package controlador;

import vista.EditorDescripcionEstructura;
import modelo.Estructura;

public class EditorDescripcionEstructuraController {
	
	
    private static EditorDescripcionEstructuraController INSTANCE = null;
    private Estructura estructura;
    private EditorDescripcionEstructura view;
    
    
    
    // Private constructor suppresses 
    private EditorDescripcionEstructuraController() {}
 
    // creador sincronizado para protegerse de posibles problemas  multi-hilo
    // otra prueba para evitar instanciacin mltiple 
    private synchronized static void createInstance() {
        if (INSTANCE == null) { 
            INSTANCE = new EditorDescripcionEstructuraController();
        }
    }
 
    public static EditorDescripcionEstructuraController getInstance() {
        createInstance();
        return INSTANCE;
    }
    
    public void inicializar(Estructura estructura, EditorDescripcionEstructura ede){
    	this.estructura = estructura;
    	this.view = ede;
    	
    	// campo
    	if(estructura.getDescripcion() != null) // mantener compatibilidad con viejas estructuras
    		view.getTextArea().setText(estructura.getDescripcion());
    	else
    		view.getTextArea().setText("");
    	
    	// titulo
    	view.setTitle("Descripcin de " +  estructura.getNombre());
    	
    }
    
    public void cambiarDescripcion(){
    	estructura.setDescripcion(view.getTextArea().getText());
    }
    
	public void cerrarVentana(){
		view.getPreviousWindow().getFrmEditorDeEstructuras().setEnabled(true);
		view.dispose();
	}
}