package controlador.undo;

import modelo.Componente;
import modelo.ComponenteCompuesta;

// TODO: Auto-generated Javadoc
/**
 * The Class AgregarComponenteCommand.
 * Encapsulacin de la operacin de agregacin de una nueva componente
 */
public class AgregarComponenteCommand extends Command{

	/** Componente en la cual se agregar una nueva componente. */
	private ComponenteCompuesta componente;
	
	/** Nueva componente creada en la operacin de ejecucin. */
	private Componente componenteCreada = null;
	
	/** Posicin que ocupa la nueva componente creada. */
	private int posicion;
	
	/* (non-Javadoc)
	 * @see controller.undo.Command#ejecutar()
	 */
	@Override
	public void ejecutar() {
		if(componenteCreada == null) // primera ejecucin
			componente.agregarComponente(posicion);
		else{ // redo
			componente.agregarComponente(componenteCreada, posicion);
		}
		
	}

	/* (non-Javadoc)
	 * @see controller.undo.Command#deshacer()
	 */
	@Override
	public void deshacer() {
		componenteCreada = componente.getComponentes().get(posicion);
		componente.eliminarComponente(posicion);
		
	}

	/**
	 * Recupera componente.
	 *
	 * @return el componente
	 */
	public ComponenteCompuesta getComponente() {
		return componente;
	}

	/**
	 * Establece componente.
	 *
	 * @param componente el nuevo componente
	 */
	public void setComponente(ComponenteCompuesta componente) {
		this.componente = componente;
	}

	/**
	 * Recupera componente creada.
	 *
	 * @return el componente creada
	 */
	public Componente getComponenteCreada() {
		return componenteCreada;
	}

	/**
	 * Establece componente creada.
	 *
	 * @param componenteCreada el nuevo componente creada
	 */
	public void setComponenteCreada(Componente componenteCreada) {
		this.componenteCreada = componenteCreada;
	}

	/**
	 * Recupera posicion.
	 *
	 * @return el posicion
	 */
	public int getPosicion() {
		return posicion;
	}

	/**
	 * Establece posicion.
	 *
	 * @param posicion el nuevo posicion
	 */
	public void setPosicion(int posicion) {
		this.posicion = posicion;
	}
	
	

}
