package controlador.undo;

import modelo.ComponenteCompuesta;

// TODO: Auto-generated Javadoc
/**
 * The Class AgregarEstructuraDerivadaCommand.
 * Comando para agregar una nueva estructura derivada
 */
public class AgregarEstructuraDerivadaCommand extends Command{

	/** Componente que contendr la estructura derivada. */
	private ComponenteCompuesta componente;
	
	/** estructura derivada. */
	private ComponenteCompuesta estructuraDerivada;
	
	/** Posicin en la componente en la cual estar insertada la estructura derivada. */
	private int posicion;
	
	/* (non-Javadoc)
	 * @see controlador.undo.Command#ejecutar()
	 */
	@Override
	public void ejecutar() {
		componente.agregarComponente(estructuraDerivada, posicion);
		
	}

	/* (non-Javadoc)
	 * @see controlador.undo.Command#deshacer()
	 */
	@Override
	public void deshacer() {
		componente.eliminarComponente(posicion);
		
	}

	/**
	 * Recupera componente.
	 *
	 * @return el componente
	 */
	public ComponenteCompuesta getComponente() {
		return componente;
	}

	/**
	 * Establece componente.
	 *
	 * @param componente el nuevo componente
	 */
	public void setComponente(ComponenteCompuesta componente) {
		this.componente = componente;
	}

	/**
	 * Recupera estructura derivada.
	 *
	 * @return el estructura derivada
	 */
	public ComponenteCompuesta getEstructuraDerivada() {
		return estructuraDerivada;
	}

	/**
	 * Establece estructura derivada.
	 *
	 * @param estructuraDerivada el nuevo estructura derivada
	 */
	public void setEstructuraDerivada(ComponenteCompuesta estructuraDerivada) {
		this.estructuraDerivada = estructuraDerivada;
	}

	/**
	 * Recupera posicion.
	 *
	 * @return el posicion
	 */
	public int getPosicion() {
		return posicion;
	}

	/**
	 * Establece posicion.
	 *
	 * @param posicion el nuevo posicion
	 */
	public void setPosicion(int posicion) {
		this.posicion = posicion;
	}
	
	

}
