package controlador.undo;

import modelo.Componente;

// TODO: Auto-generated Javadoc
/**
 * The Class DesplazarHaciaAbajoCommand.
 * Encapsulacin de la operacin desplazamiento de una componente hacia abajo
 */
public class DesplazarHaciaAbajoCommand extends Command{

	/** Componente sobre la cual se aplica el comando. */
	private Componente componente;
	
	/* (non-Javadoc)
	 * @see controller.undo.Command#ejecutar()
	 */
	@Override
	public void ejecutar() {
		componente.desplazarHaciaAbajo();
		
	}

	/* (non-Javadoc)
	 * @see controller.undo.Command#deshacer()
	 */
	@Override
	public void deshacer() {
		componente.desplazarHaciaArriba();
		
	}

	/**
	 * Recupera componente.
	 *
	 * @return el componente
	 */
	public Componente getComponente() {
		return componente;
	}

	/**
	 * Establece componente.
	 *
	 * @param componente el nuevo componente
	 */
	public void setComponente(Componente componente) {
		this.componente = componente;
	}
	
	

}
