package controlador.undo;

import java.util.ArrayList;

import modelo.Componente;
import modelo.ComponenteCompuesta;

// TODO: Auto-generated Javadoc
/**
 * The Class DesplazarHaciaIzquierdaCommand.
 * Encapsulacin de la operacin desplazamiento de una componente hacia un nivel de anidamiento inferior
 */
public class DesplazarHaciaIzquierdaCommand extends Command{

	/** Componente sobre la cual se aplica el comando. */
	private Componente componente;
	
	/* (non-Javadoc)
	 * @see controller.undo.Command#ejecutar()
	 */
	@Override
	public void ejecutar() {

		componente.desplazarHaciaIzquierda();
		
	}

	/* (non-Javadoc)
	 * @see controller.undo.Command#deshacer()
	 */
	@Override
	public void deshacer() { // desplazar hacia la izquiera la coloca debajo de su anterior parent, y desplazar hacia la derecha intenta integrarla en primer lugar en la cc superior.
		componente.desplazarHaciaDerecha();
	}

	/**
	 * Recupera componente.
	 *
	 * @return el componente
	 */
	public Componente getComponente() {
		return componente;
	}

	/**
	 * Establece componente.
	 *
	 * @param componente el nuevo componente
	 */
	public void setComponente(Componente componente) {
		this.componente = componente;
	}

	
}
