package controlador.undo;

import modelo.Componente;
import modelo.ComponenteCompuesta;

// TODO: Auto-generated Javadoc
/**
 * The Class EliminarComponenteCommand.
 * Encapsulacin de la operacin de eliminacin de una componente, y la operacin inversa de sta
 */
public class EliminarComponenteCommand extends Command{

	/** Component que contiene la componente que se va a eliminar. */
	private ComponenteCompuesta componente;
	
	/** Componente eliminada (necesario para su posible restauracin). */
	private Componente componenteEliminada = null;
	
	/** Posicin que ocupa la componente a eliminar en la componente compleja */
	private int posicion;
	
	/* (non-Javadoc)
	 * @see controller.undo.Command#ejecutar()
	 */
	@Override
	public void ejecutar() {
		componenteEliminada = componente.getComponentes().get(posicion);
		componente.eliminarComponente(posicion);
		
	}

	/* (non-Javadoc)
	 * @see controller.undo.Command#deshacer()
	 */
	@Override
	public void deshacer() {
		componente.agregarComponente(componenteEliminada, posicion);
	}

	/**
	 * Recupera componente.
	 *
	 * @return el componente
	 */
	public ComponenteCompuesta getComponente() {
		return componente;
	}

	/**
	 * Establece componente.
	 *
	 * @param componente el nuevo componente
	 */
	public void setComponente(ComponenteCompuesta componente) {
		this.componente = componente;
	}

	/**
	 * Recupera componente eliminada.
	 *
	 * @return el componente eliminada
	 */
	public Componente getComponenteEliminada() {
		return componenteEliminada;
	}

	/**
	 * Establece componente eliminada.
	 *
	 * @param componenteEliminada el nuevo componente eliminada
	 */
	public void setComponenteEliminada(Componente componenteEliminada) {
		this.componenteEliminada = componenteEliminada;
	}

	/**
	 * Recupera posicion.
	 *
	 * @return el posicion
	 */
	public int getPosicion() {
		return posicion;
	}

	/**
	 * Establece posicion.
	 *
	 * @param posicion el nuevo posicion
	 */
	public void setPosicion(int posicion) {
		this.posicion = posicion;
	}
	
	

}
