package controlador.undo;

import modelo.ComponenteCompuesta;

// TODO: Auto-generated Javadoc
/**
 * The Class ModificarIteracionCommand.
 * Encapsulacin de la operacin de modificacin del tipo de iteracion de una componente, y de su operacin opuesta.
 */
public class ModificarIteracionCommand extends Command{

	/** Componente sobre la cual se ejecuta el comando. */
	ComponenteCompuesta componente;
	
	/* (non-Javadoc)
	 * @see controller.undo.Command#ejecutar()
	 */
	@Override
	public void ejecutar() {
		componente.modificarIteracion();
		
	}

	/* (non-Javadoc)
	 * @see controller.undo.Command#deshacer()
	 */
	@Override
	public void deshacer() {
		// Tras realizar dos modificaciones de iteracin, se vuelve a la posicin original
		componente.modificarIteracion();
		componente.modificarIteracion();	
	}

	/**
	 * Recupera componente.
	 *
	 * @return el componente
	 */
	public ComponenteCompuesta getComponente() {
		return componente;
	}

	/**
	 * Establece componente.
	 *
	 * @param componente el nuevo componente
	 */
	public void setComponente(ComponenteCompuesta componente) {
		this.componente = componente;
	}

	
	
}
