package controlador.undo;

import modelo.Componente;

// TODO: Auto-generated Javadoc
/**
 * The Class ModificarNombreComponenteCommand.
 * Encapsulacin de la operacin de modificacin del valor de una componente, y la operacin del valor antiguo de sta.
 */
public class ModificarNombreComponenteCommand extends Command{

	/** Componente sobre la que se ejecuta el comando. */
	private Componente componente;
	
	/** Nuevo valor de la componente. */
	private String nuevoValor;
	
	/** Antiguo valor de la componente, necesario para realizar la operacin de deshacer. */
	private String antiguoValor;
	
	/* (non-Javadoc)
	 * @see controller.undo.Command#ejecutar()
	 */
	@Override
	public
	void ejecutar() {
		antiguoValor = componente.getNombre();
		componente.setNombre(nuevoValor);
	}

	/* (non-Javadoc)
	 * @see controller.undo.Command#deshacer()
	 */
	@Override
	public
	void deshacer() {
		componente.setNombre(antiguoValor);	
	}

	/**
	 * Recupera componente.
	 *
	 * @return el componente
	 */
	public Componente getComponente() {
		return componente;
	}

	/**
	 * Establece componente.
	 *
	 * @param componente el nuevo componente
	 */
	public void setComponente(Componente componente) {
		this.componente = componente;
	}

	/**
	 * Recupera nuevo valor.
	 *
	 * @return el nuevo valor
	 */
	public String getNuevoValor() {
		return nuevoValor;
	}

	/**
	 * Establece nuevo valor.
	 *
	 * @param nuevoValor el nuevo nuevo valor
	 */
	public void setNuevoValor(String nuevoValor) {
		this.nuevoValor = nuevoValor;
	}

	/**
	 * Recupera antiguo valor.
	 *
	 * @return el antiguo valor
	 */
	public String getAntiguoValor() {
		return antiguoValor;
	}

	/**
	 * Establece antiguo valor.
	 *
	 * @param antiguoValor el nuevo antiguo valor
	 */
	public void setAntiguoValor(String antiguoValor) {
		this.antiguoValor = antiguoValor;
	}

	
	
}
