package controlador.undo;

import modelo.PropiedadLinea;

// TODO: Auto-generated Javadoc
/**
 * The Class ModificarNombrePropiedadCommand.
 * Encapsulacin de la operacin de modificacin del valor de una propiedad, y su restauracin.
 */
public class ModificarNombrePropiedadCommand extends Command{

	/** Propiedad sobre la cual se ejecuta el comando. */
	private PropiedadLinea propiedad;
	
	/** Nuevo valor que toma la propiedad. */
	private String nuevoValor;
	
	/** Valor antigo de la propiedad, necesario para la operacin de deshacer. */
	private String antiguoValor;
	
	/* (non-Javadoc)
	 * @see controller.undo.Command#ejecutar()
	 */
	@Override
	public void ejecutar() {
		antiguoValor = propiedad.getValor();
		propiedad.setValor(nuevoValor);
		
	}

	/* (non-Javadoc)
	 * @see controller.undo.Command#deshacer()
	 */
	@Override
	public void deshacer() {
		propiedad.setValor(antiguoValor);
		
	}

	/**
	 * Recupera propiedad.
	 *
	 * @return el propiedad
	 */
	public PropiedadLinea getPropiedad() {
		return propiedad;
	}

	/**
	 * Establece propiedad.
	 *
	 * @param propiedad el nuevo propiedad
	 */
	public void setPropiedad(PropiedadLinea propiedad) {
		this.propiedad = propiedad;
	}

	/**
	 * Recupera nuevo valor.
	 *
	 * @return el nuevo valor
	 */
	public String getNuevoValor() {
		return nuevoValor;
	}

	/**
	 * Establece nuevo valor.
	 *
	 * @param nuevoValor el nuevo nuevo valor
	 */
	public void setNuevoValor(String nuevoValor) {
		this.nuevoValor = nuevoValor;
	}

	/**
	 * Recupera antiguo valor.
	 *
	 * @return el antiguo valor
	 */
	public String getAntiguoValor() {
		return antiguoValor;
	}

	/**
	 * Establece antiguo valor.
	 *
	 * @param antiguoValor el nuevo antiguo valor
	 */
	public void setAntiguoValor(String antiguoValor) {
		this.antiguoValor = antiguoValor;
	}
	

}
