package datos;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;
import java.util.ArrayList;

import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.SealedObject;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.DESKeySpec;

import modelo.Grupo;
import modelo.Usuario;

public class GruposDAO {
	private static GruposDAO INSTANCE = null;
	private static final String password = "kepa.adam@gmail.com";

	// Private constructor suppresses 
	private GruposDAO() {}

	// creador sincronizado para protegerse de posibles problemas  multi-hilo
	// otra prueba para evitar instanciacin mltiple 
	private synchronized static void createInstance() {
		if (INSTANCE == null) { 
			INSTANCE = new GruposDAO();
		}
	}

	public static GruposDAO getInstance() {
		createInstance();
		return INSTANCE;
	}

	public void guardarGrupos(ArrayList<Grupo> grupos) throws Exception{
		// Create Key
		byte key[] = password.getBytes();
		DESKeySpec desKeySpec = new DESKeySpec(key);
		SecretKeyFactory keyFactory = SecretKeyFactory.getInstance("DES");
		SecretKey secretKey = keyFactory.generateSecret(desKeySpec);

		// Create Cipher
		Cipher desCipher = Cipher.getInstance("DES/ECB/PKCS5Padding");
		desCipher.init(Cipher.ENCRYPT_MODE, secretKey);

		// Seal object

		SealedObject sealedObject = new SealedObject(grupos, desCipher);

		// Serialize to a file
		String direccion = System.getProperty("user.dir")+"\\data\\";
		String file = "grp.dat";
		File path = new File(direccion);
		if(!path.exists())
			path.mkdirs();

		File fichero = new File(direccion + file);

		ObjectOutput out = new ObjectOutputStream(new FileOutputStream(fichero));
		out.writeObject(sealedObject);
		out.close();

	}

	public ArrayList<Grupo> cargarGrupos() throws Exception{
		// Create Key
		byte key[] = password.getBytes();
		DESKeySpec desKeySpec = new DESKeySpec(key);
		SecretKeyFactory keyFactory = SecretKeyFactory.getInstance("DES");
		SecretKey secretKey = keyFactory.generateSecret(desKeySpec);

		// Deserialize from a file
		String direccion = System.getProperty("user.dir")+"\\data\\grp.dat";
		File file = new File(direccion);
		if(file.exists()){
			ObjectInputStream in = new ObjectInputStream(new FileInputStream(file));

			// Deserialize the object
			SealedObject sealedObject = (SealedObject) in.readObject();
			in.close();

			// Unseal object
			ArrayList<Grupo> grupos = (ArrayList<Grupo>)sealedObject.getObject(secretKey);

			return grupos;
		}
		else{
			return new ArrayList<Grupo>();
		}
	}



}