package modelo;

import java.util.UUID;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlID;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * Las caractersiticas de acabado definen aspectos relacionados con cmo se muestran las estructuas en la tabla del editor.
 * Cada una tiene un nombre y un valor.
 */
@XmlAccessorType(XmlAccessType.NONE)
@XmlRootElement(name="Acabado")
public class Acabado implements Cloneable{
	
	/** Identificador */
	@XmlID
	private String id = UUID.randomUUID().toString();
	
	/** Nombre de la caractersitica de acabado */
	@XmlAttribute(name="Nombre")
	private String nombre;
	
	/** Valor de la caractersitica de acabado */
	@XmlAttribute(name="Valor")
	private int valor;
	
	/**
	 * Recupera id.
	 *
	 * @return el id
	 */
	public String getId() {
		return id;
	}
	
	/**
	 * Establece id.
	 *
	 * @param id el nuevo id
	 */
	public void setId(String id) {
		this.id = id;
	}
	
	/**
	 * Recupera nombre.
	 *
	 * @return el nombre
	 */
	public String getNombre() {
		return nombre;
	}
	
	/**
	 * Establece nombre.
	 *
	 * @param nombre el nuevo nombre
	 */
	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	/**
	 * Recupera valor.
	 *
	 * @return el valor
	 */
	public int getValor() {
		return valor;
	}
	
	/**
	 * Establece valor.
	 *
	 * @param valor el nuevo valor
	 */
	public void setValor(int valor) {
		this.valor = valor;
	}
	
	/**
	 * Inicializa un objeto de tipo acabado.
	 *
	 * @param nombre el nombre de la caractersitica de acabado
	 * @param valor el valor
	 */
	public Acabado(String nombre, int valor) {
		super();
		this.nombre = nombre;
		this.valor = valor;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#clone()
	 */
	@Override
	public Object clone(){
		Acabado clonado = new Acabado(this.nombre, this.valor);
		clonado.setId(id);
		return clonado;
	}
	
	/**
	 * Inicializa un objeto de tipo acabado.
	 */
	public Acabado() {
		super();
	}
	
	
	
}
