package modelo;

import java.awt.Color;
import java.util.UUID;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlID;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.adapters.XmlAdapter;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;

// TODO: Auto-generated Javadoc
/**
 * Las caractersiticas de aspecto definen cmo se muestran las estructuas en la tabla del editor.
 * Por ejemplo, el tipo de letra con el cual se muestran algunas componentes.
 */
@XmlAccessorType(XmlAccessType.NONE)
@XmlRootElement(name="Aspecto")
public class Aspecto implements Cloneable{
	
	/** Identificador. */
	@XmlID
	private String id = UUID.randomUUID().toString();
	
	/** Nombre de la caractersitica de aspecto. */
	@XmlAttribute(name="Nombre")
	private String nombre;
	
	/** Color con el cual se muestra el tipo de componente en la tabla del editor. */
	@XmlAttribute(name="Color")
	private int color;
	
	/** Fuente con la cual se muestra el tipo de componente en la tabla del editor. */
	@XmlAttribute(name="Fuente")
	private String fuente;
	
	/** Tamao de letra con el cual se muestra el tipo de componente en la tabla del editor.. */
	@XmlAttribute(name="Tamanyo")
	private int tamanyo;




	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	/**
	 * Recupera nombre.
	 *
	 * @return el nombre
	 */
	public String getNombre() {
		return nombre;
	}
	
	/**
	 * Establece nombre.
	 *
	 * @param nombre el nuevo nombre
	 */
	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	/**
	 * Recupera color.
	 *
	 * @return el color
	 */
	public int getColor() {
		return color;
	}
	
	/**
	 * Establece color.
	 *
	 * @param color el nuevo color
	 */
	public void setColor(int color) {
		this.color = color;
	}
	

	
	public String getFuente() {
		return fuente;
	}

	public void setFuente(String fuente) {
		this.fuente = fuente;
	}

	/**
	 * Recupera tamanyo.
	 *
	 * @return el tamanyo
	 */
	public int getTamanyo() {
		return tamanyo;
	}
	
	/**
	 * Establece tamanyo.
	 *
	 * @param tamanyo el nuevo tamanyo
	 */
	public void setTamanyo(int tamanyo) {
		this.tamanyo = tamanyo;
	}


	/**
	 * Inicializa un objeto de tipo aspecto.
	 *
	 * @param nombre the nombre
	 */
	public Aspecto(String nombre) {
		super();
		this.nombre = nombre;
		this.color = (Color.BLACK).getRGB();
		this.fuente = "Arial";
		this.tamanyo = 14;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#clone()
	 */
	@Override
	public Object clone() {
		Aspecto clonado = new Aspecto(this.nombre);
		clonado.setColor(getColor());
		clonado.setFuente(getFuente());
		clonado.setTamanyo(getTamanyo());
		clonado.setId(getId());
		return clonado;
	}
	
	/**
	 * Inicializa un objeto de tipo aspecto.
	 */
	public Aspecto() {
		super();
	}
}


