package modelo;

import java.util.UUID;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;

// TODO: Auto-generated Javadoc
/**
 * Representa una lnea de la columna "Componente" de la tabla del editor de estructuras y propiedades.
 */
@XmlAccessorType(XmlAccessType.NONE)
public class ComponenteLinea extends Linea implements Cloneable{
	
	
	/** Contenido de la lnea (Nombre del campo). */
//	@XmlAttribute(name = "Contenido")
//	private String contenido;
	
	/** Contiene el smbolo inicial de una agregacin "<". */
	@XmlAttribute(name = "AgregacionInicial")
	private Boolean agrInicial;
	
	/** Contiene el smbolo intermedio de una agregacin "|". */
	@XmlAttribute(name = "AgregacionIntermedio")
	private Boolean agrIntermedio;
	
	/** Contiene el smbolo final de una agregacin ">". */
	@XmlAttribute(name = "AgregacionFinal")
	private Boolean agrFinal;
	
	/** Contiene el smbolo inicial de una especializacin "[". */
	@XmlAttribute(name = "EspecializacionInicial")
	private Boolean espInicial;
	
	/** Contiene el smbolo intermedio de una especializacin "|". */
	@XmlAttribute(name = "EspecializacionInteredio")
	private Boolean espIntermedio;
	
	/** Contiene el smbolo final de una especializacin ">". */
	@XmlAttribute(name = "EspecializacionFinal")
	private Boolean espFinal;
	
	/** Contiene el smbolo inicial de una iteracin "{". */
	@XmlAttribute(name = "IteracionInicial")
	private Boolean iterInicial;
	
	/** Contiene el smbolo final de una iteracin "}". */
	@XmlAttribute(name = "IteracionFinal")
	private Boolean iterFinal;
	
	/** Contiene el smbolo igual "=". */
	@XmlAttribute(name = "IgualFinal")
	private Boolean igualFinal;
	
	/** Contiene el smbolo inicial de opcionalidad "[". */
	@XmlAttribute(name = "OpcionalInicial")
	private Boolean opcInicial;
	
	/** Contiene el smbolo final de opcionalidad "]". */
	@XmlAttribute(name = "OpcionalFinal")
	private Boolean opcFinal;
	
	/** La lnea seleccionada es editable. */
	@XmlAttribute(name = "Editable")
	private Boolean editable;
	
	/** Componente a la cual pertenece la lnea. */
	private Componente componente;
	

	
	/**
	 * Inicializa un objeto de tipo componente linea.
	 *
	 * @param componente la componente a la cual pertenece la lnea
	 * @param anidamiento el nivel de anidamiento de la lnea
	 */
	public ComponenteLinea(Componente componente, int anidamiento) {
		this.clear();
		this.componente = componente;
		setAnidamiento(anidamiento);
		setContenido("");
	}

	
	

	/**
	 * Inicializa un objeto de tipo componente linea.
	 */
	public ComponenteLinea() {
		super();
	}




	/**
	 * Reestablece (desactiva) todas las propiedades.
	 */
	public void clear() {
		// Resetea todas las propieades de la lnea
		this.agrInicial = false;
		this.agrIntermedio = false;
		this.agrFinal = false;
		this.espInicial = false;
		this.espIntermedio = false;
		this.espFinal = false;
		this.iterInicial = false;
		this.iterFinal = false;
		this.igualFinal = false;
		this.editable = true;	
		this.opcFinal = false;
		this.opcInicial = false;
	}

	/**
	 * Recupera agr inicial.
	 *
	 * @return el agr inicial
	 */
	public Boolean getAgrInicial() {
		return agrInicial;
	}


	/**
	 * Establece agr inicial.
	 *
	 * @param agrInicial el nuevo agr inicial
	 */
	public void setAgrInicial(Boolean agrInicial) {
		this.agrInicial = agrInicial;
	}


	/**
	 * Recupera agr intermedio.
	 *
	 * @return el agr intermedio
	 */
	public Boolean getAgrIntermedio() {
		return agrIntermedio;
	}


	/**
	 * Establece agr intermedio.
	 *
	 * @param agrIntermedio el nuevo agr intermedio
	 */
	public void setAgrIntermedio(Boolean agrIntermedio) {
		this.agrIntermedio = agrIntermedio;
	}


	/**
	 * Recupera agr final.
	 *
	 * @return el agr final
	 */
	public Boolean getAgrFinal() {
		return agrFinal;
	}


	/**
	 * Establece agr final.
	 *
	 * @param agrFinal el nuevo agr final
	 */
	public void setAgrFinal(Boolean agrFinal) {
		this.agrFinal = agrFinal;
	}


	/**
	 * Recupera esp inicial.
	 *
	 * @return el esp inicial
	 */
	public Boolean getEspInicial() {
		return espInicial;
	}


	/**
	 * Establece esp inicial.
	 *
	 * @param espInicial el nuevo esp inicial
	 */
	public void setEspInicial(Boolean espInicial) {
		this.espInicial = espInicial;
	}


	/**
	 * Recupera esp intermedio.
	 *
	 * @return el esp intermedio
	 */
	public Boolean getEspIntermedio() {
		return espIntermedio;
	}


	/**
	 * Establece esp intermedio.
	 *
	 * @param espIntermedio el nuevo esp intermedio
	 */
	public void setEspIntermedio(Boolean espIntermedio) {
		this.espIntermedio = espIntermedio;
	}


	/**
	 * Recupera esp final.
	 *
	 * @return el esp final
	 */
	public Boolean getEspFinal() {
		return espFinal;
	}


	/**
	 * Establece esp final.
	 *
	 * @param espFinal el nuevo esp final
	 */
	public void setEspFinal(Boolean espFinal) {
		this.espFinal = espFinal;
	}


	/**
	 * Recupera iter inicial.
	 *
	 * @return el iter inicial
	 */
	public Boolean getIterInicial() {
		return iterInicial;
	}


	/**
	 * Establece iter inicial.
	 *
	 * @param iterInicial el nuevo iter inicial
	 */
	public void setIterInicial(Boolean iterInicial) {
		this.iterInicial = iterInicial;
	}


	/**
	 * Recupera iter final.
	 *
	 * @return el iter final
	 */
	public Boolean getIterFinal() {
		return iterFinal;
	}


	/**
	 * Establece iter final.
	 *
	 * @param iterFinal el nuevo iter final
	 */
	public void setIterFinal(Boolean iterFinal) {
		this.iterFinal = iterFinal;
	}


	/**
	 * Recupera igual final.
	 *
	 * @return el igual final
	 */
	public Boolean getIgualFinal() {
		return igualFinal;
	}


	/**
	 * Establece igual final.
	 *
	 * @param igualFinal el nuevo igual final
	 */
	public void setIgualFinal(Boolean igualFinal) {
		this.igualFinal = igualFinal;
	}


	/**
	 * Recupera editable.
	 *
	 * @return el editable
	 */
	public Boolean getEditable() {
		return editable;
	}


	/**
	 * Establece editable.
	 *
	 * @param editable el nuevo editable
	 */
	public void setEditable(Boolean editable) {
		this.editable = editable;
	}


	/**
	 * Recupera componente.
	 *
	 * @return el componente
	 */
	public Componente getComponente() {
		return componente;
	}


	/**
	 * Establece componente.
	 *
	 * @param componente el nuevo componente
	 */
	public void setComponente(Componente componente) {
		this.componente = componente;
	}

	
	/**
	 * Recupera opc inicial.
	 *
	 * @return el opc inicial
	 */
	public Boolean getOpcInicial() {
		return opcInicial;
	}


	/**
	 * Establece opc inicial.
	 *
	 * @param opcInicial el nuevo opc inicial
	 */
	public void setOpcInicial(Boolean opcInicial) {
		this.opcInicial = opcInicial;
	}


	/**
	 * Recupera opc final.
	 *
	 * @return el opc final
	 */
	public Boolean getOpcFinal() {
		return opcFinal;
	}


	/**
	 * Establece opc final.
	 *
	 * @param opcFinal el nuevo opc final
	 */
	public void setOpcFinal(Boolean opcFinal) {
		this.opcFinal = opcFinal;
	}


	/* (non-Javadoc)
	 * Creacin del string a partir de las propiedades de una lnea
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		for(int i = 0; i<getAnidamiento(); i++)
			sb.append("     ");
		if(opcInicial) sb.append(" [ ");
		if(iterInicial) sb.append(" { ");
		if(agrInicial) sb.append(" <" );
		if(espInicial) sb.append(" [ ");
		if(getContenido().length()>0) sb.append(" " + getContenido() + " ");
		if(agrFinal) sb.append(" >" );
		if(espFinal) sb.append(" ] ");
		if(iterFinal) sb.append(" } ");
		if(igualFinal) sb.append(" = ");
		if(opcFinal) sb.append(" ] ");
		if(agrIntermedio) sb.append(" + ");
		if(espIntermedio) sb.append(" | ");
		
		
		return sb.toString();
	}




	/* (non-Javadoc)
	 * @see java.lang.Object#clone()
	 */
	@Override
	public Object clone() throws CloneNotSupportedException {
		
		ComponenteLinea ncl = new ComponenteLinea(getComponente(), getAnidamiento());
		ncl.setAgrFinal(agrFinal);
		ncl.setAgrInicial(agrInicial);
		ncl.setAgrIntermedio(agrIntermedio);
		ncl.setContenido(getContenido());
		ncl.setEditable(editable);
		ncl.setEspFinal(espFinal);
		ncl.setEspInicial(espInicial);
		ncl.setEspIntermedio(espIntermedio);
		ncl.setIgualFinal(igualFinal);
		ncl.setEspInicial(espInicial);
		ncl.setEspIntermedio(espIntermedio);
		ncl.setIgualFinal(igualFinal);
		ncl.setIterFinal(iterFinal);
		ncl.setIterInicial(iterInicial);
		ncl.setOpcFinal(opcFinal);
		ncl.setOpcInicial(opcInicial);
		ncl.setId(getId());
		return ncl;
	}
	
	
}
