package modelo;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.UUID;

public class Esquema implements Serializable, Comparable{

	private String id = UUID.randomUUID().toString();
	private String nombre;
	private String descripcion;
	
	private String idAutorCreacion;
	private String idAutorModificacion;
	
	private Calendar fechaCreacion;
	private Calendar fechaModificacion;
	
	private String idPresentacion;
	private ArrayList<String> idEstructuras;
	
	private String idArea;
	
	
	
	
	public Esquema() {
		super();
	}
	
	public Esquema(String nombre, String idArea) {
		super();
		this.nombre = nombre;
		idEstructuras = new ArrayList<String>();
		this.idArea = idArea;
		
		fechaCreacion = Calendar.getInstance();
		fechaModificacion = Calendar.getInstance();
	}
	
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	public String getNombre() {
		return nombre;
	}
	public void setNombre(String nombre) {
		this.nombre = nombre;
	}
	public String getDescripcion() {
		return descripcion;
	}
	public void setDescripcion(String descripcion) {
		this.descripcion = descripcion;
	}
	public String getIdAutorCreacion() {
		return idAutorCreacion;
	}
	public void setIdAutorCreacion(String idAutorCreacion) {
		this.idAutorCreacion = idAutorCreacion;
	}
	public String getIdAutorModificacion() {
		return idAutorModificacion;
	}
	public void setIdAutorModificacion(String idAutorModificacion) {
		this.idAutorModificacion = idAutorModificacion;
	}
	public Calendar getFechaCreacion() {
		return fechaCreacion;
	}
	public void setFechaCreacion(Calendar fechaCreacion) {
		this.fechaCreacion = fechaCreacion;
	}
	public Calendar getFechaModificacion() {
		return fechaModificacion;
	}
	public void setFechaModificacion(Calendar fechaModificacion) {
		this.fechaModificacion = fechaModificacion;
	}
	public String getIdPresentacion() {
		return idPresentacion;
	}
	public void setIdPresentacion(String idPresentacion) {
		this.idPresentacion = idPresentacion;
	}
	public ArrayList<String> getIdEstructuras() {
		return idEstructuras;
	}
	public void setIdEstructuras(ArrayList<String> idEstructuras) {
		this.idEstructuras = idEstructuras;
	}

	public String getIdArea() {
		return idArea;
	}

	public void setIdArea(String idArea) {
		this.idArea = idArea;
	}
	
	
	@Override
	public int compareTo(Object arg0) {
		Esquema esquema = (Esquema) arg0;
		return this.getNombre().compareTo( esquema.getNombre());
	}
	
}
