package modelo;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.UUID;

public class Grupo implements Cloneable, Serializable, Comparable{

	private String ID = UUID.randomUUID().toString();
	private String Nombre;
	private String Descripcion;
	private ArrayList<String> idsUsuarios;
	// Acordarse de no serializar esta parte
	private ArrayList<Usuario> usuarios;
	
	public Grupo() {
		super();
		usuarios = new ArrayList<Usuario>();
		idsUsuarios = new ArrayList<String>();
	}

	public String getID() {
		return ID;
	}

	public void setID(String iD) {
		ID = iD;
	}

	public String getNombre() {
		return Nombre;
	}

	public void setNombre(String nombre) {
		Nombre = nombre;
	}

	public String getDescripcion() {
		return Descripcion;
	}

	public void setDescripcion(String descripcion) {
		Descripcion = descripcion;
	}

	public ArrayList<String> getIdsUsuarios() {
		return idsUsuarios;
	}

	public void setIdsUsuarios(ArrayList<String> idsUsuarios) {
		this.idsUsuarios = idsUsuarios;
	}

	public ArrayList<Usuario> getUsuarios() {
		return usuarios;
	}

	public void setUsuarios(ArrayList<Usuario> usuarios) {
		this.usuarios = usuarios;
	}

	@Override
	protected Object clone() {
		Grupo nuevo = new Grupo();
		nuevo.setDescripcion(this.getDescripcion());
		nuevo.setID(this.getID());
		nuevo.setIdsUsuarios(this.getIdsUsuarios());
		nuevo.setNombre(this.getNombre());
		// FALTA CLONAR USUARIOS
		return nuevo;
	}
	
	@Override
	public int compareTo(Object arg0) {
		Grupo grupo = (Grupo) arg0;
		return this.getNombre().compareTo( grupo.getNombre());
	}
	
}
