package modelo;

import java.util.UUID;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlID;
import javax.xml.bind.annotation.XmlSeeAlso;

// TODO: Auto-generated Javadoc
/**
 * Clase abstracta que contiene mtodos y atributos comunes a todas las lneas que se pueden mostrar en la ventana
 * principal del editor.
 */
@XmlAccessorType(XmlAccessType.NONE)
@XmlSeeAlso({ComponenteLinea.class, SelectorLinea.class})
public abstract class Linea {

	/** id. */
	@XmlID
	private String id = UUID.randomUUID().toString();
	
	/** contenido. */
	@XmlAttribute(name="Contenido")
	private String contenido;
	
	/** Nivel de anidamiento de la lnea. */
	@XmlAttribute(name = "Anidamiento")
	private int anidamiento;
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public abstract String toString();

	/**
	 * Recupera contenido.
	 *
	 * @return el contenido
	 */
	public String getContenido() {
		return contenido;
	}

	/**
	 * Establece contenido.
	 *
	 * @param contenido el nuevo contenido
	 */
	public void setContenido(String contenido) {
		this.contenido = contenido;
	}

	/**
	 * Recupera id.
	 *
	 * @return el id
	 */
	public String getId() {
		return id;
	}

	/**
	 * Establece id.
	 *
	 * @param id el nuevo id
	 */
	public void setId(String id) {
		this.id = id;
	}

	/**
	 * Recupera anidamiento.
	 *
	 * @return el anidamiento
	 */
	public int getAnidamiento() {
		return anidamiento;
	}

	/**
	 * Establece anidamiento.
	 *
	 * @param anidamiento el nuevo anidamiento
	 */
	public void setAnidamiento(int anidamiento) {
		this.anidamiento = anidamiento;
	}
	
	
	
}
