package modelo;

import java.util.UUID;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlID;
import javax.xml.bind.annotation.XmlRootElement;

// TODO: Auto-generated Javadoc
/**
 * La clase propiedad define 
 */
@XmlAccessorType(XmlAccessType.NONE)
@XmlRootElement(name="Propiedad")
public class Propiedad implements Cloneable {

	/** Identificador. */
	@XmlID
	private String id = UUID.randomUUID().toString();
	
	/** Constante DEBUG. */
	private static final boolean DEBUG = true;
	
	/** Nombre de la propiedad. */
	@XmlAttribute(name="Nombre")
	private String nombre;
	
	/** Alias. */
	@XmlAttribute(name="Alias")
	private String alias;
	
	/** Es visible?. */
	@XmlAttribute(name="Visible")
	private boolean visible;
	
	/** Presentacin asociada. */
	private Presentacion presentacion;
	
	/** Tipo de datos. */
	@XmlElement(name="TipoDatos")
	private TipoDatos tipoDatos;
	
	/**
	 * Inicializa un objeto de tipo propiedad.
	 */
	public Propiedad() {
		super();
		// TODO Auto-generated constructor stub
	}

	
	
	/**
	 * Inicializa un objeto de tipo propiedad.
	 *
	 * @param nombre the nombre
	 * @param presentacion the presentacion
	 * @param visible the visible
	 */
	public Propiedad(String nombre, Presentacion presentacion, boolean visible) {
		super();
		
		
		this.nombre = nombre;
		this.alias = nombre;
		this.presentacion = presentacion;
		this.visible = visible;
	}
	
	/**
	 * Inicializa un objeto de tipo propiedad.
	 *
	 * @param nombre the nombre
	 * @param presentacion the presentacion
	 * @param visible the visible
	 * @param tipoDatos the tipo datos
	 */
	public Propiedad(String nombre, Presentacion presentacion, boolean visible, TipoDatos tipoDatos) {
		super();
		
		
		this.nombre = nombre;
		this.alias = nombre;
		this.presentacion = presentacion;
		this.visible = visible;
		this.tipoDatos = tipoDatos;
	}

	/**
	 * Recupera nombre.
	 *
	 * @return el nombre
	 */
	public String getNombre() {
		return nombre;
	}

	/**
	 * Establece nombre.
	 *
	 * @param nombre el nuevo nombre
	 */
	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	/**
	 * Recupera visible.
	 *
	 * @return el visible
	 */
	public Boolean getVisible() {
		return visible;
	}

	/**
	 * Establece visible.
	 *
	 * @param visible el nuevo visible
	 */
	public void setVisible(Boolean visible) {
		this.visible = visible;
	}

	/**
	 * Recupera presentacion.
	 *
	 * @return el presentacion
	 */
	public Presentacion getPresentacion() {
		return presentacion;
	}

	/**
	 * Establece presentacion.
	 *
	 * @param presentacion el nuevo presentacion
	 */
	public void setPresentacion(Presentacion presentacion) {
		this.presentacion = presentacion;
	}



	/**
	 * Recupera id.
	 *
	 * @return el id
	 */
	public String getId() {
		return id;
	}



	/**
	 * Establece id.
	 *
	 * @param id el nuevo id
	 */
	public void setId(String id) {
		this.id = id;
	}



	/**
	 * Recupera alias.
	 *
	 * @return el alias
	 */
	public String getAlias() {
		return alias;
	}



	/**
	 * Establece alias.
	 *
	 * @param alias el nuevo alias
	 */
	public void setAlias(String alias) {
		this.alias = alias;
	}



	/**
	 * Recupera tipo datos.
	 *
	 * @return el tipo datos
	 */
	public TipoDatos getTipoDatos() {
		return tipoDatos;
	}



	/**
	 * Establece tipo datos.
	 *
	 * @param tipoDatos el nuevo tipo datos
	 */
	public void setTipoDatos(TipoDatos tipoDatos) {
		this.tipoDatos = tipoDatos;
	}



	/**
	 * Establece visible.
	 *
	 * @param visible el nuevo visible
	 */
	public void setVisible(boolean visible) {
		this.visible = visible;
	}



	/* (non-Javadoc)
	 * @see java.lang.Object#clone()
	 */
	@Override
	public Object clone() {
		Propiedad clonada = new Propiedad(this.nombre, this.presentacion, this.visible, (TipoDatos) this.tipoDatos.clone());
		clonada.setAlias(this.getAlias());
		clonada.setId(this.getId());
		return clonada;
	}
	
	
	
}
