package modelo;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;

// TODO: Auto-generated Javadoc
/**
 * PropiedadLinea contiene los valores concretos de una Propiedad, asociados a una componente.
 */
@XmlAccessorType(XmlAccessType.NONE)
public class PropiedadLinea implements Cloneable{
	


	/** Nombre la propiedad (comn con el objeto de tipo Propiedad) */
	@XmlAttribute(name="Nombre")
	private String nombre;
	
	/** Valor de la propiedad. */
	@XmlAttribute(name="Valor")
	private String valor;

	/** Componente asociada */
	private Componente componente;
	
	
	/**
	 * Inicializa un objeto de tipo propiedad linea.
	 */
	public PropiedadLinea() {
	}


	/**
	 * Inicializa un objeto de tipo propiedad linea.
	 *
	 * @param nombre the nombre
	 * @param componente the componente
	 */
	public PropiedadLinea(String nombre, Componente componente) {
		super();
		this.nombre = nombre;
		this.componente = componente;
		this.valor = "";
	}

	/**
	 * Inicializa un objeto de tipo propiedad linea.
	 *
	 * @param nombre the nombre
	 */
	public PropiedadLinea(String nombre) {
		super();
		this.nombre = nombre;
		this.valor = "";
	}


	/**
	 * Recupera valor.
	 *
	 * @return el valor
	 */
	public String getValor() {
		return valor;
	}


	/**
	 * Establece valor.
	 *
	 * @param valor el nuevo valor
	 */
	public void setValor(String valor) {
		this.valor = valor;
	}



	/**
	 * Recupera nombre.
	 *
	 * @return el nombre
	 */
	public String getNombre() {
		return nombre;
	}


	/**
	 * Establece nombre.
	 *
	 * @param nombre el nuevo nombre
	 */
	public void setNombre(String nombre) {
		this.nombre = nombre;
	}




	/**
	 * Recupera componente.
	 *
	 * @return el componente
	 */
	public Componente getComponente() {
		return componente;
	}


	/**
	 * Establece componente.
	 *
	 * @param componente el nuevo componente
	 */
	public void setComponente(Componente componente) {
		this.componente = componente;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#clone()
	 */
	@Override
	public Object clone() {
		PropiedadLinea npl = new PropiedadLinea();
		npl.setValor(valor);
		npl.setNombre(nombre);
		npl.setComponente(componente);
		return npl;
	}

	
}
