package modelo;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.UUID;

import utils.ManagerGrupos;

public class Usuario implements java.io.Serializable{

	public static final int TIPO_NORMAL = 0;
	public static final int TIPO_ADMINISTRADOR = 1;
	
	private String id = UUID.randomUUID().toString();
	private String nombreReal;
	private String nombreUsuario;
	private String password;
	private String correoElectronico;
	private int tipo;
	
	public Usuario() {
		tipo = TIPO_NORMAL;
	}

	public String getNombreReal() {
		return nombreReal;
	}

	public void setNombreReal(String nombreReal) {
		this.nombreReal = nombreReal;
	}

	public String getNombreUsuario() {
		return nombreUsuario;
	}

	public void setNombreUsuario(String nombreUsuario) {
		this.nombreUsuario = nombreUsuario;
		generarContrasenya();
	}

	private void generarContrasenya() {
		Calendar calendar = Calendar.getInstance();
		int anyo = calendar.get(Calendar.YEAR);
		this.password = this.nombreUsuario+"."+"anyo";
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	public String getCorreoElectronico() {
		return correoElectronico;
	}

	public void setCorreoElectronico(String correoElectronico) {
		this.correoElectronico = correoElectronico;
	}

	public int getTipo() {
		return tipo;
	}

	public void setTipo(int tipo) {
		this.tipo = tipo;
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}
	
	public ArrayList<Grupo> obtenerGrupos(){
		
		ManagerGrupos mg = ManagerGrupos.getInstance();
		ArrayList<Grupo> grupos = new ArrayList<Grupo>();
		
		for(String nombreGrupo: mg.listarGrupos()){
			
			// Comprobar si el usuario est en el grupo
			
			Grupo g = mg.obtenerGrupoPorNombre(nombreGrupo);
			if(g != null){
				
				if(g.getIdsUsuarios().contains(this.getId())){
					grupos.add(g);
				}
				
			}
			
		}
		return grupos;
		
	}
	
}
