package modelo;

import controlador.EditorEstructurasController;

// TODO: Auto-generated Javadoc
/**
 * Un esquema es la vista de la estructura frente a la presentacin en el editor de estructuras.
 */
public class Visualizacion {
	
	/** nombre del esquema */
	private String nombre;
	
	/** estructura contenida en el esquema. */
	private Estructura estructura;
	
	/** presentacion contenida en el esquema. */
	private Presentacion presentacion;
	
	
	
	/**
	 * Inicializa un objeto de tipo esquema.
	 */
	public Visualizacion() { // Constructor vaco exigido por hibernate
	}



	/**
	 * Inicializa un objeto de tipo esquema.
	 *
	 * @param nombre el nombre del esquema
	 * @param estructura the estructura
	 * @param presentacion the presentacion
	 */
	public Visualizacion(String nombre, Estructura estructura,
			Presentacion presentacion) {
		super();
		this.nombre = nombre;
		this.estructura = estructura;
		this.presentacion = presentacion;
	}



	/**
	 * Recupera nombre.
	 *
	 * @return el nombre
	 */
	public String getNombre() {
		return nombre;
	}



	/**
	 * Establece nombre.
	 *
	 * @param nombre el nuevo nombre
	 */
	public void setNombre(String nombre) {
		this.nombre = nombre;
	}



	/**
	 * Recupera estructura.
	 *
	 * @return el estructura
	 */
	public Estructura getEstructura() {
		return estructura;
	}



	/**
	 * Establece estructura.
	 *
	 * @param estructura el nuevo estructura
	 */
	public void setEstructura(Estructura estructura) {
		this.estructura = estructura;
	}



	/**
	 * Recupera presentacion.
	 *
	 * @return el presentacion
	 */
	public Presentacion getPresentacion() {
		return presentacion;
	}



	/**
	 * Establece presentacion.
	 *
	 * @param presentacion el nuevo presentacion
	 */
	public void setPresentacion(Presentacion presentacion) {
		this.presentacion = presentacion;
	}

	/**
	 * Actualizar tabla.
	 */
	public void actualizarTabla(){
		EditorEstructurasController.getInstance().actualizarTabla();
	}
	
	
}
