package modelo.prototypes;

import java.util.ArrayList;

import modelo.Aspecto;
import modelo.Propiedad;
import modelo.PropiedadLinea;

// TODO: Auto-generated Javadoc
/**
 * PrototipoListaPropiedadLinea prototipo que contiene las propiedades que contendrn las nuevas componentes creadas
 * Esta lista se genera a partir de PrototipoListaPropiedades.
 * Es clonada cada vez que se crea una nueva componente.
 */
public class PrototipoListaPropiedadLinea implements Cloneable{
    
    /** INSTANCE. */
    private static PrototipoListaPropiedadLinea INSTANCE = null;
    
    /** Propiedades. */
    private ArrayList<PropiedadLinea> propiedades;
 
    // Private constructor suppresses 
    /**
     * Inicializa un objeto de tipo prototipo lista propiedad linea.
     */
    private PrototipoListaPropiedadLinea() {
    	generarPropiedades();
    }
 
    // creador sincronizado para protegerse de posibles problemas  multi-hilo
    // otra prueba para evitar instanciacin mltiple 
    /**
     * Crea instance.
     */
    private synchronized static void createInstance() {
        if (INSTANCE == null) { 
            INSTANCE = new PrototipoListaPropiedadLinea();
        }
    }
 
    /**
     * Gets the single instance of PrototipoListaPropiedadLinea.
     *
     * @return single instance of PrototipoListaPropiedadLinea
     */
    public static PrototipoListaPropiedadLinea getInstance() {
        createInstance();
        return INSTANCE;
    }
    
    /**
     * Generar propiedades a partir de las propiedades del prototipo PrototipoListaPropiedades.
     */
    public void generarPropiedades(){
    	PrototipoListaPropiedades manager = new PrototipoListaPropiedades();
    	manager.abrir();
    	propiedades = new ArrayList<PropiedadLinea>();
    	
    	for(Propiedad p: manager.getPropiedades()){
    		PropiedadLinea pl = new PropiedadLinea(p.getNombre());
    		propiedades.add(pl);
    	}
    }

	/* (non-Javadoc)
	 * @see java.lang.Object#clone()
	 */
	@Override
	public Object clone()  {
		ArrayList<PropiedadLinea> clonado = new ArrayList<PropiedadLinea>();
		for(PropiedadLinea p: propiedades){
			clonado.add((PropiedadLinea) p.clone());
		}
		return clonado;
	}
    
    
}
