package utils.listeners;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.HashSet;
import java.util.Set;

import controlador.EditorEstructurasController;

// TODO: Auto-generated Javadoc
/**
 * The Class MultiKeyPressListenerEditorEstructuras.
 * 
 * Realiza llamadas a las diferentes acciones editoriales tras la pulsacin de las combinaciones de teclas correspondientes:
 * 
 * SHIFT + CURSOR IZQUIERDA: Desplazar componente a la izquierda
 * SHIFT + CURSOR DERECHA: Desplazar componente a la derecha
 * SHIFT + CURSOR ARRIBA: Desplazar componente hacia arriba
 * SHIFT + CURSOR ABAJO: Desplazar componente hacia abajo
 * SHIFT + A: Agregar componente
 * SHIFT + E: Eliminar componente
 * SHIFT + T: Cambiar tipo
 * SHIFT + C: Cambiar clase
 * SHIFT + O: Cambiar opcionalidad
 * SHIFT + I: Cambiar iteracin
 * CTRL + Z: Deshacer
 * CTRL + Y: Rehacer
 * CTRL + D: Estructura derivada
 * CTRL + N: Descripcin
 */
public class MultiKeyPressListenerEditorEstructuras implements KeyListener {

    // Set of currently pressed keys
    /** pressed. */
    private final Set<Integer> pressed = new HashSet<Integer>();

    

	/**
	 * Inicializa un objeto de tipo multi key press listener editor estructuras.
	 */
	public MultiKeyPressListenerEditorEstructuras() {
		super();
		// TODO Auto-generated constructor stub
	}

	/* (non-Javadoc)
	 * @see java.awt.event.KeyListener#keyPressed(java.awt.event.KeyEvent)
	 */
	@Override
	public void keyPressed(KeyEvent e) {
        pressed.add(e.getKeyCode());
        
        EditorEstructurasController controller = EditorEstructurasController.getInstance();
        
        if(pressed.contains(17)){ // CTRL pulsado
        	if(pressed.contains(KeyEvent.VK_LEFT)){ // flecha izquierda
        		controller.getView().getDecp092button().doClick();
        	}
        	else if(pressed.contains(KeyEvent.VK_UP)){ // flecha arriba
        		controller.getView().getDecp081button().doClick();
        		controller.desplazarCeldaSeleccionada(1,0); // compensar el click de la flecha que desplaza el cursor
        	}
        	else if(pressed.contains(KeyEvent.VK_RIGHT)){ // flecha derecha
        		controller.getView().getDecp091button().doClick();
        		controller.desplazarCeldaSeleccionada(0,-1);
        	}
        	else if(pressed.contains(KeyEvent.VK_DOWN)){ // flecha abajo
        		controller.getView().getDecp082button().doClick();
        		controller.desplazarCeldaSeleccionada(-1,0); // compensar el click de la flecha que desplaza el cursor
        	}
        	else if(pressed.contains(84)){ // tecla t
        		controller.getView().getDecp02button().doClick();
        	}
        	else if(pressed.contains(67)){ // tecla c
        		controller.getView().getDecp03button().doClick();
        	}
        	else if(pressed.contains(73)){ // tecla i
        		controller.getView().getDecp04button().doClick();
        	}
        	else if(pressed.contains(79)){ // tecla o
        		controller.getView().getDecp05button().doClick();
        	}
        	else if(pressed.contains(65)){ // tecla a
        		controller.getView().getDecp06button().doClick();
        	}
        	else if(pressed.contains(69)){ // tecla e
        		controller.getView().getDecp07button().doClick();
        	}
        	else if(pressed.contains(68)){ // tecla d
        		/* Si no se hace un clear, se ralla */
        		pressed.clear();
        		controller.getView().getDecp10button().doClick();
        	}
        	else if(pressed.contains(90)){
        		controller.getView().getDecp11button().doClick();
        	}
        	else if(pressed.contains(89)){
        		controller.getView().getDecp12button().doClick();
        	}
        	else if(pressed.contains(KeyEvent.VK_N)){
        		controller.getView().getDecp14button().doClick();
        	}
        	else if(pressed.contains(KeyEvent.VK_P)){
        		controller.getView().getDecp13button().doClick();
        	}
        }
		//System.out.println(pressed.toString());
	}

	/* (non-Javadoc)
	 * @see java.awt.event.KeyListener#keyReleased(java.awt.event.KeyEvent)
	 */
	@Override
	public void keyReleased(KeyEvent e) {
		pressed.remove(e.getKeyCode());
		
	}

	/* (non-Javadoc)
	 * @see java.awt.event.KeyListener#keyTyped(java.awt.event.KeyEvent)
	 */
	@Override
	public void keyTyped(KeyEvent e) {
		// TODO Auto-generated method stub
		
	}
}
