package utils.tablemodels;

import java.util.ArrayList;
import java.util.SortedSet;

import javax.swing.event.TableModelListener;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableModel;

import utils.ManagerAreas;

import modelo.Area;

public class AreasModel extends AbstractTableModel {

	String [] columnas = {"Nombre"};
	ArrayList<Area> areas;
	
	@Override
	public void addTableModelListener(TableModelListener arg0) {
		// TODO Auto-generated method stub

	}

	@Override
	public int getColumnCount() {
		return columnas.length;
	}

	@Override
	public String getColumnName(int arg0) {
		return columnas[arg0];
	}

	@Override
	public int getRowCount() {
		return areas.size();
	}

	@Override
	public Object getValueAt(int row, int column) {
		return areas.get(row).getNombre();
	}

	public AreasModel() {
		
		super();
		ManagerAreas manager = ManagerAreas.getInstance();
	
		SortedSet<Area> areasAux = manager.obtenerAreas();
		
		areas = new ArrayList<Area>();
		
		for(Area a: areasAux){
			areas.add(a);
		}
	}


}
