package utils.tablemodels;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.SortedSet;

import javax.swing.table.AbstractTableModel;

import utils.ManagerAreas;

import modelo.Area;
import modelo.Estructura;

public class ModeloAreasEstructuras extends AbstractTableModel{

	String [] columns = {"Nombre rea", "Nombre estructura"};
	ArrayList<Estructura> estructuras;
	
	@Override
	public int getColumnCount() {
		return columns.length;
	}

	@Override
	public int getRowCount() {
		return estructuras.size();
	}

	@Override
	public Object getValueAt(int row, int column) {
		if(column == 0){
			ManagerAreas ma = ManagerAreas.getInstance();
			Area area = ma.obtenerAreaPorID(estructuras.get(row).getIdArea());
			if(area != null)
				return area.getNombre();
			else
				return "[Area no encontrada]";
		}
			else
				return estructuras.get(row).getNombre();
	}

	public ModeloAreasEstructuras(ArrayList<Estructura> estructuras) {
		super();
		this.estructuras = estructuras;
	}

	@Override
	public String getColumnName(int col) {
		return columns[col];
	}
	
	

}
