package utils.tablemodels;

import java.util.ArrayList;

import javax.swing.table.AbstractTableModel;

import modelo.Aspecto;

// TODO: Auto-generated Javadoc
/**
 *  ModeloEditorPresentacionesAspecto es el modelo utilizado para la tabla en la que se 
 *  musetra el conjunto de caractersticas de aspecto.
 */
public class ModeloEditorPresentacionesAspecto extends AbstractTableModel{

	/** Nombres de las columnas. */
	String columns[] = {"Tipo de elemento"};
	
	/** Conjunto de caractersticas de aspecto. */
	ArrayList<Aspecto> aspecto;
	
	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getColumnCount()
	 */
	@Override
	public int getColumnCount() {
		return columns.length;
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getRowCount()
	 */
	@Override
	public int getRowCount() {
		return aspecto.size();
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getValueAt(int, int)
	 */
	@Override
	public Object getValueAt(int rowIndex, int columnIndex) {
		return aspecto.get(rowIndex).getNombre();
	}

	/**
	 * Inicializa un objeto de tipo modelo editor presentaciones aspecto.
	 *
	 * @param aspecto the aspecto
	 */
	public ModeloEditorPresentacionesAspecto(ArrayList<Aspecto> aspecto) {
		super();
		this.aspecto = aspecto;
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.AbstractTableModel#getColumnName(int)
	 */
	@Override
	public String getColumnName(int arg0) {
		return columns[arg0];
	}
	

}
