package utils.tablemodels;

import java.util.ArrayList;

import javax.swing.table.AbstractTableModel;

import utils.ManagerComponentes;

import modelo.Componente;
import modelo.ComponenteCompuesta;
import modelo.ComponenteLinea;
import modelo.Estructura;
import modelo.Linea;
import modelo.SelectorLinea;

// TODO: Auto-generated Javadoc
/**
 * The Class ModeloEditorSelectorComponentesInsertadas.
 * Tabla Superior Izquierda de la interfaz del editor de selector
 */
public class ModeloEditorSelectorComponentesInsertadas extends AbstractTableModel{

	/** Nombre de las columnas. */
	private ArrayList<String> nombresColumnas;
	
	/** Componentes mostradas en la tabla */
	private ArrayList<Componente> componentes;
	
	/** Diccionario */
	private ManagerComponentes diccionario;

	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getColumnCount()
	 */
	@Override
	public int getColumnCount() {
		return nombresColumnas.size();
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getRowCount()
	 */
	@Override
	public int getRowCount() {
		return componentes.size();
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getValueAt(int, int)
	 */
	@Override
	public Object getValueAt(int rowIndex, int columnIndex) {
		Componente componenteSeleccionada = componentes.get(rowIndex); // se elimina la propia componente

		if(columnIndex == 0){ // Nombre componente
			return componenteSeleccionada.getNombre();
		}
		else{ // Componente origen
			// Obtener el id de la componente origen
			String id =  componenteSeleccionada.getIdComponenteOrigen();
			// Obtener la componente origen del diccionario
			Componente c = diccionario.getComponentes().get(id);
			// La componente compleja base no tiene estructura origen ni componente origen
			if(c != null)
				return c.getNombre();
			else
				return "";

		}
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.AbstractTableModel#getColumnName(int)
	 */
	@Override
	public String getColumnName(int index) {
		return nombresColumnas.get(index);
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.AbstractTableModel#isCellEditable(int, int)
	 */
	@Override
	public boolean isCellEditable(int rowIndex, int columnIndex) {
		return false;
	}

	/**
	 * Inicializa un objeto de tipo modelo editor selector componentes insertadas.
	 *
	 * @param componentes the componentes
	 */
	public ModeloEditorSelectorComponentesInsertadas(ArrayList<Componente> componentes) {
		super();
		this.componentes = componentes;
		nombresColumnas = new ArrayList<String>();
		nombresColumnas.add("Nombre componente");
		nombresColumnas.add("Componente origen");
		diccionario = ManagerComponentes.getInstance();
		diccionario.actualizar();
	}
	

	
	
}
