package utils.tablemodels;

import java.util.ArrayList;

import javax.swing.table.AbstractTableModel;
import javax.swing.table.DefaultTableModel;

import modelo.Componente;
import modelo.ComponenteCompuesta;
import modelo.ComponenteLinea;

// TODO: Auto-generated Javadoc
/**
 * The Class ModeloEditorSelectorComponentesNoInsertadas.
 * Modelo correspondiente a la tabla inferior izquierda de la interfaz del editor de selector
 */
public class ModeloEditorSelectorComponentesNoInsertadas extends AbstractTableModel{

	/** Nombre de las columnas */
	private ArrayList<String> nombresColumnas;
	
	/** Componentes mostradas en la tabla. */
	private ArrayList<Componente> componentes;
	
	
	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getColumnCount()
	 */
	@Override
	public int getColumnCount() {
		return nombresColumnas.size();
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getRowCount()
	 */
	@Override
	public int getRowCount() {
		return componentes.size(); 
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getValueAt(int, int)
	 */
	@Override
	public Object getValueAt(int rowIndex, int columnIndex) {
		Componente componenteSeleccionada = componentes.get(rowIndex); 
		return componenteSeleccionada.getNombre();
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.AbstractTableModel#getColumnName(int)
	 */
	@Override
	public String getColumnName(int column) {
		return nombresColumnas.get(column);
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.AbstractTableModel#isCellEditable(int, int)
	 */
	@Override
	public boolean isCellEditable(int rowIndex, int columnIndex) {
		return false;
	}

	/**
	 * Inicializa un objeto de tipo modelo editor selector componentes no insertadas.
	 *
	 * @param componentes the componentes
	 */
	public ModeloEditorSelectorComponentesNoInsertadas(ArrayList<Componente> componentes) {
		super();
		nombresColumnas = new ArrayList<String>();
		nombresColumnas.add("Nombre componente");
		this.componentes = componentes;
	}
	
	

}
