package utils.tablemodels;

import java.util.ArrayList;

import javax.swing.table.AbstractTableModel;

import controlador.EditorSelectorController;

import modelo.Componente;

// TODO: Auto-generated Javadoc
/**
 * The Class ModeloEditorSelectorComponentesSelector.
 * Modelo de la tabla derecha de la interfaz del editor de selector
 */
public class ModeloEditorSelectorComponentesSelector extends AbstractTableModel{

	/** Componentes mostradas. */
	private ArrayList<Componente> componentes;
	
	/** Nombre de las columnas*/
	private ArrayList<String> columnNames;
	
	/** Expresiones. */
	private ArrayList<String> expresiones;
	
	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getColumnCount()
	 */
	@Override
	public int getColumnCount() {
		return columnNames.size();
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getRowCount()
	 */
	@Override
	public int getRowCount() {
		return componentes.size();
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getValueAt(int, int)
	 */
	@Override
	public Object getValueAt(int rowIndex, int columnIndex) {
		if(columnIndex == 0){
			return componentes.get(rowIndex).getNombre();
		}
		else{
			return expresiones.get(rowIndex);
		}
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.AbstractTableModel#getColumnName(int)
	 */
	@Override
	public String getColumnName(int column) {
		return columnNames.get(column);
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.AbstractTableModel#isCellEditable(int, int)
	 */
	@Override
	public boolean isCellEditable(int rowIndex, int columnIndex) {
		if(columnIndex == 1) return true;
		else return false;
	}

	/**
	 * Inicializa un objeto de tipo modelo editor selector componentes selector.
	 *
	 * @param componentes the componentes
	 * @param expresiones the expresiones
	 */
	public ModeloEditorSelectorComponentesSelector(ArrayList<Componente> componentes, ArrayList<String> expresiones) {
		super();
		
		columnNames = new ArrayList<String>();
		columnNames.add("Nombre Componente");
		columnNames.add("Expresin");
		
		this.componentes = componentes;
		this.expresiones = expresiones;
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.AbstractTableModel#setValueAt(java.lang.Object, int, int)
	 */
	@Override
	public void setValueAt(Object nuevoValor, int rowIndex, int columnIndex) {
		
		String expresion = (String) nuevoValor;
		EditorSelectorController controller = EditorSelectorController.getInstance();
		
		controller.modificarExpresin(expresion, rowIndex);
	}

	
	
}
