package utils.tablemodels;

import java.text.SimpleDateFormat;
import java.util.ArrayList;

import javax.swing.table.AbstractTableModel;

import controlador.EditorPresentacionesController;

import modelo.Presentacion;

// TODO: Auto-generated Javadoc
/**
 * ModeloEditorTipoPresentaciones es usada como modelo en las tablas en las que se permite realizar cambios
 * entre propiedades publica y privadas.
 */
public class ModeloEditorTipoPresentaciones extends AbstractTableModel{

	/** Nombre de las columnas. */
	String columns [] = {"Nombre", "Autor", "Creacin", "Default"};
	
	/** Conjunto de presentaciones mostradas. */
	ArrayList<Presentacion> presentaciones;
	
	/** Formateo de fechas. */
	SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");
	
	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getColumnCount()
	 */
	@Override
	public int getColumnCount() {
		return columns.length;
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getRowCount()
	 */
	@Override
	public int getRowCount() {
		return presentaciones.size();
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getValueAt(int, int)
	 */
	@Override
	public Object getValueAt(int rowIndex, int columnIndex) {
		if(columnIndex == 0){ // nombre
			return presentaciones.get(rowIndex).getNombre();
		}
		else if(columnIndex == 2){ // fecha creacion
			return  sdf.format(presentaciones.get(rowIndex).getCreacion().getTime());
		}
		else if(columnIndex == 3){ // default
			if(presentaciones.get(rowIndex).getTipo() == Presentacion.DEFAULT)
				return "Si";
			else
				return null;
		}
		else return null;
	}
	
	/* (non-Javadoc)
	 * @see javax.swing.table.AbstractTableModel#getColumnName(int)
	 */
	@Override
	public String getColumnName(int col) {
		return columns[col];
	}


//	@Override
//	public Class getColumnClass(int c) {
//		return getValueAt(0, c).getClass();
//	}


	
	/**
 * Inicializa un objeto de tipo modelo editor tipo presentaciones.
 *
 * @param presentaciones the presentaciones
 */
public ModeloEditorTipoPresentaciones(ArrayList<Presentacion> presentaciones) {
		super();
		this.presentaciones = presentaciones;
	}
	
	

}
