package utils.tablemodels;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.SortedSet;

import javax.swing.table.AbstractTableModel;

import modelo.Esquema;

public class ModeloLocalizarEsquemas extends AbstractTableModel{

	String [] columns = {"Nombre del esquema"};
	ArrayList<String> esquemas;

	@Override
	public int getColumnCount() {
		return columns.length;
	}

	@Override
	public int getRowCount() {
		return esquemas.size();
	}

	@Override
	public Object getValueAt(int row, int column) {
		return esquemas.get(row);
	}

	public ModeloLocalizarEsquemas(SortedSet<Esquema> setEsquemas) {
		super();
		esquemas = new ArrayList<String>();

		for(Esquema e: setEsquemas){
			esquemas.add(e.getNombre());
		}
	}

	@Override
	public String getColumnName(int col) {
		return columns[col];
	}



}
