package utils.tablemodels;

import java.util.ArrayList;
import java.util.SortedSet;

import javax.swing.table.AbstractTableModel;

import modelo.Estructura;

public class ModeloLocalizarEstructuras extends AbstractTableModel{

	String [] columns = {"Nombre de la estructura"};
	ArrayList<Estructura> estructuras;

	@Override
	public int getColumnCount() {
		return columns.length;
	}

	@Override
	public int getRowCount() {
		return estructuras.size();
	}

	@Override
	public Object getValueAt(int row, int column) {
		return estructuras.get(row).getNombre();
	}

	public ModeloLocalizarEstructuras(ArrayList<Estructura> estructuras) {
		super();
		this.estructuras = estructuras;
	}

	@Override
	public String getColumnName(int col) {
		return columns[col];
	}

	public ArrayList<Estructura> getEstructuras() {
		return estructuras;
	}

	public void setEstructuras(ArrayList<Estructura> estructuras) {
		this.estructuras = estructuras;
	}



}
