package utils.tablemodels;

import java.util.ArrayList;
import java.util.SortedSet;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.event.TableModelListener;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.DefaultTableModel;

import modelo.Area;
import modelo.Grupo;
import utils.ManagerAreas;
import utils.ManagerGrupos;

public class ModeloPermisos extends AbstractTableModel{

	String [] columnas = {"Nombre grupo", "Nivel de acceso"};
	private static final Class<?>[] COLUMN_TYPES = new Class<?>[] {String.class, JComboBox.class};
	ArrayList<Grupo> grupos;
	Area area;

	@Override
	public int getColumnCount() {
		return columnas.length;
	}

	@Override
	public String getColumnName(int arg0) {
		return columnas[arg0];
	}

	@Override
	public int getRowCount() {
		return grupos.size();
	}

	@Override
	public Object getValueAt(int row, int column) {
		if(column == 0){
			// Nombre del grupo
			return grupos.get(row).getNombre();
		}
		else{
			// Permiso
			int permiso = Area.SIN_ACCESO; // por defecto
			Grupo grupo = grupos.get(row);
			// Buscar permiso para el grupo
			Integer permisoBuscado = area.getPermisos().get(grupo.getID());

			if(permisoBuscado == null){
				// Aun no existe ningn permiso asignado
				area.getPermisos().put(grupo.getID(), permiso);
			}
			else{
				permiso = permisoBuscado;
			}
			switch(permiso){
			case Area.LECTURA:
				return "Lectura";
			case Area.ESCRITURA:
				return "Escritura";
				default:
					return "Sin Acceso";
			}
		}
	}

	   public Class getColumnClass(int c) {
           return getValueAt(0, c).getClass();
       }
	   
       public void setValueAt(Object value, int row, int col) {
    	   /* Actualizar modelo */
           Grupo grupo = grupos.get(row);
           area.getPermisos().remove(grupo.getID());
           if(value.equals("Lectura"))
        	   area.getPermisos().put(grupo.getID(), Area.LECTURA);
           else if(value.equals("Escritura"))
        	   area.getPermisos().put(grupo.getID(), Area.ESCRITURA);
           else
        	   area.getPermisos().put(grupo.getID(), Area.SIN_ACCESO);
    	   
          // Actualizar tabla
           fireTableCellUpdated(row, col);
       }


	@Override
	public boolean isCellEditable(int row, int column) {
		if(column==0)
			return false;
		else
			return true;
	}

	public ModeloPermisos(Area area) {

		super();
		this.area = area;

		ManagerGrupos managerGrupos = ManagerGrupos.getInstance();
		grupos = new ArrayList<Grupo>();
		grupos.addAll(managerGrupos.obtenerGrupos());
	}




}
