package vista;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JTextArea;
import javax.swing.JScrollPane;
import javax.swing.border.LineBorder;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import java.awt.Color;
import javax.swing.JTabbedPane;
import java.awt.FlowLayout;
import javax.swing.JToolBar;
import javax.swing.JButton;
import javax.swing.ImageIcon;
import javax.swing.JTable;

import utils.tablemodels.ExampleModel;
import javax.swing.ListSelectionModel;

import controlador.EditorAreasController;

import modelo.Area;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.JSplitPane;
import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;

public class EditorAreas extends JFrame {

	private JPanel contentPane;
	private JPanel panelNorth;
	private JPanel panelSouth;
	private JPanel panelCenter;
	private JPanel panelCenterLeft;
	private JPanel panelCenterRight;
	private JLabel lblNombre;
	private JLabel lblDescripcin;
	private JLabel lblFechaCreacin;
	private JLabel lblAutor;
	private JLabel lblUltModificacin;
	private JLabel lblAutorModificacin;
	private JTextField textFieldNombre;
	private JTextField textFieldCreacion;
	private JTextField textFieldAutor;
	private JTextField textFieldFechaModificacion;
	private JTextField textFieldAutorModificacion;
	private JTextArea textAreaDescripcion;
	private JScrollPane scrollPane;
	private JTabbedPane tabbedPane;
	private JPanel panelPermisos;
	private JLabel lblUsuario;
	private JLabel lblGrupos;
	private JToolBar toolBar;
	private JButton dea1button;
	private JButton dea2button;
	private JTable tablePermisos;
	private JScrollPane scrollPane_1;
	private JPanel panelEstructuras;
	private JPanel panelLeft;
	private JPanel panelCenter2;
	private JPanel panelRight;
	private JLabel lblEstructuras;
	private JLabel lblEstructurasDelrea;
	private JTable tableEstructurasNoArea;
	private JTable tableEstructurasArea;
	private JScrollPane scrollPane_2;
	private JScrollPane scrollPane_3;
	private JButton dge1button;
	private JButton dge2button;
	private JLabel lblGruposUsuarios;
	private EditorAreasController controller;
	private LocalizadorAreasEsquemas previousWindow;
	private JPanel panel;
	private JPanel panel_1;
	private JLabel lblRealimentacion;
	private JPanel panel_2;
	private JPanel panel_3;
	private JButton btnDerecha;
	private JButton btnIzquierda;
	private JPanel panel_4;
	private JPanel panel_5;
	private JTable tableEstructurasPropias;
	private JTable tableAreas;
	private JScrollPane scrollPane_4;
	private JScrollPane scrollPane_5;
	private JTable tableEstructurasOtrasAreas;
	private JScrollPane scrollPane_6;
	private JPanel panel_6;
	private JLabel lblRealimentacion2;


	/**
	 * Create the frame.
	 */
	public EditorAreas(LocalizadorAreasEsquemas previousWindow, Area area, int tipoOperacion) {
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent arg0) {
				controller.cerrarVentana();
			}
		});
		setTitle("Editor de \u00C1reas");
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		setBounds(100, 100, 900, 600);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(0, 0));
		setContentPane(contentPane);

		panelNorth = new JPanel();
		FlowLayout flowLayout_1 = (FlowLayout) panelNorth.getLayout();
		flowLayout_1.setHgap(0);
		flowLayout_1.setVgap(0);
		flowLayout_1.setAlignment(FlowLayout.LEFT);
		contentPane.add(panelNorth, BorderLayout.NORTH);

		toolBar = new JToolBar();
		toolBar.setFloatable(false);
		panelNorth.add(toolBar);

		dea1button = new JButton("");
		dea1button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.cerrarVentana();
			}
		});
		dea1button.setIcon(new ImageIcon(EditorAreas.class.getResource("/resources/icons/ok_button.png")));
		toolBar.add(dea1button);

		dea2button = new JButton("");
		dea2button.setIcon(new ImageIcon(EditorAreas.class.getResource("/resources/icons/help-browser.png")));
		toolBar.add(dea2button);

		panelSouth = new JPanel();
		FlowLayout flowLayout = (FlowLayout) panelSouth.getLayout();
		flowLayout.setVgap(0);
		flowLayout.setAlignment(FlowLayout.LEFT);
		contentPane.add(panelSouth, BorderLayout.SOUTH);

		lblUsuario = new JLabel("Usuario:");
		panelSouth.add(lblUsuario);

		lblGrupos = new JLabel("Grupos:");
		panelSouth.add(lblGrupos);

		panelCenter = new JPanel();
		contentPane.add(panelCenter, BorderLayout.CENTER);
		GridBagLayout gbl_panelCenter = new GridBagLayout();
		gbl_panelCenter.columnWidths = new int[]{225, 0};
		gbl_panelCenter.rowHeights = new int[]{0, 0};
		gbl_panelCenter.columnWeights = new double[]{0.0, 1.0};
		gbl_panelCenter.rowWeights = new double[]{1.0, Double.MIN_VALUE};
		panelCenter.setLayout(gbl_panelCenter);

		panelCenterLeft = new JPanel();
		panelCenterLeft.setBorder(new LineBorder(Color.LIGHT_GRAY));
		GridBagConstraints gbc_panelCenterLeft = new GridBagConstraints();
		gbc_panelCenterLeft.insets = new Insets(0, 0, 0, 5);
		gbc_panelCenterLeft.fill = GridBagConstraints.BOTH;
		gbc_panelCenterLeft.gridx = 0;
		gbc_panelCenterLeft.gridy = 0;
		panelCenter.add(panelCenterLeft, gbc_panelCenterLeft);
		GridBagLayout gbl_panelCenterLeft = new GridBagLayout();
		gbl_panelCenterLeft.columnWidths = new int[]{0, 0, 0};
		gbl_panelCenterLeft.rowHeights = new int[]{0, 0, 0, 0, 0, 0, 0, 0};
		gbl_panelCenterLeft.columnWeights = new double[]{1.0, 1.0, Double.MIN_VALUE};
		gbl_panelCenterLeft.rowWeights = new double[]{0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		panelCenterLeft.setLayout(gbl_panelCenterLeft);

		lblNombre = new JLabel("Nombre:");
		GridBagConstraints gbc_lblNombre = new GridBagConstraints();
		gbc_lblNombre.anchor = GridBagConstraints.EAST;
		gbc_lblNombre.insets = new Insets(5, 5, 5, 5);
		gbc_lblNombre.gridx = 0;
		gbc_lblNombre.gridy = 0;
		panelCenterLeft.add(lblNombre, gbc_lblNombre);

		textFieldNombre = new JTextField();
		GridBagConstraints gbc_textFieldNombre = new GridBagConstraints();
		gbc_textFieldNombre.insets = new Insets(5, 5, 5, 5);
		gbc_textFieldNombre.fill = GridBagConstraints.HORIZONTAL;
		gbc_textFieldNombre.gridx = 1;
		gbc_textFieldNombre.gridy = 0;
		panelCenterLeft.add(textFieldNombre, gbc_textFieldNombre);
		textFieldNombre.setColumns(10);

		lblDescripcin = new JLabel("Descripci\u00F3n:");
		GridBagConstraints gbc_lblDescripcin = new GridBagConstraints();
		gbc_lblDescripcin.anchor = GridBagConstraints.NORTHEAST;
		gbc_lblDescripcin.insets = new Insets(0, 5, 5, 5);
		gbc_lblDescripcin.gridx = 0;
		gbc_lblDescripcin.gridy = 1;
		panelCenterLeft.add(lblDescripcin, gbc_lblDescripcin);

		scrollPane = new JScrollPane();
		GridBagConstraints gbc_scrollPane = new GridBagConstraints();
		gbc_scrollPane.fill = GridBagConstraints.BOTH;
		gbc_scrollPane.gridwidth = 2;
		gbc_scrollPane.insets = new Insets(0, 5, 0, 5);
		gbc_scrollPane.gridx = 0;
		gbc_scrollPane.gridy = 2;
		panelCenterLeft.add(scrollPane, gbc_scrollPane);

		textAreaDescripcion = new JTextArea();
		textAreaDescripcion.getDocument().addDocumentListener(new DocumentListener() {
			public void changedUpdate(DocumentEvent e) {
				controller.getArea().setDescripcion(textAreaDescripcion.getText());
			}
			public void removeUpdate(DocumentEvent e) {
				controller.getArea().setDescripcion(textAreaDescripcion.getText());
			}
			public void insertUpdate(DocumentEvent e) {
				controller.getArea().setDescripcion(textAreaDescripcion.getText());
			}
		});
		textAreaDescripcion.setLineWrap( true );
		textAreaDescripcion.setWrapStyleWord( true );
		textAreaDescripcion.setSize( textAreaDescripcion.getPreferredSize() );
		scrollPane.setViewportView(textAreaDescripcion);

		lblFechaCreacin = new JLabel("Creaci\u00F3n:");
		GridBagConstraints gbc_lblFechaCreacin = new GridBagConstraints();
		gbc_lblFechaCreacin.anchor = GridBagConstraints.EAST;
		gbc_lblFechaCreacin.insets = new Insets(5, 0, 5, 5);
		gbc_lblFechaCreacin.gridx = 0;
		gbc_lblFechaCreacin.gridy = 3;
		panelCenterLeft.add(lblFechaCreacin, gbc_lblFechaCreacin);

		textFieldCreacion = new JTextField();
		textFieldCreacion.setEnabled(false);
		GridBagConstraints gbc_textFieldCreacion = new GridBagConstraints();
		gbc_textFieldCreacion.insets = new Insets(5, 5, 5, 5);
		gbc_textFieldCreacion.fill = GridBagConstraints.HORIZONTAL;
		gbc_textFieldCreacion.gridx = 1;
		gbc_textFieldCreacion.gridy = 3;
		panelCenterLeft.add(textFieldCreacion, gbc_textFieldCreacion);
		textFieldCreacion.setColumns(10);

		lblAutor = new JLabel("Autor:");
		GridBagConstraints gbc_lblAutor = new GridBagConstraints();
		gbc_lblAutor.anchor = GridBagConstraints.EAST;
		gbc_lblAutor.insets = new Insets(0, 0, 5, 5);
		gbc_lblAutor.gridx = 0;
		gbc_lblAutor.gridy = 4;
		panelCenterLeft.add(lblAutor, gbc_lblAutor);

		textFieldAutor = new JTextField();
		textFieldAutor.setEnabled(false);
		GridBagConstraints gbc_textFieldAutor = new GridBagConstraints();
		gbc_textFieldAutor.insets = new Insets(0, 5, 5, 5);
		gbc_textFieldAutor.fill = GridBagConstraints.HORIZONTAL;
		gbc_textFieldAutor.gridx = 1;
		gbc_textFieldAutor.gridy = 4;
		panelCenterLeft.add(textFieldAutor, gbc_textFieldAutor);
		textFieldAutor.setColumns(10);

		lblUltModificacin = new JLabel("Ult. Modificaci\u00F3n:");
		GridBagConstraints gbc_lblUltModificacin = new GridBagConstraints();
		gbc_lblUltModificacin.anchor = GridBagConstraints.EAST;
		gbc_lblUltModificacin.insets = new Insets(0, 0, 5, 5);
		gbc_lblUltModificacin.gridx = 0;
		gbc_lblUltModificacin.gridy = 5;
		panelCenterLeft.add(lblUltModificacin, gbc_lblUltModificacin);

		textFieldFechaModificacion = new JTextField();
		textFieldFechaModificacion.setEnabled(false);
		GridBagConstraints gbc_textFieldFechaModificacion = new GridBagConstraints();
		gbc_textFieldFechaModificacion.insets = new Insets(0, 5, 5, 5);
		gbc_textFieldFechaModificacion.fill = GridBagConstraints.HORIZONTAL;
		gbc_textFieldFechaModificacion.gridx = 1;
		gbc_textFieldFechaModificacion.gridy = 5;
		panelCenterLeft.add(textFieldFechaModificacion, gbc_textFieldFechaModificacion);
		textFieldFechaModificacion.setColumns(10);

		lblAutorModificacin = new JLabel("Autor Modificaci\u00F3n:");
		GridBagConstraints gbc_lblAutorModificacin = new GridBagConstraints();
		gbc_lblAutorModificacin.anchor = GridBagConstraints.EAST;
		gbc_lblAutorModificacin.insets = new Insets(0, 0, 0, 5);
		gbc_lblAutorModificacin.gridx = 0;
		gbc_lblAutorModificacin.gridy = 6;
		panelCenterLeft.add(lblAutorModificacin, gbc_lblAutorModificacin);

		textFieldAutorModificacion = new JTextField();
		textFieldAutorModificacion.setEnabled(false);
		GridBagConstraints gbc_textFieldAutorModificacion = new GridBagConstraints();
		gbc_textFieldAutorModificacion.insets = new Insets(0, 5, 5, 5);
		gbc_textFieldAutorModificacion.fill = GridBagConstraints.HORIZONTAL;
		gbc_textFieldAutorModificacion.gridx = 1;
		gbc_textFieldAutorModificacion.gridy = 6;
		panelCenterLeft.add(textFieldAutorModificacion, gbc_textFieldAutorModificacion);
		textFieldAutorModificacion.setColumns(10);

		panelCenterRight = new JPanel();
		GridBagConstraints gbc_panelCenterRight = new GridBagConstraints();
		gbc_panelCenterRight.fill = GridBagConstraints.BOTH;
		gbc_panelCenterRight.gridx = 1;
		gbc_panelCenterRight.gridy = 0;
		panelCenter.add(panelCenterRight, gbc_panelCenterRight);
		GridBagLayout gbl_panelCenterRight = new GridBagLayout();
		gbl_panelCenterRight.columnWidths = new int[]{56, 0};
		gbl_panelCenterRight.rowHeights = new int[]{54, 0};
		gbl_panelCenterRight.columnWeights = new double[]{1.0, Double.MIN_VALUE};
		gbl_panelCenterRight.rowWeights = new double[]{1.0, Double.MIN_VALUE};
		panelCenterRight.setLayout(gbl_panelCenterRight);

		tabbedPane = new JTabbedPane(JTabbedPane.TOP);
		tabbedPane.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent evt) {
				JTabbedPane pane = (JTabbedPane)evt.getSource();
				int sel = pane.getSelectedIndex();
				if(sel == 1){ // tablas importadas
					controller.actualizarContenidoTablasImportadas();
					controller.actualizarTablasImportadasYPremisos();
				}
			}
		});
		GridBagConstraints gbc_tabbedPane = new GridBagConstraints();
		gbc_tabbedPane.fill = GridBagConstraints.BOTH;
		gbc_tabbedPane.gridx = 0;
		gbc_tabbedPane.gridy = 0;
		panelCenterRight.add(tabbedPane, gbc_tabbedPane);

		panel = new JPanel();
		tabbedPane.addTab("Estructuras", null, panel, null);
		GridBagLayout gbl_panel = new GridBagLayout();
		gbl_panel.columnWidths = new int[]{0, 0, 400, 400, 0};
		gbl_panel.rowHeights = new int[]{-206, 0, 0};
		gbl_panel.columnWeights = new double[]{1.0, 0.0, 1.0, 1.0, Double.MIN_VALUE};
		gbl_panel.rowWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
		panel.setLayout(gbl_panel);

		panel_1 = new JPanel();
		GridBagConstraints gbc_panel_1 = new GridBagConstraints();
		gbc_panel_1.fill = GridBagConstraints.BOTH;
		gbc_panel_1.insets = new Insets(0, 0, 5, 5);
		gbc_panel_1.gridx = 0;
		gbc_panel_1.gridy = 0;
		panel.add(panel_1, gbc_panel_1);
		panel_1.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));

		lblRealimentacion = new JLabel("sdf");
		panel_1.add(lblRealimentacion);
		
		panel_6 = new JPanel();
		FlowLayout flowLayout_2 = (FlowLayout) panel_6.getLayout();
		flowLayout_2.setAlignment(FlowLayout.LEFT);
		GridBagConstraints gbc_panel_6 = new GridBagConstraints();
		gbc_panel_6.gridwidth = 2;
		gbc_panel_6.insets = new Insets(0, 0, 5, 5);
		gbc_panel_6.fill = GridBagConstraints.BOTH;
		gbc_panel_6.gridx = 2;
		gbc_panel_6.gridy = 0;
		panel.add(panel_6, gbc_panel_6);
		
		lblRealimentacion2 = new JLabel("New label");
		panel_6.add(lblRealimentacion2);

		panel_2 = new JPanel();
		GridBagConstraints gbc_panel_2 = new GridBagConstraints();
		gbc_panel_2.fill = GridBagConstraints.BOTH;
		gbc_panel_2.insets = new Insets(0, 0, 0, 5);
		gbc_panel_2.gridx = 0;
		gbc_panel_2.gridy = 1;
		panel.add(panel_2, gbc_panel_2);
		GridBagLayout gbl_panel_2 = new GridBagLayout();
		gbl_panel_2.columnWidths = new int[]{400, 0};
		gbl_panel_2.rowHeights = new int[]{0, 0};
		gbl_panel_2.columnWeights = new double[]{1.0, Double.MIN_VALUE};
		gbl_panel_2.rowWeights = new double[]{1.0, Double.MIN_VALUE};
		panel_2.setLayout(gbl_panel_2);

		scrollPane_4 = new JScrollPane();
		GridBagConstraints gbc_scrollPane_4 = new GridBagConstraints();
		gbc_scrollPane_4.fill = GridBagConstraints.BOTH;
		gbc_scrollPane_4.gridx = 0;
		gbc_scrollPane_4.gridy = 0;
		panel_2.add(scrollPane_4, gbc_scrollPane_4);

		tableEstructurasPropias = new JTable(new ExampleModel());
		tableEstructurasPropias.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		ListSelectionModel selectionModel4 = tableEstructurasPropias.getSelectionModel();
		selectionModel4.addListSelectionListener(new ListSelectionListener(){

			@Override
			public void valueChanged(ListSelectionEvent arg0) {
				controller.habilitarDisparos();
			}

		});
		scrollPane_4.setViewportView(tableEstructurasPropias);

		panel_3 = new JPanel();
		GridBagConstraints gbc_panel_3 = new GridBagConstraints();
		gbc_panel_3.insets = new Insets(0, 0, 0, 5);
		gbc_panel_3.gridx = 1;
		gbc_panel_3.gridy = 1;
		panel.add(panel_3, gbc_panel_3);
		GridBagLayout gbl_panel_3 = new GridBagLayout();
		gbl_panel_3.columnWidths = new int[]{0, 0};
		gbl_panel_3.rowHeights = new int[]{0, 0, 0};
		gbl_panel_3.columnWeights = new double[]{0.0, Double.MIN_VALUE};
		gbl_panel_3.rowWeights = new double[]{0.0, 0.0, Double.MIN_VALUE};
		panel_3.setLayout(gbl_panel_3);

		btnDerecha = new JButton("");
		btnDerecha.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.desplazarDerecha();
			}
		});
		btnDerecha.setIcon(new ImageIcon(EditorAreas.class.getResource("/resources/icons/go-next.png")));
		GridBagConstraints gbc_btnDerecha = new GridBagConstraints();
		gbc_btnDerecha.insets = new Insets(0, 0, 5, 0);
		gbc_btnDerecha.gridx = 0;
		gbc_btnDerecha.gridy = 0;
		panel_3.add(btnDerecha, gbc_btnDerecha);

		btnIzquierda = new JButton("");
		btnIzquierda.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.desplazarIzquierda();
			}
		});
		btnIzquierda.setIcon(new ImageIcon(EditorAreas.class.getResource("/resources/icons/go-previous.png")));
		GridBagConstraints gbc_btnIzquierda = new GridBagConstraints();
		gbc_btnIzquierda.gridx = 0;
		gbc_btnIzquierda.gridy = 1;
		panel_3.add(btnIzquierda, gbc_btnIzquierda);

		panel_4 = new JPanel();
		GridBagConstraints gbc_panel_4 = new GridBagConstraints();
		gbc_panel_4.fill = GridBagConstraints.BOTH;
		gbc_panel_4.insets = new Insets(0, 0, 0, 5);
		gbc_panel_4.gridx = 2;
		gbc_panel_4.gridy = 1;
		panel.add(panel_4, gbc_panel_4);
		GridBagLayout gbl_panel_4 = new GridBagLayout();
		gbl_panel_4.columnWidths = new int[]{0, 0};
		gbl_panel_4.rowHeights = new int[]{0, 0};
		gbl_panel_4.columnWeights = new double[]{1.0, Double.MIN_VALUE};
		gbl_panel_4.rowWeights = new double[]{1.0, Double.MIN_VALUE};
		panel_4.setLayout(gbl_panel_4);

		scrollPane_5 = new JScrollPane();
		GridBagConstraints gbc_scrollPane_5 = new GridBagConstraints();
		gbc_scrollPane_5.fill = GridBagConstraints.BOTH;
		gbc_scrollPane_5.gridx = 0;
		gbc_scrollPane_5.gridy = 0;
		panel_4.add(scrollPane_5, gbc_scrollPane_5);

		tableAreas = new JTable(new ExampleModel());
		tableAreas.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		ListSelectionModel selectionModel2 = tableAreas.getSelectionModel();
		selectionModel2.addListSelectionListener(new ListSelectionListener(){

			@Override
			public void valueChanged(ListSelectionEvent arg0) {

				controller.habilitarDisparos();
				controller.actualizarTablaDerechaEstructuras();
				controller.actualizarRealimentacion();
			}

		});
		scrollPane_5.setViewportView(tableAreas);

		panel_5 = new JPanel();
		GridBagConstraints gbc_panel_5 = new GridBagConstraints();
		gbc_panel_5.fill = GridBagConstraints.BOTH;
		gbc_panel_5.gridx = 3;
		gbc_panel_5.gridy = 1;
		panel.add(panel_5, gbc_panel_5);
		GridBagLayout gbl_panel_5 = new GridBagLayout();
		gbl_panel_5.columnWidths = new int[]{0, 0};
		gbl_panel_5.rowHeights = new int[]{0, 0};
		gbl_panel_5.columnWeights = new double[]{1.0, Double.MIN_VALUE};
		gbl_panel_5.rowWeights = new double[]{1.0, Double.MIN_VALUE};
		panel_5.setLayout(gbl_panel_5);

		scrollPane_6 = new JScrollPane();
		GridBagConstraints gbc_scrollPane_6 = new GridBagConstraints();
		gbc_scrollPane_6.fill = GridBagConstraints.BOTH;
		gbc_scrollPane_6.gridx = 0;
		gbc_scrollPane_6.gridy = 0;
		panel_5.add(scrollPane_6, gbc_scrollPane_6);

		tableEstructurasOtrasAreas = new JTable(new ExampleModel());
		tableEstructurasOtrasAreas.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		ListSelectionModel selectionModel3 = tableEstructurasOtrasAreas.getSelectionModel();
		selectionModel3.addListSelectionListener(new ListSelectionListener(){

			@Override
			public void valueChanged(ListSelectionEvent arg0) {
				controller.habilitarDisparos();
			}

		});
		scrollPane_6.setViewportView(tableEstructurasOtrasAreas);

		panelEstructuras = new JPanel();
		tabbedPane.addTab("Estructuras Importadas", null, panelEstructuras, null);
		GridBagLayout gbl_panelEstructuras = new GridBagLayout();
		gbl_panelEstructuras.columnWidths = new int[]{300, 0, 300, 0};
		gbl_panelEstructuras.rowHeights = new int[]{0, 0};
		gbl_panelEstructuras.columnWeights = new double[]{1.0, 0.0, 1.0, Double.MIN_VALUE};
		gbl_panelEstructuras.rowWeights = new double[]{1.0, Double.MIN_VALUE};
		panelEstructuras.setLayout(gbl_panelEstructuras);

		panelLeft = new JPanel();
		GridBagConstraints gbc_panelLeft = new GridBagConstraints();
		gbc_panelLeft.insets = new Insets(5, 5, 5, 5);
		gbc_panelLeft.fill = GridBagConstraints.BOTH;
		gbc_panelLeft.gridx = 0;
		gbc_panelLeft.gridy = 0;
		panelEstructuras.add(panelLeft, gbc_panelLeft);
		GridBagLayout gbl_panelLeft = new GridBagLayout();
		gbl_panelLeft.columnWidths = new int[]{59, 0};
		gbl_panelLeft.rowHeights = new int[]{14, 0, 0};
		gbl_panelLeft.columnWeights = new double[]{1.0, Double.MIN_VALUE};
		gbl_panelLeft.rowWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
		panelLeft.setLayout(gbl_panelLeft);

		lblEstructuras = new JLabel("Estructuras disponibles:");
		GridBagConstraints gbc_lblEstructuras = new GridBagConstraints();
		gbc_lblEstructuras.insets = new Insets(0, 0, 5, 0);
		gbc_lblEstructuras.anchor = GridBagConstraints.NORTHWEST;
		gbc_lblEstructuras.gridx = 0;
		gbc_lblEstructuras.gridy = 0;
		panelLeft.add(lblEstructuras, gbc_lblEstructuras);

		scrollPane_2 = new JScrollPane();
		GridBagConstraints gbc_scrollPane_2 = new GridBagConstraints();
		gbc_scrollPane_2.fill = GridBagConstraints.BOTH;
		gbc_scrollPane_2.gridx = 0;
		gbc_scrollPane_2.gridy = 1;
		panelLeft.add(scrollPane_2, gbc_scrollPane_2);

		tableEstructurasNoArea = new JTable(new ExampleModel());
		tableEstructurasNoArea.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		ListSelectionModel selectionModel = tableEstructurasNoArea.getSelectionModel();
		selectionModel.addListSelectionListener(new ListSelectionListener(){

			@Override
			public void valueChanged(ListSelectionEvent arg0) {
				controller.habilitarDisparos();

			}

		});
		scrollPane_2.setViewportView(tableEstructurasNoArea);

		panelCenter2 = new JPanel();
		GridBagConstraints gbc_panelCenter2 = new GridBagConstraints();
		gbc_panelCenter2.insets = new Insets(0, 0, 0, 5);
		gbc_panelCenter2.gridx = 1;
		gbc_panelCenter2.gridy = 0;
		panelEstructuras.add(panelCenter2, gbc_panelCenter2);
		GridBagLayout gbl_panelCenter2 = new GridBagLayout();
		gbl_panelCenter2.columnWidths = new int[]{0, 0};
		gbl_panelCenter2.rowHeights = new int[]{0, 0, 0};
		gbl_panelCenter2.columnWeights = new double[]{0.0, Double.MIN_VALUE};
		gbl_panelCenter2.rowWeights = new double[]{0.0, 0.0, Double.MIN_VALUE};
		panelCenter2.setLayout(gbl_panelCenter2);

		dge1button = new JButton("");
		dge1button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.importar();
			}
		});
		dge1button.setIcon(new ImageIcon(EditorAreas.class.getResource("/resources/icons/go-next.png")));
		GridBagConstraints gbc_dge1button = new GridBagConstraints();
		gbc_dge1button.insets = new Insets(0, 0, 5, 0);
		gbc_dge1button.gridx = 0;
		gbc_dge1button.gridy = 0;
		panelCenter2.add(dge1button, gbc_dge1button);

		dge2button = new JButton("");
		dge2button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.desimportar();
			}
		});
		dge2button.setIcon(new ImageIcon(EditorAreas.class.getResource("/resources/icons/go-previous.png")));
		GridBagConstraints gbc_dge2button = new GridBagConstraints();
		gbc_dge2button.gridx = 0;
		gbc_dge2button.gridy = 1;
		panelCenter2.add(dge2button, gbc_dge2button);

		panelRight = new JPanel();
		GridBagConstraints gbc_panelRight = new GridBagConstraints();
		gbc_panelRight.insets = new Insets(5, 5, 5, 5);
		gbc_panelRight.fill = GridBagConstraints.BOTH;
		gbc_panelRight.gridx = 2;
		gbc_panelRight.gridy = 0;
		panelEstructuras.add(panelRight, gbc_panelRight);
		GridBagLayout gbl_panelRight = new GridBagLayout();
		gbl_panelRight.columnWidths = new int[]{139, 0};
		gbl_panelRight.rowHeights = new int[]{14, 0, 0};
		gbl_panelRight.columnWeights = new double[]{1.0, Double.MIN_VALUE};
		gbl_panelRight.rowWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
		panelRight.setLayout(gbl_panelRight);

		lblEstructurasDelrea = new JLabel("Estructuras importadas:");
		GridBagConstraints gbc_lblEstructurasDelrea = new GridBagConstraints();
		gbc_lblEstructurasDelrea.insets = new Insets(0, 0, 5, 0);
		gbc_lblEstructurasDelrea.anchor = GridBagConstraints.NORTHWEST;
		gbc_lblEstructurasDelrea.gridx = 0;
		gbc_lblEstructurasDelrea.gridy = 0;
		panelRight.add(lblEstructurasDelrea, gbc_lblEstructurasDelrea);

		scrollPane_3 = new JScrollPane();
		GridBagConstraints gbc_scrollPane_3 = new GridBagConstraints();
		gbc_scrollPane_3.fill = GridBagConstraints.BOTH;
		gbc_scrollPane_3.gridx = 0;
		gbc_scrollPane_3.gridy = 1;
		panelRight.add(scrollPane_3, gbc_scrollPane_3);

		tableEstructurasArea = new JTable(new ExampleModel());
		tableEstructurasArea.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		ListSelectionModel selectionModel5 = tableEstructurasArea.getSelectionModel();
		selectionModel5.addListSelectionListener(new ListSelectionListener(){

			@Override
			public void valueChanged(ListSelectionEvent arg0) {
				controller.habilitarDisparos();

			}

		});
		scrollPane_3.setViewportView(tableEstructurasArea);

		panelPermisos = new JPanel();
		tabbedPane.addTab("Permisos", null, panelPermisos, null);
		GridBagLayout gbl_panelPermisos = new GridBagLayout();
		gbl_panelPermisos.columnWidths = new int[]{0, 0};
		gbl_panelPermisos.rowHeights = new int[]{0, 0, 0};
		gbl_panelPermisos.columnWeights = new double[]{1.0, Double.MIN_VALUE};
		gbl_panelPermisos.rowWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
		panelPermisos.setLayout(gbl_panelPermisos);

		lblGruposUsuarios = new JLabel("Grupos de usuarios de la aplicaci\u00F3n:");
		GridBagConstraints gbc_lblGruposUsuarios = new GridBagConstraints();
		gbc_lblGruposUsuarios.anchor = GridBagConstraints.WEST;
		gbc_lblGruposUsuarios.insets = new Insets(5, 5, 5, 5);
		gbc_lblGruposUsuarios.gridx = 0;
		gbc_lblGruposUsuarios.gridy = 0;
		panelPermisos.add(lblGruposUsuarios, gbc_lblGruposUsuarios);

		scrollPane_1 = new JScrollPane();
		GridBagConstraints gbc_scrollPane_1 = new GridBagConstraints();
		gbc_scrollPane_1.insets = new Insets(5, 5, 0, 0);
		gbc_scrollPane_1.fill = GridBagConstraints.BOTH;
		gbc_scrollPane_1.gridx = 0;
		gbc_scrollPane_1.gridy = 1;
		panelPermisos.add(scrollPane_1, gbc_scrollPane_1);

		tablePermisos = new JTable(new ExampleModel());
		tablePermisos.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		scrollPane_1.setViewportView(tablePermisos);

		controller = EditorAreasController.getInstance();
		controller.inicializar(this, area, tipoOperacion);

		this.previousWindow = previousWindow;
	}

	public JLabel getLblNombre() {
		return lblNombre;
	}

	public void setLblNombre(JLabel lblNombre) {
		this.lblNombre = lblNombre;
	}

	public JLabel getLblDescripcin() {
		return lblDescripcin;
	}

	public void setLblDescripcin(JLabel lblDescripcin) {
		this.lblDescripcin = lblDescripcin;
	}

	public JLabel getLblFechaCreacin() {
		return lblFechaCreacin;
	}

	public void setLblFechaCreacin(JLabel lblFechaCreacin) {
		this.lblFechaCreacin = lblFechaCreacin;
	}

	public JLabel getLblAutor() {
		return lblAutor;
	}

	public void setLblAutor(JLabel lblAutor) {
		this.lblAutor = lblAutor;
	}

	public JLabel getLblUltModificacin() {
		return lblUltModificacin;
	}

	public void setLblUltModificacin(JLabel lblUltModificacin) {
		this.lblUltModificacin = lblUltModificacin;
	}

	public JLabel getLblAutorModificacin() {
		return lblAutorModificacin;
	}

	public void setLblAutorModificacin(JLabel lblAutorModificacin) {
		this.lblAutorModificacin = lblAutorModificacin;
	}

	public JTextField getTextFieldNombre() {
		return textFieldNombre;
	}

	public void setTextFieldNombre(JTextField textFieldNombre) {
		this.textFieldNombre = textFieldNombre;
	}

	public JTextField getTextFieldCreacion() {
		return textFieldCreacion;
	}

	public void setTextFieldCreacion(JTextField textFieldCreacion) {
		this.textFieldCreacion = textFieldCreacion;
	}

	public JTextField getTextFieldAutor() {
		return textFieldAutor;
	}

	public void setTextFieldAutor(JTextField textFieldAutor) {
		this.textFieldAutor = textFieldAutor;
	}

	public JTextField getTextFieldFechaModificacion() {
		return textFieldFechaModificacion;
	}

	public void setTextFieldFechaModificacion(JTextField textFieldFechaModificacion) {
		this.textFieldFechaModificacion = textFieldFechaModificacion;
	}

	public JTextField getTextFieldAutorModificacion() {
		return textFieldAutorModificacion;
	}

	public void setTextFieldAutorModificacion(JTextField textFieldAutorModificacion) {
		this.textFieldAutorModificacion = textFieldAutorModificacion;
	}

	public JTextArea getTextAreaDescripcion() {
		return textAreaDescripcion;
	}

	public void setTextAreaDescripcion(JTextArea textAreaDescripcion) {
		this.textAreaDescripcion = textAreaDescripcion;
	}

	public JLabel getLblUsuario() {
		return lblUsuario;
	}

	public void setLblUsuario(JLabel lblUsuario) {
		this.lblUsuario = lblUsuario;
	}

	public JLabel getLblGrupos() {
		return lblGrupos;
	}

	public void setLblGrupos(JLabel lblGrupos) {
		this.lblGrupos = lblGrupos;
	}

	public JButton getDea1button() {
		return dea1button;
	}

	public void setDea1button(JButton dea1button) {
		this.dea1button = dea1button;
	}

	public JButton getDea2button() {
		return dea2button;
	}

	public void setDea2button(JButton dea2button) {
		this.dea2button = dea2button;
	}

	public JTable getTablePermisos() {
		return tablePermisos;
	}

	public void setTablePermisos(JTable tablePermisos) {
		this.tablePermisos = tablePermisos;
	}

	public JLabel getLblEstructuras() {
		return lblEstructuras;
	}

	public void setLblEstructuras(JLabel lblEstructuras) {
		this.lblEstructuras = lblEstructuras;
	}

	public JLabel getLblEstructurasDelrea() {
		return lblEstructurasDelrea;
	}

	public void setLblEstructurasDelrea(JLabel lblEstructurasDelrea) {
		this.lblEstructurasDelrea = lblEstructurasDelrea;
	}

	public JTable getTableEstructurasNoArea() {
		return tableEstructurasNoArea;
	}

	public void setTableEstructurasNoArea(JTable tableEstructurasNoArea) {
		this.tableEstructurasNoArea = tableEstructurasNoArea;
	}

	public JTable getTableEstructurasArea() {
		return tableEstructurasArea;
	}

	public void setTableEstructurasArea(JTable tableEstructurasArea) {
		this.tableEstructurasArea = tableEstructurasArea;
	}

	public JButton getDge1button() {
		return dge1button;
	}

	public void setDge1button(JButton dge1button) {
		this.dge1button = dge1button;
	}

	public JButton getDge2button() {
		return dge2button;
	}

	public void setDge2button(JButton dge2button) {
		this.dge2button = dge2button;
	}

	public JLabel getLblGruposUsuarios() {
		return lblGruposUsuarios;
	}

	public void setLblGruposUsuarios(JLabel lblGruposUsuarios) {
		this.lblGruposUsuarios = lblGruposUsuarios;
	}

	public LocalizadorAreasEsquemas getPreviousWindow() {
		return previousWindow;
	}

	public void setPreviousWindow(LocalizadorAreasEsquemas previousWindow) {
		this.previousWindow = previousWindow;
	}

	public JLabel getLblRealimentacion() {
		return lblRealimentacion;
	}

	public void setLblRealimentacion(JLabel lblRealimentacion) {
		this.lblRealimentacion = lblRealimentacion;
	}

	public JButton getBtnDerecha() {
		return btnDerecha;
	}

	public void setBtnDerecha(JButton btnDerecha) {
		this.btnDerecha = btnDerecha;
	}

	public JButton getBtnIzquierda() {
		return btnIzquierda;
	}

	public void setBtnIzquierda(JButton btnIzquierda) {
		this.btnIzquierda = btnIzquierda;
	}

	public JTable getTableEstructurasPropias() {
		return tableEstructurasPropias;
	}

	public void setTableEstructurasPropias(JTable tableEstructurasPropias) {
		this.tableEstructurasPropias = tableEstructurasPropias;
	}

	public JTable getTableAreas() {
		return tableAreas;
	}

	public void setTableAreas(JTable tableAreas) {
		this.tableAreas = tableAreas;
	}

	public JTable getTableEstructurasOtrasAreas() {
		return tableEstructurasOtrasAreas;
	}

	public void setTableEstructurasOtrasAreas(JTable tableEstructurasOtrasAreas) {
		this.tableEstructurasOtrasAreas = tableEstructurasOtrasAreas;
	}

	public JLabel getLblRealimentacion2() {
		return lblRealimentacion2;
	}

	public void setLblRealimentacion2(JLabel lblRealimentacion2) {
		this.lblRealimentacion2 = lblRealimentacion2;
	}



}
