package vista;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.JTextArea;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.JScrollPane;
import javax.swing.JTextPane;

import controlador.EditorDescripcionEstructuraController;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.ScrollPaneConstants;

public class EditorDescripcionEstructura extends JFrame {

	private JPanel contentPane;
	private JScrollPane scrollPane;
	private JTextArea textArea;
	
	private EditorDescripcionEstructuraController controller;
	private EditorEstructuras previousWindow;

	/**
	 * Launch the application.
	 */
//	public static void main(String[] args) {
//		EventQueue.invokeLater(new Runnable() {
//			public void run() {
//				try {
//					EditorDescripcionEstructura frame = new EditorDescripcionEstructura();
//					frame.setVisible(true);
//				} catch (Exception e) {
//					e.printStackTrace();
//				}
//			}
//		});
//	}

	/**
	 * Create the frame.
	 */
	public EditorDescripcionEstructura(EditorEstructuras previousWindow) {
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent arg0) {
				controller.cerrarVentana();
			}
		});
		setTitle("Descripci\u00F3n de");
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		setBounds(100, 100, 450, 300);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(0, 0));
		setContentPane(contentPane);
		
		scrollPane = new JScrollPane();
		contentPane.add(scrollPane, BorderLayout.CENTER);
		
		textArea = new JTextArea();
		textArea.getDocument().addDocumentListener(new DocumentListener() {
			public void changedUpdate(DocumentEvent e) {
				controller.cambiarDescripcion();
			}
			public void removeUpdate(DocumentEvent e) {
				controller.cambiarDescripcion();
			}
			public void insertUpdate(DocumentEvent e) {
				controller.cambiarDescripcion();
			}
		});
		textArea.setLineWrap( true );
		textArea.setWrapStyleWord( true );
		textArea.setSize( textArea.getPreferredSize() );
		scrollPane.setViewportView(textArea);
		
		controller = EditorDescripcionEstructuraController.getInstance();
		this.previousWindow = previousWindow;
		controller.inicializar(previousWindow.getController().getEsquema().getEstructura(), this);
	}

	public JTextArea getTextArea() {
		return textArea;
	}

	public void setTextArea(JTextArea textArea) {
		this.textArea = textArea;
	}

	public EditorDescripcionEstructuraController getController() {
		return controller;
	}

	public void setController(EditorDescripcionEstructuraController controller) {
		this.controller = controller;
	}

	public EditorEstructuras getPreviousWindow() {
		return previousWindow;
	}

	public void setPreviousWindow(EditorEstructuras previousWindow) {
		this.previousWindow = previousWindow;
	}


	
	
}
