package vista;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JTextArea;
import javax.swing.JScrollPane;
import javax.swing.border.LineBorder;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import java.awt.Color;
import javax.swing.JTabbedPane;
import java.awt.FlowLayout;
import javax.swing.JToolBar;
import javax.swing.JButton;
import javax.swing.ImageIcon;
import javax.swing.JTable;

import utils.MSWordUtils;
import utils.ManagerPresentaciones;
import utils.tablemodels.ExampleModel;
import javax.swing.ListSelectionModel;

import controlador.EditorEsquemasController;

import modelo.Esquema;

import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JComboBox;

public class EditorEsquemas extends JFrame {

	private JPanel contentPane;
	private JPanel panelNorth;
	private JPanel panelSouth;
	private JPanel panelCenter;
	private JPanel panelCenterLeft;
	private JLabel lblNombre;
	private JLabel lblDescripcin;
	private JLabel lblFechaCreacin;
	private JLabel lblAutor;
	private JLabel lblUltModificacin;
	private JLabel lblAutorModificacin;
	private JTextField textFieldNombre;
	private JTextField textFieldCreacion;
	private JTextField textFieldAutor;
	private JTextField textFieldFechaModificacion;
	private JTextField textFieldAutorModificacion;
	private JTextArea textAreaDescripcion;
	private JScrollPane scrollPane;
	private JLabel lblUsuario;
	private JLabel lblGrupos;
	private JToolBar toolBar;
	private JButton dee4button;
	private JButton dee5button;
	private JPanel panelCenterRight;
	private JPanel panelLeft;
	private JPanel panelCenter2;
	private JPanel panelRight;
	private JLabel lblEstructuras1;
	private JLabel lblEstructuras2;
	private JTable tableEstructurasNoVisibles;
	private JScrollPane scrollPane_1;
	private JTable tableEstructurasVisibles;
	private JScrollPane scrollPane_2;
	private JButton dge1button;
	private JButton dge2button;
	private JButton dee1button;
	private JButton dee2button;
	private JButton dee3button;
	private LocalizadorAreasEsquemas previousWindow;
	private EditorEsquemasController controller;
	private JLabel lblPresentacin;
	private JComboBox comboBoxPresentacion;


	/**
	 * Create the frame.
	 */
	public EditorEsquemas(LocalizadorAreasEsquemas previousWindow, Esquema esquema, int tipoOperacion) {
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent arg0) {
				controller.cerrarVentana();
			}
		});
		setTitle("Editor de Esquemas");
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		setBounds(100, 100, 900, 600);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(0, 0));
		setContentPane(contentPane);
		
		panelNorth = new JPanel();
		FlowLayout flowLayout_1 = (FlowLayout) panelNorth.getLayout();
		flowLayout_1.setHgap(0);
		flowLayout_1.setVgap(0);
		flowLayout_1.setAlignment(FlowLayout.LEFT);
		contentPane.add(panelNorth, BorderLayout.NORTH);
		
		toolBar = new JToolBar();
		toolBar.setFloatable(false);
		panelNorth.add(toolBar);
		
		dee1button = new JButton("");
		dee1button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.validar();
			}
		});
		dee1button.setIcon(new ImageIcon(EditorEsquemas.class.getResource("/resources/icons/dialog-warning.png")));
		toolBar.add(dee1button);
		
		dee2button = new JButton("");
		dee2button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.generarHTML();
			}
		});
		dee2button.setIcon(new ImageIcon(EditorEsquemas.class.getResource("/resources/icons/html.gif")));
		toolBar.add(dee2button);
		
		dee3button = new JButton("");
		dee3button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.generarWord();
			}
		});
		dee3button.setIcon(new ImageIcon(EditorEsquemas.class.getResource("/resources/icons/word2010.png")));
		toolBar.add(dee3button);
		
		dee4button = new JButton("");
		dee4button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.cerrarVentana();
			}
		});
		dee4button.setIcon(new ImageIcon(EditorEsquemas.class.getResource("/resources/icons/ok_button.png")));
		toolBar.add(dee4button);
		
		dee5button = new JButton("");
		dee5button.setIcon(new ImageIcon(EditorEsquemas.class.getResource("/resources/icons/help-browser.png")));
		toolBar.add(dee5button);
		
		panelSouth = new JPanel();
		FlowLayout flowLayout = (FlowLayout) panelSouth.getLayout();
		flowLayout.setVgap(0);
		flowLayout.setAlignment(FlowLayout.LEFT);
		contentPane.add(panelSouth, BorderLayout.SOUTH);
		
		lblUsuario = new JLabel("Usuario:");
		panelSouth.add(lblUsuario);
		
		lblGrupos = new JLabel("Grupos:");
		panelSouth.add(lblGrupos);
		
		panelCenter = new JPanel();
		contentPane.add(panelCenter, BorderLayout.CENTER);
		GridBagLayout gbl_panelCenter = new GridBagLayout();
		gbl_panelCenter.columnWidths = new int[]{225, 0};
		gbl_panelCenter.rowHeights = new int[]{0, 0};
		gbl_panelCenter.columnWeights = new double[]{0.0, 1.0};
		gbl_panelCenter.rowWeights = new double[]{1.0, Double.MIN_VALUE};
		panelCenter.setLayout(gbl_panelCenter);
		
		panelCenterLeft = new JPanel();
		panelCenterLeft.setBorder(new LineBorder(Color.LIGHT_GRAY));
		GridBagConstraints gbc_panelCenterLeft = new GridBagConstraints();
		gbc_panelCenterLeft.insets = new Insets(0, 0, 0, 5);
		gbc_panelCenterLeft.fill = GridBagConstraints.BOTH;
		gbc_panelCenterLeft.gridx = 0;
		gbc_panelCenterLeft.gridy = 0;
		panelCenter.add(panelCenterLeft, gbc_panelCenterLeft);
		GridBagLayout gbl_panelCenterLeft = new GridBagLayout();
		gbl_panelCenterLeft.columnWidths = new int[]{0, 0, 0};
		gbl_panelCenterLeft.rowHeights = new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0};
		gbl_panelCenterLeft.columnWeights = new double[]{1.0, 1.0, Double.MIN_VALUE};
		gbl_panelCenterLeft.rowWeights = new double[]{0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		panelCenterLeft.setLayout(gbl_panelCenterLeft);
		
		lblNombre = new JLabel("Nombre:");
		GridBagConstraints gbc_lblNombre = new GridBagConstraints();
		gbc_lblNombre.anchor = GridBagConstraints.EAST;
		gbc_lblNombre.insets = new Insets(5, 5, 5, 5);
		gbc_lblNombre.gridx = 0;
		gbc_lblNombre.gridy = 0;
		panelCenterLeft.add(lblNombre, gbc_lblNombre);
		
		textFieldNombre = new JTextField();
		GridBagConstraints gbc_textFieldNombre = new GridBagConstraints();
		gbc_textFieldNombre.insets = new Insets(5, 5, 5, 0);
		gbc_textFieldNombre.fill = GridBagConstraints.HORIZONTAL;
		gbc_textFieldNombre.gridx = 1;
		gbc_textFieldNombre.gridy = 0;
		panelCenterLeft.add(textFieldNombre, gbc_textFieldNombre);
		textFieldNombre.setColumns(10);
		
		lblDescripcin = new JLabel("Descripci\u00F3n:");
		GridBagConstraints gbc_lblDescripcin = new GridBagConstraints();
		gbc_lblDescripcin.anchor = GridBagConstraints.NORTHEAST;
		gbc_lblDescripcin.insets = new Insets(0, 5, 5, 5);
		gbc_lblDescripcin.gridx = 0;
		gbc_lblDescripcin.gridy = 1;
		panelCenterLeft.add(lblDescripcin, gbc_lblDescripcin);
		
		scrollPane = new JScrollPane();
		GridBagConstraints gbc_scrollPane = new GridBagConstraints();
		gbc_scrollPane.fill = GridBagConstraints.BOTH;
		gbc_scrollPane.gridwidth = 2;
		gbc_scrollPane.insets = new Insets(0, 5, 5, 0);
		gbc_scrollPane.gridx = 0;
		gbc_scrollPane.gridy = 2;
		panelCenterLeft.add(scrollPane, gbc_scrollPane);
		
		textAreaDescripcion = new JTextArea();
		textAreaDescripcion.getDocument().addDocumentListener(new DocumentListener() {
			public void changedUpdate(DocumentEvent e) {
				controller.getEsquema().setDescripcion(textAreaDescripcion.getText());
			}
			public void removeUpdate(DocumentEvent e) {
				controller.getEsquema().setDescripcion(textAreaDescripcion.getText());
			}
			public void insertUpdate(DocumentEvent e) {
				controller.getEsquema().setDescripcion(textAreaDescripcion.getText());
			}
		});
		textAreaDescripcion.setLineWrap( true );
		textAreaDescripcion.setWrapStyleWord( true );
		textAreaDescripcion.setSize( textAreaDescripcion.getPreferredSize() );
		scrollPane.setViewportView(textAreaDescripcion);
		
		lblPresentacin = new JLabel("Presentaci\u00F3n:");
		GridBagConstraints gbc_lblPresentacin = new GridBagConstraints();
		gbc_lblPresentacin.anchor = GridBagConstraints.EAST;
		gbc_lblPresentacin.insets = new Insets(9, 0, 5, 5);
		gbc_lblPresentacin.gridx = 0;
		gbc_lblPresentacin.gridy = 3;
		panelCenterLeft.add(lblPresentacin, gbc_lblPresentacin);
		
		ManagerPresentaciones mp = ManagerPresentaciones.getInstance();
		comboBoxPresentacion = new JComboBox(mp.getPresentacionesPublicas().toArray());
		comboBoxPresentacion.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent arg0) {
				controller.cambiarPresentacion();
			}
		});
		GridBagConstraints gbc_comboBoxPresentacion = new GridBagConstraints();
		gbc_comboBoxPresentacion.insets = new Insets(5, 5, 0, 0);
		gbc_comboBoxPresentacion.fill = GridBagConstraints.HORIZONTAL;
		gbc_comboBoxPresentacion.gridx = 1;
		gbc_comboBoxPresentacion.gridy = 3;
		panelCenterLeft.add(comboBoxPresentacion, gbc_comboBoxPresentacion);
		
		lblFechaCreacin = new JLabel("Creaci\u00F3n:");
		GridBagConstraints gbc_lblFechaCreacin = new GridBagConstraints();
		gbc_lblFechaCreacin.anchor = GridBagConstraints.EAST;
		gbc_lblFechaCreacin.insets = new Insets(5, 0, 5, 5);
		gbc_lblFechaCreacin.gridx = 0;
		gbc_lblFechaCreacin.gridy = 4;
		panelCenterLeft.add(lblFechaCreacin, gbc_lblFechaCreacin);
		
		textFieldCreacion = new JTextField();
		textFieldCreacion.setEnabled(false);
		GridBagConstraints gbc_textFieldCreacion = new GridBagConstraints();
		gbc_textFieldCreacion.insets = new Insets(5, 5, 5, 0);
		gbc_textFieldCreacion.fill = GridBagConstraints.HORIZONTAL;
		gbc_textFieldCreacion.gridx = 1;
		gbc_textFieldCreacion.gridy = 4;
		panelCenterLeft.add(textFieldCreacion, gbc_textFieldCreacion);
		textFieldCreacion.setColumns(10);
		
		lblAutor = new JLabel("Autor:");
		GridBagConstraints gbc_lblAutor = new GridBagConstraints();
		gbc_lblAutor.anchor = GridBagConstraints.EAST;
		gbc_lblAutor.insets = new Insets(0, 0, 5, 5);
		gbc_lblAutor.gridx = 0;
		gbc_lblAutor.gridy = 5;
		panelCenterLeft.add(lblAutor, gbc_lblAutor);
		
		textFieldAutor = new JTextField();
		textFieldAutor.setEnabled(false);
		GridBagConstraints gbc_textFieldAutor = new GridBagConstraints();
		gbc_textFieldAutor.insets = new Insets(0, 5, 5, 0);
		gbc_textFieldAutor.fill = GridBagConstraints.HORIZONTAL;
		gbc_textFieldAutor.gridx = 1;
		gbc_textFieldAutor.gridy = 5;
		panelCenterLeft.add(textFieldAutor, gbc_textFieldAutor);
		textFieldAutor.setColumns(10);
		
		lblUltModificacin = new JLabel("Ult. Modificaci\u00F3n:");
		GridBagConstraints gbc_lblUltModificacin = new GridBagConstraints();
		gbc_lblUltModificacin.anchor = GridBagConstraints.EAST;
		gbc_lblUltModificacin.insets = new Insets(0, 0, 5, 5);
		gbc_lblUltModificacin.gridx = 0;
		gbc_lblUltModificacin.gridy = 6;
		panelCenterLeft.add(lblUltModificacin, gbc_lblUltModificacin);
		
		textFieldFechaModificacion = new JTextField();
		textFieldFechaModificacion.setEnabled(false);
		GridBagConstraints gbc_textFieldFechaModificacion = new GridBagConstraints();
		gbc_textFieldFechaModificacion.insets = new Insets(0, 5, 5, 0);
		gbc_textFieldFechaModificacion.fill = GridBagConstraints.HORIZONTAL;
		gbc_textFieldFechaModificacion.gridx = 1;
		gbc_textFieldFechaModificacion.gridy = 6;
		panelCenterLeft.add(textFieldFechaModificacion, gbc_textFieldFechaModificacion);
		textFieldFechaModificacion.setColumns(10);
		
		lblAutorModificacin = new JLabel("Autor Modificaci\u00F3n:");
		GridBagConstraints gbc_lblAutorModificacin = new GridBagConstraints();
		gbc_lblAutorModificacin.anchor = GridBagConstraints.EAST;
		gbc_lblAutorModificacin.insets = new Insets(0, 0, 0, 5);
		gbc_lblAutorModificacin.gridx = 0;
		gbc_lblAutorModificacin.gridy = 7;
		panelCenterLeft.add(lblAutorModificacin, gbc_lblAutorModificacin);
		
		textFieldAutorModificacion = new JTextField();
		textFieldAutorModificacion.setEnabled(false);
		GridBagConstraints gbc_textFieldAutorModificacion = new GridBagConstraints();
		gbc_textFieldAutorModificacion.insets = new Insets(0, 5, 0, 0);
		gbc_textFieldAutorModificacion.fill = GridBagConstraints.HORIZONTAL;
		gbc_textFieldAutorModificacion.gridx = 1;
		gbc_textFieldAutorModificacion.gridy = 7;
		panelCenterLeft.add(textFieldAutorModificacion, gbc_textFieldAutorModificacion);
		textFieldAutorModificacion.setColumns(10);
		
		panelCenterRight = new JPanel();
		GridBagConstraints gbc_panelCenterRight = new GridBagConstraints();
		gbc_panelCenterRight.fill = GridBagConstraints.BOTH;
		gbc_panelCenterRight.gridx = 1;
		gbc_panelCenterRight.gridy = 0;
		panelCenter.add(panelCenterRight, gbc_panelCenterRight);
		GridBagLayout gbl_panelCenterRight = new GridBagLayout();
		gbl_panelCenterRight.columnWidths = new int[]{0, 10, 0, 0};
		gbl_panelCenterRight.rowHeights = new int[]{10, 0};
		gbl_panelCenterRight.columnWeights = new double[]{1.0, 0.0, 1.0, Double.MIN_VALUE};
		gbl_panelCenterRight.rowWeights = new double[]{1.0, Double.MIN_VALUE};
		panelCenterRight.setLayout(gbl_panelCenterRight);
		
		panelLeft = new JPanel();
		GridBagConstraints gbc_panelLeft = new GridBagConstraints();
		gbc_panelLeft.insets = new Insets(0, 0, 0, 5);
		gbc_panelLeft.fill = GridBagConstraints.BOTH;
		gbc_panelLeft.gridx = 0;
		gbc_panelLeft.gridy = 0;
		panelCenterRight.add(panelLeft, gbc_panelLeft);
		GridBagLayout gbl_panelLeft = new GridBagLayout();
		gbl_panelLeft.columnWidths = new int[]{333, 0};
		gbl_panelLeft.rowHeights = new int[]{0, 0, 0};
		gbl_panelLeft.columnWeights = new double[]{1.0, Double.MIN_VALUE};
		gbl_panelLeft.rowWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
		panelLeft.setLayout(gbl_panelLeft);
		
		lblEstructuras1 = new JLabel("Estructuras no visibles:");
		GridBagConstraints gbc_lblEstructuras1 = new GridBagConstraints();
		gbc_lblEstructuras1.insets = new Insets(5, 5, 5, 5);
		gbc_lblEstructuras1.anchor = GridBagConstraints.SOUTHWEST;
		gbc_lblEstructuras1.gridx = 0;
		gbc_lblEstructuras1.gridy = 0;
		panelLeft.add(lblEstructuras1, gbc_lblEstructuras1);
		
		scrollPane_1 = new JScrollPane();
		GridBagConstraints gbc_scrollPane_1 = new GridBagConstraints();
		gbc_scrollPane_1.insets = new Insets(5, 5, 5, 5);
		gbc_scrollPane_1.fill = GridBagConstraints.BOTH;
		gbc_scrollPane_1.gridx = 0;
		gbc_scrollPane_1.gridy = 1;
		panelLeft.add(scrollPane_1, gbc_scrollPane_1);
		
		tableEstructurasNoVisibles = new JTable(new ExampleModel());
		tableEstructurasNoVisibles.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		tableEstructurasNoVisibles.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		ListSelectionModel selectionModel = tableEstructurasNoVisibles.getSelectionModel();
		selectionModel.addListSelectionListener(new ListSelectionListener(){

			@Override
			public void valueChanged(ListSelectionEvent arg0) {
				controller.habilitarDisparos();
				
			}
			
		});
		scrollPane_1.setViewportView(tableEstructurasNoVisibles);
		
		panelCenter2 = new JPanel();
		GridBagConstraints gbc_panelCenter2 = new GridBagConstraints();
		gbc_panelCenter2.insets = new Insets(0, 0, 0, 5);
		gbc_panelCenter2.gridx = 1;
		gbc_panelCenter2.gridy = 0;
		panelCenterRight.add(panelCenter2, gbc_panelCenter2);
		GridBagLayout gbl_panelCenter2 = new GridBagLayout();
		gbl_panelCenter2.columnWidths = new int[]{0, 0};
		gbl_panelCenter2.rowHeights = new int[]{0, 0, 0};
		gbl_panelCenter2.columnWeights = new double[]{0.0, Double.MIN_VALUE};
		gbl_panelCenter2.rowWeights = new double[]{0.0, 0.0, Double.MIN_VALUE};
		panelCenter2.setLayout(gbl_panelCenter2);
		
		dge1button = new JButton("");
		dge1button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.incluirEstructura();
			}
		});
		dge1button.setIcon(new ImageIcon(EditorEsquemas.class.getResource("/resources/icons/go-next.png")));
		GridBagConstraints gbc_dge1button = new GridBagConstraints();
		gbc_dge1button.insets = new Insets(0, 0, 5, 0);
		gbc_dge1button.gridx = 0;
		gbc_dge1button.gridy = 0;
		panelCenter2.add(dge1button, gbc_dge1button);
		
		dge2button = new JButton("");
		dge2button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.excluirEstructura();
			}
		});
		dge2button.setIcon(new ImageIcon(EditorEsquemas.class.getResource("/resources/icons/go-previous.png")));
		GridBagConstraints gbc_dge2button = new GridBagConstraints();
		gbc_dge2button.gridx = 0;
		gbc_dge2button.gridy = 1;
		panelCenter2.add(dge2button, gbc_dge2button);
		
		panelRight = new JPanel();
		GridBagConstraints gbc_panelRight = new GridBagConstraints();
		gbc_panelRight.fill = GridBagConstraints.BOTH;
		gbc_panelRight.gridx = 2;
		gbc_panelRight.gridy = 0;
		panelCenterRight.add(panelRight, gbc_panelRight);
		GridBagLayout gbl_panelRight = new GridBagLayout();
		gbl_panelRight.columnWidths = new int[]{333, 0};
		gbl_panelRight.rowHeights = new int[]{0, 0, 0};
		gbl_panelRight.columnWeights = new double[]{1.0, Double.MIN_VALUE};
		gbl_panelRight.rowWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
		panelRight.setLayout(gbl_panelRight);
		
		lblEstructuras2 = new JLabel("Estructuras visibles:");
		GridBagConstraints gbc_lblEstructuras2 = new GridBagConstraints();
		gbc_lblEstructuras2.anchor = GridBagConstraints.WEST;
		gbc_lblEstructuras2.insets = new Insets(5, 5, 5, 5);
		gbc_lblEstructuras2.gridx = 0;
		gbc_lblEstructuras2.gridy = 0;
		panelRight.add(lblEstructuras2, gbc_lblEstructuras2);
		
		scrollPane_2 = new JScrollPane();
		GridBagConstraints gbc_scrollPane_2 = new GridBagConstraints();
		gbc_scrollPane_2.insets = new Insets(5, 5, 5, 5);
		gbc_scrollPane_2.fill = GridBagConstraints.BOTH;
		gbc_scrollPane_2.gridx = 0;
		gbc_scrollPane_2.gridy = 1;
		panelRight.add(scrollPane_2, gbc_scrollPane_2);
		
		tableEstructurasVisibles = new JTable(new ExampleModel());
		tableEstructurasVisibles.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		tableEstructurasVisibles.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		ListSelectionModel selectionModel2 = tableEstructurasVisibles.getSelectionModel();
		selectionModel2.addListSelectionListener(new ListSelectionListener(){

			@Override
			public void valueChanged(ListSelectionEvent arg0) {
				controller.habilitarDisparos();
				
			}
			
		});
		scrollPane_2.setViewportView(tableEstructurasVisibles);
		
		this.previousWindow = previousWindow;
		controller = EditorEsquemasController.getInstance();
		controller.inicializar(this, esquema, tipoOperacion);
	}


	public JTextField getTextFieldNombre() {
		return textFieldNombre;
	}


	public void setTextFieldNombre(JTextField textFieldNombre) {
		this.textFieldNombre = textFieldNombre;
	}





	public JTextField getTextFieldCreacion() {
		return textFieldCreacion;
	}


	public void setTextFieldCreacion(JTextField textFieldCreacion) {
		this.textFieldCreacion = textFieldCreacion;
	}


	public JTextField getTextFieldAutor() {
		return textFieldAutor;
	}


	public void setTextFieldAutor(JTextField textFieldAutor) {
		this.textFieldAutor = textFieldAutor;
	}


	public JTextField getTextFieldFechaModificacion() {
		return textFieldFechaModificacion;
	}


	public void setTextFieldFechaModificacion(JTextField textFieldFechaModificacion) {
		this.textFieldFechaModificacion = textFieldFechaModificacion;
	}


	public JTextField getTextFieldAutorModificacion() {
		return textFieldAutorModificacion;
	}


	public void setTextFieldAutorModificacion(JTextField textFieldAutorModificacion) {
		this.textFieldAutorModificacion = textFieldAutorModificacion;
	}


	public JTextArea getTextAreaDescripcion() {
		return textAreaDescripcion;
	}


	public void setTextAreaDescripcion(JTextArea textAreaDescripcion) {
		this.textAreaDescripcion = textAreaDescripcion;
	}


	public JButton getDee4button() {
		return dee4button;
	}


	public void setDee4button(JButton dee4button) {
		this.dee4button = dee4button;
	}


	public JButton getDee5button() {
		return dee5button;
	}


	public void setDee5button(JButton dee5button) {
		this.dee5button = dee5button;
	}


	public JTable getTableEstructurasNoVisibles() {
		return tableEstructurasNoVisibles;
	}


	public void setTableEstructurasNoVisibles(JTable tableEstructurasNoVisibles) {
		this.tableEstructurasNoVisibles = tableEstructurasNoVisibles;
	}


	public JTable getTableEstructurasVisibles() {
		return tableEstructurasVisibles;
	}


	public void setTableEstructurasVisibles(JTable tableEstructurasVisibles) {
		this.tableEstructurasVisibles = tableEstructurasVisibles;
	}


	public JButton getDge1button() {
		return dge1button;
	}


	public void setDge1button(JButton dge1button) {
		this.dge1button = dge1button;
	}


	public JButton getDge2button() {
		return dge2button;
	}


	public void setDge2button(JButton dge2button) {
		this.dge2button = dge2button;
	}


	public JButton getDee1button() {
		return dee1button;
	}


	public void setDee1button(JButton dee1button) {
		this.dee1button = dee1button;
	}


	public JButton getDee2button() {
		return dee2button;
	}


	public void setDee2button(JButton dee2button) {
		this.dee2button = dee2button;
	}


	public JButton getDee3button() {
		return dee3button;
	}


	public void setDee3button(JButton dee3button) {
		this.dee3button = dee3button;
	}


	public LocalizadorAreasEsquemas getPreviousWindow() {
		return previousWindow;
	}


	public void setPreviousWindow(LocalizadorAreasEsquemas previousWindow) {
		this.previousWindow = previousWindow;
	}


	public JComboBox getComboBoxPresentacion() {
		return comboBoxPresentacion;
	}


	public void setComboBoxPresentacion(JComboBox comboBoxPresentacion) {
		this.comboBoxPresentacion = comboBoxPresentacion;
	}
	
	

}
