package vista;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.ListSelectionModel;
import javax.swing.border.EmptyBorder;

import controlador.EditorEstructuraDerivadaController;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.JToolBar;
import java.awt.GridLayout;
import javax.swing.JTree;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import javax.swing.JTable;
import javax.swing.JScrollPane;

import utils.tablemodels.ModeloEditorEstructuraDerivada;

import javax.swing.JLabel;
import java.awt.FlowLayout;
import javax.swing.border.LineBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;

import java.awt.Color;
import java.awt.Dimension;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.ImageIcon;
import javax.swing.border.BevelBorder;

public class EditorEstructuraDerivada extends JFrame {

	private JPanel contentPane;
	EditorEstructuraDerivadaController controller;

	JFrame previousWindow;
	private JToolBar toolBar;
	private JTree laecTree;
	private JTable eedTable;
	private JScrollPane laecScrollPane;
	private JScrollPane eedScrollPane;
	private JLabel usuarioLabel;
	private JLabel grupoLabel;
	private JLabel estructuraLabel;
	private JButton deed1button;
	private JButton deed3button;
	private JButton deed4button;
	private JButton deed5button;
	
	/**
	 * Launch the application.
	 */
//	public static void main(String[] args) {
//		EventQueue.invokeLater(new Runnable() {
//			public void run() {
//				try {
//					EditorEstructuraDerivada frame = new EditorEstructuraDerivada();
//					frame.setVisible(true);
//				} catch (Exception e) {
//					e.printStackTrace();
//				}
//			}
//		});
//	}

	/**
	 * Create the frame.
	 */
	public EditorEstructuraDerivada(JFrame previousWindow) {
		setTitle("A\u00F1adir Estructura Derivada");
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				controller.cerrarVentana();
			}
		});
		this.previousWindow = previousWindow;
		
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		setBounds(200, 200, 900, 500);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(0, 0));
		setContentPane(contentPane);
		
		JPanel toolBarPane = new JPanel();
		FlowLayout flowLayout_1 = (FlowLayout) toolBarPane.getLayout();
		flowLayout_1.setAlignment(FlowLayout.LEFT);
		flowLayout_1.setVgap(0);
		flowLayout_1.setHgap(0);
		contentPane.add(toolBarPane, BorderLayout.NORTH);
		
		toolBar = new JToolBar();
		toolBar.setFloatable(false);
		toolBarPane.add(toolBar);
		
		deed1button = new JButton("");
		deed1button.setEnabled(false);
		deed1button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.eliminarComponente();
			}
		});
		deed1button.setIcon(new ImageIcon(EditorEstructuraDerivada.class.getResource("/resources/icons/list-remove.png")));
		deed1button.setToolTipText("Eliminar componente de estructura derivada");
		toolBar.add(deed1button);
		
		deed3button = new JButton("");
		deed3button.setIcon(new ImageIcon(EditorEstructuraDerivada.class.getResource("/resources/icons/edit_selector.png")));
		deed3button.setToolTipText("Agregar o modificar el selector de la estructura derivada.");
		deed3button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.abrirEditorSelector();
			}
		});
		toolBar.add(deed3button);
		
		deed4button = new JButton("");
		deed4button.setEnabled(false);
		deed4button.setMnemonic('d');
		deed4button.setIcon(new ImageIcon(EditorEstructuraDerivada.class.getResource("/resources/icons/ok_button.png")));
		deed4button.setToolTipText("Aplicar los cambios realizados");
		deed4button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.insertarEstructuraDerivada();
				controller.cerrarVentana();
			}
		});
		toolBar.add(deed4button);
		
		deed5button = new JButton("");
		deed5button.setToolTipText("No aplicar los cambios realizados");
		deed5button.setIcon(new ImageIcon(EditorEstructuraDerivada.class.getResource("/resources/icons/cancel_button.png")));
		deed5button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.cerrarVentana();
			}
		});
		toolBar.add(deed5button);
		
		JPanel contentPane2 = new JPanel();
		contentPane2.setBorder(new LineBorder(Color.LIGHT_GRAY));
		contentPane.add(contentPane2, BorderLayout.CENTER);
		GridBagLayout gbl_contentPane2 = new GridBagLayout();
		gbl_contentPane2.columnWidths = new int[]{200, 0, 0};
		gbl_contentPane2.rowHeights = new int[]{216, 0, 0, 0, 0, 0, 0, 0, 0, 0};
		gbl_contentPane2.columnWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
		gbl_contentPane2.rowWeights = new double[]{1.0, 1.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		contentPane2.setLayout(gbl_contentPane2);
		
		laecScrollPane = new JScrollPane();
		GridBagConstraints gbc_laecScrollPane = new GridBagConstraints();
		gbc_laecScrollPane.gridheight = 10;
		gbc_laecScrollPane.fill = GridBagConstraints.BOTH;
		gbc_laecScrollPane.gridx = 0;
		gbc_laecScrollPane.gridy = 0;
		gbc_laecScrollPane.insets.set(5, 0, 5, 0);
		contentPane2.add(laecScrollPane, gbc_laecScrollPane);
		
		laecTree = new JTree(creaArbolEjemplo());
		laecTree.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				int selRow = laecTree.getRowForLocation(e.getX(), e.getY());
		         TreePath selPath = laecTree.getPathForLocation(e.getX(), e.getY());
		         if(selRow != -1) {
		            if(e.getClickCount() == 2) {
		            	 controller.agregarComponente(selPath);
		             }
		         }
			}
		});
		laecScrollPane.setViewportView(laecTree);
		
		eedScrollPane = new JScrollPane();
		GridBagConstraints gbc_eedScrollPane = new GridBagConstraints();
		gbc_eedScrollPane.weightx = 1.0;
		gbc_eedScrollPane.gridheight = 10;
		gbc_eedScrollPane.gridwidth = 9;
		gbc_eedScrollPane.fill = GridBagConstraints.BOTH;
		gbc_eedScrollPane.gridx = 1;
		gbc_eedScrollPane.gridy = 0;
		gbc_eedScrollPane.insets.set(5, 5, 5, 0);
		contentPane2.add(eedScrollPane, gbc_eedScrollPane);
		
		eedTable = new JTable();
		eedTable.setShowHorizontalLines(false);
		eedTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		ListSelectionModel selectionModel = eedTable.getSelectionModel();
		selectionModel.addListSelectionListener(new ListSelectionListener(){

			@Override
			public void valueChanged(ListSelectionEvent arg0) {
				controller.actualizarHabilitacionDisparos();
				
			}
			
		});
		eedScrollPane.setViewportView(eedTable);
		
		JPanel statusBarPane = new JPanel();
		statusBarPane.setBorder(new BevelBorder(BevelBorder.LOWERED, null, null, null, null));
		FlowLayout flowLayout = (FlowLayout) statusBarPane.getLayout();
		flowLayout.setVgap(0);
		flowLayout.setAlignment(FlowLayout.LEFT);
		contentPane.add(statusBarPane, BorderLayout.SOUTH);
		
		usuarioLabel = new JLabel("Usuario: Adam");
		statusBarPane.add(usuarioLabel);
		
		grupoLabel = new JLabel("Grupo: Becario");
		statusBarPane.add(grupoLabel);
		
		estructuraLabel = new JLabel("Estructura: Cliente");
		statusBarPane.add(estructuraLabel);
		
		controller = EditorEstructuraDerivadaController.getInstance();
		controller.inicializar(this);
	}

	public EditorEstructuraDerivadaController getController() {
		return controller;
	}

	public void setController(EditorEstructuraDerivadaController controller) {
		this.controller = controller;
	}

	public JFrame getPreviousWindow() {
		return previousWindow;
	}

	public void setPreviousWindow(JFrame previousWindow) {
		this.previousWindow = previousWindow;
	}

	/* Generacin manual de cdigo */
	
	public DefaultMutableTreeNode creaArbolEjemplo(){
    	DefaultMutableTreeNode areas = new DefaultMutableTreeNode("Areas");
    	for(int i = 1; i < 4; i++){
    		DefaultMutableTreeNode area = new DefaultMutableTreeNode("Area"+i);
    		for(int j = 1; j < 4; j++){
    			DefaultMutableTreeNode estructura = new DefaultMutableTreeNode("Estructura"+j);
        		for(int k = 1; k < 6; k++){
        			DefaultMutableTreeNode componente = new DefaultMutableTreeNode("Componente"+k);
        			estructura.add(componente);
        		}
    			area.add(estructura);
    		}

    		areas.add(area);
    	}
    	return areas;
    }

	public JTree getLaecTree() {
		return laecTree;
	}

	public void setLaecTree(JTree laecTree) {
		this.laecTree = laecTree;
	}

	public JLabel getEstructuraLabel() {
		return estructuraLabel;
	}

	public void setEstructuraLabel(JLabel estructuraLabel) {
		this.estructuraLabel = estructuraLabel;
	}

	public JTable getEedTable() {
		return eedTable;
	}

	public void setEedTable(JTable eedTable) {
		this.eedTable = eedTable;
	}

	public JButton getDeed1button() {
		return deed1button;
	}

	public void setDeed1button(JButton deed1button) {
		this.deed1button = deed1button;
	}

	public JButton getDeed3button() {
		return deed3button;
	}

	public void setDeed3button(JButton deed3button) {
		this.deed3button = deed3button;
	}

	public JButton getDeed4button() {
		return deed4button;
	}

	public void setDeed4button(JButton deed4button) {
		this.deed4button = deed4button;
	}
	
	
	

}
