package vista;

import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import java.awt.BorderLayout;

import javax.swing.DefaultCellEditor;
import javax.swing.InputMap;
import javax.swing.JTextField;
import javax.swing.JToolBar;
import javax.swing.BoxLayout;
import javax.swing.KeyStroke;
import javax.swing.ListSelectionModel;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

import java.awt.Component;
import java.awt.FlowLayout;
import java.awt.GridBagLayout;
import javax.swing.JTree;
import java.awt.GridBagConstraints;
import javax.swing.JTable;
import java.awt.Insets;
import javax.swing.JScrollPane;
import javax.swing.JLabel;
import javax.swing.border.LineBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;
import javax.swing.tree.TreePath;

import utils.listeners.MultiKeyPressListenerEditorEstructuras;
import utils.tablemodels.RXTable;

import java.awt.Color;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JSeparator;
import javax.swing.SwingConstants;

import controlador.EditorEstructurasController;

import java.awt.Dimension;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;
import java.awt.Rectangle;
import javax.swing.ImageIcon;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.border.BevelBorder;
import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;

public class EditorEstructuras {

	private JFrame frmEditorDeEstructuras;
	private EditorEstructurasController controller;
	private JButton decp10button; 
	private JButton decp081button;
	private JButton decp092button;
	private JButton decp082button;
	private JButton decp091button;
	private RXTable ecpTable;
	private JButton decp06button;
	private JButton decp07button;
	private JButton decp03button;
	private JButton decp05button;
	private JButton decp04button;
	private JButton decp02button;
	private JButton decp11button;
	private JComboBox lpComboBox;
	private JButton decp12button;
	private JButton dlae01button;
	private JButton dlae03button;
	private JButton dlae05button;
	private JTree laeTree;
	private JButton dlae04button;
	private JButton dlae06button;
	private JButton decp14button;
	private JButton dlae08button;
	private JSeparator separator_1;
	private JSeparator separator_2;
	private JButton decp13button;
	private JButton decp16button;
	private JButton decp15button;
	private JTextField autortextField;
	private JTextField creaciontextField;
	private JTextField modificaciontextField;
	private JButton btnAreas;
	private JScrollPane ecpScrollPane;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					try {
						// Set System L&F
						UIManager.setLookAndFeel(
								//UIManager.getSystemLookAndFeelClassName());
								UIManager.getSystemLookAndFeelClassName());
					} 
					catch (UnsupportedLookAndFeelException e) {
						// handle exception
					}
					catch (ClassNotFoundException e) {
						// handle exception
					}
					catch (InstantiationException e) {
						// handle exception
					}
					catch (IllegalAccessException e) {
						// handle exception
					}
					EditorEstructuras window = new EditorEstructuras();
					window.frmEditorDeEstructuras.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public EditorEstructuras() {
		initialize();

		controller = EditorEstructurasController.getInstance();
		controller.setView(this);
		controller.inicializar();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		frmEditorDeEstructuras = new JFrame();

		BorderLayout borderLayout = (BorderLayout) frmEditorDeEstructuras.getContentPane().getLayout();
		frmEditorDeEstructuras.setTitle("Editor de Estructuras");
		frmEditorDeEstructuras.setBounds(100, 100, 900, 500);
		frmEditorDeEstructuras.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		//frmEditorDeEstructuras.createBufferStrategy(2);

		JPanel toolBarPanel = new JPanel();
		frmEditorDeEstructuras.getContentPane().add(toolBarPanel, BorderLayout.NORTH);
		GridBagLayout gbl_toolBarPanel = new GridBagLayout();
		gbl_toolBarPanel.columnWidths = new int[]{0, 0, 0};
		gbl_toolBarPanel.rowHeights = new int[]{23, 23, 0, 0};
		gbl_toolBarPanel.columnWeights = new double[]{1.0, 0.0, Double.MIN_VALUE};
		gbl_toolBarPanel.rowWeights = new double[]{0.0, 0.0, 1.0, Double.MIN_VALUE};
		toolBarPanel.setLayout(gbl_toolBarPanel);

		JPanel firstToolBarPanel = new JPanel();
		FlowLayout flowLayout_1 = (FlowLayout) firstToolBarPanel.getLayout();
		flowLayout_1.setVgap(0);
		flowLayout_1.setAlignment(FlowLayout.LEFT);
		GridBagConstraints gbc_firstToolBarPanel = new GridBagConstraints();
		gbc_firstToolBarPanel.insets = new Insets(0, 0, 0, 0);
		gbc_firstToolBarPanel.anchor = GridBagConstraints.WEST;
		gbc_firstToolBarPanel.gridx = 0;
		gbc_firstToolBarPanel.gridy = 0;
		toolBarPanel.add(firstToolBarPanel, gbc_firstToolBarPanel);

		JToolBar firstToolBar = new JToolBar();
		firstToolBar.setFloatable(false);
		firstToolBarPanel.add(firstToolBar);
		firstToolBar.setAlignmentX(Component.LEFT_ALIGNMENT);

		dlae01button = new JButton("");
		dlae01button.setFocusable(false);
		dlae01button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				/* Si se pulsa un botn mientras se est editando una celda, se guardan los cambios */
				if (getEcpTable().isEditing())
					getEcpTable().getCellEditor().stopCellEditing();
				controller.nuevaEstructura();
			}
		});
		dlae01button.setIcon(new ImageIcon(EditorEstructuras.class.getResource("/resources/icons/document-new.png")));
		dlae01button.setToolTipText("Nueva estructura");
		dlae01button.addKeyListener(new MultiKeyPressListenerEditorEstructuras());
		firstToolBar.add(dlae01button);

		dlae05button = new JButton("");
		dlae05button.setFocusable(false);
		dlae05button.setEnabled(false);
		dlae05button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				/* Si se pulsa un botn mientras se est editando una celda, se guardan los cambios */
				if (getEcpTable().isEditing())
					getEcpTable().getCellEditor().stopCellEditing();
				controller.guardarEstructura();
			}
		});
		dlae05button.addKeyListener(new MultiKeyPressListenerEditorEstructuras());
		dlae05button.setToolTipText("Guardar estructura");
		dlae05button.setIcon(new ImageIcon(EditorEstructuras.class.getResource("/resources/icons/document-save.png")));
		firstToolBar.add(dlae05button);

		dlae03button = new JButton("");
		dlae03button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.eliminarEstructura();
			}
		});
		dlae03button.setFocusable(false);
		dlae03button.setEnabled(false);
		dlae03button.setIcon(new ImageIcon(EditorEstructuras.class.getResource("/resources/icons/mail-mark-junk.png")));
		dlae03button.setToolTipText("Eliminar estructura");
		dlae03button.addKeyListener(new MultiKeyPressListenerEditorEstructuras());
		firstToolBar.add(dlae03button);

		dlae04button = new JButton("");
		dlae04button.setFocusable(false);
		dlae04button.setEnabled(false);
		dlae04button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				/* Si se pulsa un botn mientras se est editando una celda, se guardan los cambios */
				if (getEcpTable().isEditing())
					getEcpTable().getCellEditor().stopCellEditing();
				controller.validar();
			}
		});
		dlae04button.setIcon(new ImageIcon(EditorEstructuras.class.getResource("/resources/icons/dialog-warning.png")));
		dlae04button.addKeyListener(new MultiKeyPressListenerEditorEstructuras());

		separator_2 = new JSeparator();
		separator_2.setOrientation(SwingConstants.VERTICAL);
		firstToolBar.add(separator_2);

		decp14button = new JButton("");
		firstToolBar.add(decp14button);
		decp14button.setEnabled(false);
		decp14button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				/* Si se pulsa un botn mientras se est editando una celda, se guardan los cambios */
				if (getEcpTable().isEditing())
					getEcpTable().getCellEditor().stopCellEditing();
				controller.modificarDescripcion();
			}
		});
		decp14button.setFocusable(false);
		decp14button.setIcon(new ImageIcon(EditorEstructuras.class.getResource("/resources/icons/text-x-generic.png")));
		decp14button.setToolTipText("Modificar la descripci\u00F3n de la estructura (CTRL + N)");
		decp14button.addKeyListener(new MultiKeyPressListenerEditorEstructuras());
		dlae04button.setToolTipText("Validar estructura");
		firstToolBar.add(dlae04button);

		dlae06button = new JButton("");
		dlae06button.setFocusable(false);
		dlae06button.setEnabled(false);
		dlae06button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				/* Si se pulsa un botn mientras se est editando una celda, se guardan los cambios */
				if (getEcpTable().isEditing())
					getEcpTable().getCellEditor().stopCellEditing();
				controller.generarHTML();
			}
		});
		dlae06button.setIcon(new ImageIcon(EditorEstructuras.class.getResource("/resources/icons/html.gif")));
		dlae06button.setToolTipText("Generar documento HTML");
		dlae06button.addKeyListener(new MultiKeyPressListenerEditorEstructuras());
		firstToolBar.add(dlae06button);

		dlae08button = new JButton("");
		dlae08button.setEnabled(false);
		dlae08button.setFocusable(false);
		dlae08button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				/* Si se pulsa un botn mientras se est editando una celda, se guardan los cambios */
				if (getEcpTable().isEditing())
					getEcpTable().getCellEditor().stopCellEditing();
				controller.generarWord();
			}
		});
		dlae08button.setToolTipText("Generar documento MS Word");
		dlae08button.setIcon(new ImageIcon(EditorEstructuras.class.getResource("/resources/icons/word2010.png")));
		firstToolBar.add(dlae08button);

		separator_1 = new JSeparator();
		separator_1.setOrientation(SwingConstants.VERTICAL);
		firstToolBar.add(separator_1);

		btnAreas = new JButton("");
		btnAreas.setFocusable(false);	
		btnAreas.setIcon(new ImageIcon(EditorEstructuras.class.getResource("/resources/icons/system-file-manager.png")));
		btnAreas.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.abrirEditorAreas();
			}
		});
		firstToolBar.add(btnAreas);

		decp13button = new JButton("");
		decp13button.setFocusable(false);
		decp13button.setToolTipText("Abrir ventana de edici\u00F3n de presentaciones (CTRL + P)");
		decp13button.setIcon(new ImageIcon(EditorEstructuras.class.getResource("/resources/icons/view_text.png")));
		firstToolBar.add(decp13button);

		decp16button = new JButton("");
		decp16button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				/* Si se pulsa un botn mientras se est editando una celda, se guardan los cambios */
				if (getEcpTable().isEditing())
					getEcpTable().getCellEditor().stopCellEditing();
				controller.abrirGestionUsuarios();
			}
		});
		decp16button.setFocusable(false);
		decp16button.setIcon(new ImageIcon(EditorEstructuras.class.getResource("/resources/icons/user_info_panel.png")));
		decp16button.setToolTipText("Abrir ventana de gesti\u00F3n de usuarios (CTRL + U)");
		firstToolBar.add(decp16button);

		decp15button = new JButton("");
		decp15button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.abrirGestionGrupos();
			}
		});
		decp15button.setFocusable(false);
		decp15button.setIcon(new ImageIcon(EditorEstructuras.class.getResource("/resources/icons/system-users.png")));
		decp15button.setToolTipText("Abrir ventana de gesti\u00F3n de grupos de usuarios (CTRL + G)");
		firstToolBar.add(decp15button);
		decp13button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				/* Si se pulsa un botn mientras se est editando una celda, se guardan los cambios */
				if (getEcpTable().isEditing())
					getEcpTable().getCellEditor().stopCellEditing();
				controller.abrirEditorPresentaciones();
			}
		});
		decp13button.addKeyListener(new MultiKeyPressListenerEditorEstructuras());



		JPanel secondToolBarPanel = new JPanel();
		FlowLayout flowLayout = (FlowLayout) secondToolBarPanel.getLayout();
		flowLayout.setAlignment(FlowLayout.LEFT);
		flowLayout.setVgap(0);
		GridBagConstraints gbc_secondToolBarPanel = new GridBagConstraints();
		gbc_secondToolBarPanel.anchor = GridBagConstraints.WEST;
		gbc_secondToolBarPanel.gridx = 0;
		gbc_secondToolBarPanel.gridy = 1;
		toolBarPanel.add(secondToolBarPanel, gbc_secondToolBarPanel);

		JToolBar secondToolBar = new JToolBar();
		secondToolBar.setFloatable(false);
		secondToolBarPanel.add(secondToolBar);

		decp02button = new JButton("");
		decp02button.setFocusable(false);
		decp02button.setEnabled(false);
		decp02button.setIcon(new ImageIcon(EditorEstructuras.class.getResource("/resources/icons/edit-tipo.png")));
		decp02button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				/* Si se pulsa un botn mientras se est editando una celda, se guardan los cambios */
				if (getEcpTable().isEditing())
					getEcpTable().getCellEditor().stopCellEditing();
				controller.modificarTipo();
			}
		});
		decp02button.addKeyListener(new MultiKeyPressListenerEditorEstructuras());

		decp06button = new JButton("");
		decp06button.setFocusable(false);
		decp06button.setEnabled(false);
		decp06button.setIcon(new ImageIcon(EditorEstructuras.class.getResource("/resources/icons/list-add.png")));
		decp06button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				/* Si se pulsa un botn mientras se est editando una celda, se guardan los cambios */
				if (getEcpTable().isEditing())
					getEcpTable().getCellEditor().stopCellEditing();
				controller.agregarComponente();
			}
		});
		decp06button.setToolTipText("A\u00F1adir componente (CTRL + A)");
		decp06button.addKeyListener(new MultiKeyPressListenerEditorEstructuras());

		secondToolBar.add(decp06button);

		decp07button = new JButton("");
		decp07button.setFocusable(false);
		decp07button.setEnabled(false);
		decp07button.setIcon(new ImageIcon(EditorEstructuras.class.getResource("/resources/icons/list-remove.png")));
		decp07button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				/* Si se pulsa un botn mientras se est editando una celda, se guardan los cambios */
				if (getEcpTable().isEditing())
					getEcpTable().getCellEditor().stopCellEditing();
				controller.eliminarComponente();
			}
		});
		decp07button.setToolTipText("Eliminar Componente (CTRL + E)");
		decp07button.addKeyListener(new MultiKeyPressListenerEditorEstructuras());
		secondToolBar.add(decp07button);

		decp04button = new JButton("");
		decp04button.setFocusable(false);
		decp04button.setEnabled(false);
		decp04button.setIcon(new ImageIcon(EditorEstructuras.class.getResource("/resources/icons/edit-iteracion.png")));
		decp04button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				/* Si se pulsa un botn mientras se est editando una celda, se guardan los cambios */
				if (getEcpTable().isEditing())
					getEcpTable().getCellEditor().stopCellEditing();
				controller.modificarIteracion();
			}
		});
		decp04button.setToolTipText("Alternar entre los posibles tipos de iteraci\u00F3n de una componente compuesta (CTRL + I)");
		decp04button.addKeyListener(new MultiKeyPressListenerEditorEstructuras());
		secondToolBar.add(decp04button);

		decp05button = new JButton("");
		decp05button.setFocusable(false);
		decp05button.setEnabled(false);
		decp05button.setIcon(new ImageIcon(EditorEstructuras.class.getResource("/resources/icons/edit-opcionalidad.png")));
		decp05button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				/* Si se pulsa un botn mientras se est editando una celda, se guardan los cambios */
				if (getEcpTable().isEditing())
					getEcpTable().getCellEditor().stopCellEditing();
				controller.modificarOpcionalidad();
			}
		});
		decp05button.setToolTipText("Establecer la componente seleccionada como optativa o no optativa. (CTRL + O)");
		decp05button.addKeyListener(new MultiKeyPressListenerEditorEstructuras());
		secondToolBar.add(decp05button);
		decp02button.setToolTipText("Convertir una agregaci\u00F3n en una especializaci\u00F3n, o viceversa. (CTRL + T)");
		secondToolBar.add(decp02button);

		decp03button = new JButton("");
		decp03button.setFocusable(false);
		decp03button.setEnabled(false);
		decp03button.setIcon(new ImageIcon(EditorEstructuras.class.getResource("/resources/icons/edit-clase.png")));
		decp03button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				/* Si se pulsa un botn mientras se est editando una celda, se guardan los cambios */
				if (getEcpTable().isEditing())
					getEcpTable().getCellEditor().stopCellEditing();
				controller.modificarClase();
			}
		});
		decp03button.setToolTipText("Conversi\u00F3n de una componente elemental en una componente compuesta, o viceversa. (CTRL + C)");
		decp03button.addKeyListener(new MultiKeyPressListenerEditorEstructuras());
		secondToolBar.add(decp03button);

		decp10button = new JButton("");
		decp10button.setFocusable(false);
		decp10button.setToolTipText("Insertar o modificar una estructura derivada. (CTRL + D)");
		decp10button.setIcon(new ImageIcon(EditorEstructuras.class.getResource("/resources/icons/editor_estructura_derivada.png")));
		decp10button.setEnabled(false);
		decp10button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				/* Si se pulsa un botn mientras se est editando una celda, se guardan los cambios */
				if (getEcpTable().isEditing())
					getEcpTable().getCellEditor().stopCellEditing();
				controller.abrirEditorEstructuraDerivada();
			}
		});
		decp10button.addKeyListener(new MultiKeyPressListenerEditorEstructuras());
		secondToolBar.add(decp10button);

		decp11button = new JButton("");
		decp11button.setFocusable(false);
		decp11button.setEnabled(false);
		decp11button.setToolTipText("Deshacer (CTRL + Z)");
		decp11button.setIcon(new ImageIcon(EditorEstructuras.class.getResource("/resources/icons/edit-undo.png")));
		decp11button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				/* Si se pulsa un botn mientras se est editando una celda, se guardan los cambios */
				if (getEcpTable().isEditing())
					getEcpTable().getCellEditor().stopCellEditing();
				controller.deshacer();
			}
		});
		decp11button.addKeyListener(new MultiKeyPressListenerEditorEstructuras());
		secondToolBar.add(decp11button);

		decp12button = new JButton("");
		decp12button.setFocusable(false);
		decp12button.setEnabled(false);
		decp12button.setToolTipText("Rehacer (CTRL + Y)");
		decp12button.setIcon(new ImageIcon(EditorEstructuras.class.getResource("/resources/icons/edit-redo.png")));
		decp12button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				/* Si se pulsa un botn mientras se est editando una celda, se guardan los cambios */
				if (getEcpTable().isEditing())
					getEcpTable().getCellEditor().stopCellEditing();
				controller.rehacer();
			}
		});
		decp12button.addKeyListener(new MultiKeyPressListenerEditorEstructuras());
		secondToolBar.add(decp12button);

		JSeparator separator = new JSeparator();
		secondToolBar.add(separator);
		separator.setOrientation(SwingConstants.VERTICAL);

		JLabel presentacionLabel = new JLabel("Presentaci\u00F3n:");
		secondToolBarPanel.add(presentacionLabel);

		//DefaultComboBoxModel cbm = new DefaultComboBoxModel(new String[]{"Presentacin 1", "Presentacin 2", "Presentacin3"});
		lpComboBox = new JComboBox();
		lpComboBox.setFocusable(false);
		lpComboBox.setEnabled(false);
		lpComboBox.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent arg0) {
				/* Si se pulsa un botn mientras se est editando una celda, se guardan los cambios */
				if (getEcpTable().isEditing())
					getEcpTable().getCellEditor().stopCellEditing();
				controller.cambiarPresentacion();
			}
		});
		lpComboBox.addKeyListener(new MultiKeyPressListenerEditorEstructuras());
		secondToolBarPanel.add(lpComboBox);

		JPanel arrowsPane = new JPanel();
		GridBagConstraints gbc_arrowsPane = new GridBagConstraints();
		gbc_arrowsPane.insets.set(0, 10, 0, 0);
		gbc_arrowsPane.gridheight = 2;
		gbc_arrowsPane.fill = GridBagConstraints.BOTH;
		gbc_arrowsPane.gridx = 1;
		gbc_arrowsPane.gridy = 0;
		toolBarPanel.add(arrowsPane, gbc_arrowsPane);
		GridBagLayout gbl_arrowsPane = new GridBagLayout();
		gbl_arrowsPane.columnWidths = new int[]{0, 0, 0, 0};
		gbl_arrowsPane.rowHeights = new int[]{0, 0, 0};
		gbl_arrowsPane.columnWeights = new double[]{0.0, 0.0, 0.0, Double.MIN_VALUE};
		gbl_arrowsPane.rowWeights = new double[]{0.0, 0.0, Double.MIN_VALUE};
		arrowsPane.setLayout(gbl_arrowsPane);

		decp081button = new JButton("");
		decp081button.setFocusable(false);
		decp081button.setToolTipText("Mover hacia arriba (CTRL + Flecha Arriba)");
		decp081button.setEnabled(false);
		decp081button.setIcon(new ImageIcon(EditorEstructuras.class.getResource("/resources/icons/go-up.png")));
		decp081button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				/* Si se pulsa un botn mientras se est editando una celda, se guardan los cambios */
				if (getEcpTable().isEditing())
					getEcpTable().getCellEditor().stopCellEditing();
				controller.desplazarHaciaArriba();
			}
		});
		decp081button.addKeyListener(new MultiKeyPressListenerEditorEstructuras());
		GridBagConstraints gbc_decp081button = new GridBagConstraints();
		gbc_decp081button.insets = new Insets(0, 0, 0, 5);
		gbc_decp081button.gridx = 1;
		gbc_decp081button.gridy = 0;
		arrowsPane.add(decp081button, gbc_decp081button);

		decp092button = new JButton("");
		decp092button.setFocusable(false);
		decp092button.setToolTipText("Mover hacia izquierda (CTRL + Flecha izquierda)");
		decp092button.setEnabled(false);
		decp092button.setIcon(new ImageIcon(EditorEstructuras.class.getResource("/resources/icons/go-previous.png")));
		decp092button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				/* Si se pulsa un botn mientras se est editando una celda, se guardan los cambios */
				if (getEcpTable().isEditing())
					getEcpTable().getCellEditor().stopCellEditing();
				controller.desplazarHaciaIzquierda();
			}
		});
		decp092button.addKeyListener(new MultiKeyPressListenerEditorEstructuras());
		GridBagConstraints gbc_decp092button = new GridBagConstraints();
		gbc_decp092button.insets = new Insets(0, 0, 0, 5);
		gbc_decp092button.gridx = 0;
		gbc_decp092button.gridy = 1;
		arrowsPane.add(decp092button, gbc_decp092button);

		decp082button = new JButton("");
		decp082button.setFocusable(false);
		decp082button.setToolTipText("Mover hacia abajo (CTRL + Flecha Abajo)");
		decp082button.setEnabled(false);
		decp082button.setIcon(new ImageIcon(EditorEstructuras.class.getResource("/resources/icons/go-down.png")));
		decp082button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				/* Si se pulsa un botn mientras se est editando una celda, se guardan los cambios */
				if (getEcpTable().isEditing())
					getEcpTable().getCellEditor().stopCellEditing();
				controller.desplazarHaciaAbajo();
			}
		});
		decp082button.addKeyListener(new MultiKeyPressListenerEditorEstructuras());
		GridBagConstraints gbc_decp082button = new GridBagConstraints();
		gbc_decp082button.insets = new Insets(0, 0, 0, 5);
		gbc_decp082button.gridx = 1;
		gbc_decp082button.gridy = 1;
		arrowsPane.add(decp082button, gbc_decp082button);

		decp091button = new JButton("");
		decp091button.setFocusable(false);
		decp091button.setToolTipText("Mover hacia derecha (CTRL + Flecha Derecha)");
		decp091button.setEnabled(false);
		decp091button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				/* Si se pulsa un botn mientras se est editando una celda, se guardan los cambios */
				if (getEcpTable().isEditing())
					getEcpTable().getCellEditor().stopCellEditing();
				controller.desplazarHaciaDerecha();
			}
		});
		decp091button.addKeyListener(new MultiKeyPressListenerEditorEstructuras());
		decp091button.setIcon(new ImageIcon(EditorEstructuras.class.getResource("/resources/icons/go-next.png")));
		GridBagConstraints gbc_decp091button = new GridBagConstraints();
		gbc_decp091button.gridx = 2;
		gbc_decp091button.gridy = 1;
		arrowsPane.add(decp091button, gbc_decp091button);

		JPanel contentPanel = new JPanel();
		contentPanel.setBorder(new LineBorder(Color.LIGHT_GRAY));
		frmEditorDeEstructuras.getContentPane().add(contentPanel, BorderLayout.CENTER);
		GridBagLayout gbl_contentPanel = new GridBagLayout();
		gbl_contentPanel.columnWidths = new int[]{200, 0, 0, 0, 0, 0, 0, 0, 0, 0};
		gbl_contentPanel.rowWeights = new double[]{1.0, 0.0};
		gbl_contentPanel.columnWeights = new double[]{0.0, 1.0};

		contentPanel.setLayout(gbl_contentPanel);

		JScrollPane laeScrollPane = new JScrollPane();
		laeScrollPane.setBounds(new Rectangle(5, 5, 0, 0));
		GridBagConstraints gbc_laeScrollPane = new GridBagConstraints();
		gbc_laeScrollPane.gridheight = 9;
		gbc_laeScrollPane.fill = GridBagConstraints.BOTH;
		gbc_laeScrollPane.gridx = 0;
		gbc_laeScrollPane.gridy = 0;
		gbc_laeScrollPane.insets.set(5, 5, 0, 5);
		contentPanel.add(laeScrollPane, gbc_laeScrollPane);

		laeTree = new JTree();
		laeTree.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				/* Si se pulsa un botn mientras se est editando una celda, se guardan los cambios */
				if (getEcpTable().isEditing())
					getEcpTable().getCellEditor().stopCellEditing();

				int selRow = laeTree.getRowForLocation(e.getX(), e.getY());
				TreePath selPath = laeTree.getPathForLocation(e.getX(), e.getY());
				if(selRow != -1) {
					if(e.getClickCount() == 2) {
						if(selPath.getPathCount() == 3)
							controller.abrirEstructuraDesdeArbol(selPath);
					}
				}
			}
		});
		laeTree.setDoubleBuffered(true);
		laeScrollPane.setViewportView(laeTree);

		ecpScrollPane = new JScrollPane();
		ecpScrollPane.addKeyListener(new MultiKeyPressListenerEditorEstructuras());
		GridBagConstraints gbc_ecpScrollPane = new GridBagConstraints();
		gbc_ecpScrollPane.weighty = 1.0;
		gbc_ecpScrollPane.weightx = 1.0;
		gbc_ecpScrollPane.fill = GridBagConstraints.BOTH;
		gbc_ecpScrollPane.gridheight = 10;
		gbc_ecpScrollPane.gridwidth = 9;
		gbc_ecpScrollPane.gridx = 1;
		gbc_ecpScrollPane.gridy = 0;
		gbc_ecpScrollPane.insets.set(5, 0, 5, 5);
		contentPanel.add(ecpScrollPane, gbc_ecpScrollPane);


		ecpTable = new RXTable(){
			/*
			 Cdigo a partir de http://www.java-forums.org/awt-swing/14821-jtable-jscrollpane-renders-partly-invisible.html
			 */
			@Override
			public Component prepareRenderer(TableCellRenderer renderer, int row,
					int column) {
				Component component = super.prepareRenderer(renderer, row, column);
				int rendererWidth = component.getPreferredSize().width;
				TableColumn tableColumn = getColumnModel().getColumn(column);
				tableColumn.setPreferredWidth(Math.max(rendererWidth +
						getIntercellSpacing().width,
						tableColumn.getPreferredWidth()));
				return  component;
			}

			//	         public void changeSelection(
			//	        		 int row, int column, boolean toggle, boolean extend)
			//	         {
			//	        	 super.changeSelection(row, column, toggle, extend);
			//
			//	        	 if (editCellAt(row, column))
			//	        	 {
			//	        		 Component editor = getEditorComponent();
			//	        		 editor.requestFocusInWindow();
			//	        		((JTextComponent)editor).selectAll();
			//	        	 }
			//	         }
		};
		ecpTable.setCellSelectionEnabled(true);
		ecpTable.setSelectAllForEdit(true);
		ecpTable.setShowHorizontalLines(false);
		ecpTable.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
		ecpTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		InputMap im = ecpTable.getInputMap(JTable.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
		// deshabilitar las combinaciones de teclas porque si no se ralla
		im.put(KeyStroke.getKeyStroke(KeyEvent.VK_DOWN, InputEvent.SHIFT_DOWN_MASK), "none");
		im.put(KeyStroke.getKeyStroke(KeyEvent.VK_UP, InputEvent.SHIFT_DOWN_MASK), "none");
		im.put(KeyStroke.getKeyStroke(KeyEvent.VK_LEFT, InputEvent.SHIFT_DOWN_MASK), "none");
		im.put(KeyStroke.getKeyStroke(KeyEvent.VK_RIGHT, InputEvent.CTRL_DOWN_MASK), "none");
		im.put(KeyStroke.getKeyStroke(KeyEvent.VK_A, InputEvent.CTRL_DOWN_MASK), "none");
		ecpTable.addKeyListener(new MultiKeyPressListenerEditorEstructuras());


		// Listener de cambio de seleccin de fila

		ListSelectionModel selectionModel = ecpTable.getSelectionModel();
		selectionModel.addListSelectionListener(new ListSelectionListener(){

			@Override
			public void valueChanged(ListSelectionEvent arg0) {
				controller.actualizarHabilitacionDisparos();

			}

		});
		ecpScrollPane.setViewportView(ecpTable);

		JPanel realimentacionPanel = new JPanel();
		realimentacionPanel.setBorder(new LineBorder(Color.LIGHT_GRAY));
		GridBagConstraints gbc_realimentacionPanel = new GridBagConstraints();
		gbc_realimentacionPanel.fill = GridBagConstraints.BOTH;
		gbc_realimentacionPanel.gridx = 0;
		gbc_realimentacionPanel.gridy = 9;
		gbc_realimentacionPanel.insets.set(5, 5, 5, 5);
		contentPanel.add(realimentacionPanel, gbc_realimentacionPanel);
		GridBagLayout gbl_realimentacionPanel = new GridBagLayout();
		gbl_realimentacionPanel.columnWidths = new int[]{65, 0, 0};
		gbl_realimentacionPanel.rowHeights = new int[]{14, 14, 14, 0};
		gbl_realimentacionPanel.columnWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
		gbl_realimentacionPanel.rowWeights = new double[]{0.0, 0.0, 0.0, Double.MIN_VALUE};
		realimentacionPanel.setLayout(gbl_realimentacionPanel);

		JLabel autorLabel = new JLabel("Autor: ");
		GridBagConstraints gbc_autorLabel = new GridBagConstraints();
		gbc_autorLabel.anchor = GridBagConstraints.EAST;
		gbc_autorLabel.insets = new Insets(5, 5, 5, 5);
		gbc_autorLabel.gridx = 0;
		gbc_autorLabel.gridy = 0;
		realimentacionPanel.add(autorLabel, gbc_autorLabel);

		autortextField = new JTextField();
		autortextField.setEnabled(false);
		GridBagConstraints gbc_autortextField = new GridBagConstraints();
		gbc_autortextField.insets = new Insets(5, 5, 5, 5);
		gbc_autortextField.fill = GridBagConstraints.HORIZONTAL;
		gbc_autortextField.gridx = 1;
		gbc_autortextField.gridy = 0;
		realimentacionPanel.add(autortextField, gbc_autortextField);
		autortextField.setColumns(10);

		JLabel creacionLabel = new JLabel("Creacin: ");
		GridBagConstraints gbc_creacionLabel = new GridBagConstraints();
		gbc_creacionLabel.anchor = GridBagConstraints.EAST;
		gbc_creacionLabel.insets = new Insets(5, 5, 5, 5);
		gbc_creacionLabel.gridx = 0;
		gbc_creacionLabel.gridy = 1;
		realimentacionPanel.add(creacionLabel, gbc_creacionLabel);

		creaciontextField = new JTextField();
		creaciontextField.setEnabled(false);
		GridBagConstraints gbc_creaciontextField = new GridBagConstraints();
		gbc_creaciontextField.insets = new Insets(5, 5, 5, 5);
		gbc_creaciontextField.fill = GridBagConstraints.HORIZONTAL;
		gbc_creaciontextField.gridx = 1;
		gbc_creaciontextField.gridy = 1;
		realimentacionPanel.add(creaciontextField, gbc_creaciontextField);
		creaciontextField.setColumns(10);

		JLabel modificacionLabel = new JLabel("Modificacin: ");
		GridBagConstraints gbc_modificacionLabel = new GridBagConstraints();
		gbc_modificacionLabel.insets = new Insets(5, 5, 5, 5);
		gbc_modificacionLabel.anchor = GridBagConstraints.EAST;
		gbc_modificacionLabel.gridx = 0;
		gbc_modificacionLabel.gridy = 2;
		realimentacionPanel.add(modificacionLabel, gbc_modificacionLabel);

		modificaciontextField = new JTextField();
		modificaciontextField.setEnabled(false);
		GridBagConstraints gbc_modificaciontextField = new GridBagConstraints();
		gbc_modificaciontextField.insets = new Insets(5, 5, 5, 5);
		gbc_modificaciontextField.fill = GridBagConstraints.HORIZONTAL;
		gbc_modificaciontextField.gridx = 1;
		gbc_modificaciontextField.gridy = 2;
		realimentacionPanel.add(modificaciontextField, gbc_modificaciontextField);
		modificaciontextField.setColumns(10);

		JPanel statusBarPanel = new JPanel();
		statusBarPanel.setBorder(new BevelBorder(BevelBorder.LOWERED, null, null, null, null));
		FlowLayout flowLayout_2 = (FlowLayout) statusBarPanel.getLayout();
		flowLayout_2.setVgap(2);
		flowLayout_2.setAlignment(FlowLayout.LEFT);
		flowLayout_2.setHgap(10);
		frmEditorDeEstructuras.getContentPane().add(statusBarPanel, BorderLayout.SOUTH);

		JLabel lblUsuarioAdam = new JLabel("Usuario: Adam");
		statusBarPanel.add(lblUsuarioAdam);

		JLabel lblGrupoBecario = new JLabel("Grupo: Becario");
		statusBarPanel.add(lblGrupoBecario);
	}



	/* Generacin manual de cdigo */

	public JTree getLaeTree() {
		return laeTree;
	}

	public void setLaeTree(JTree laeTree) {
		this.laeTree = laeTree;
	}

	//	public DefaultMutableTreeNode creaArbolEjemplo(){
	//    	DefaultMutableTreeNode areas = new DefaultMutableTreeNode("Areas");
	//    	for(int i = 1; i < 4; i++){
	//    		DefaultMutableTreeNode area = new DefaultMutableTreeNode("Area"+i);
	//    		for(int j = 1; j < 4; j++){
	//    			DefaultMutableTreeNode estructura = new DefaultMutableTreeNode("Estructura"+j);
	//    			area.add(estructura);
	//    		}
	//    		areas.add(area);
	//    	}
	//    	return areas;
	//    }

	public JFrame getFrmEditorDeEstructuras() {
		return frmEditorDeEstructuras;
	}

	public void setFrmEditorDeEstructuras(JFrame frmEditorDeEstructuras) {
		this.frmEditorDeEstructuras = frmEditorDeEstructuras;
	}

	public EditorEstructurasController getController() {
		return controller;
	}

	public void setController(EditorEstructurasController controller) {
		this.controller = controller;
	}

	public JButton getDecp10button() {
		return decp10button;
	}

	public void setDecp10button(JButton decp10button) {
		this.decp10button = decp10button;
	}

	public JTable getEcpTable() {
		return ecpTable;
	}

	public void setEcpTable(RXTable ecpTable) {
		this.ecpTable = ecpTable;
	}


	public JButton getDecp081button() {
		return decp081button;
	}

	public void setDecp081button(JButton decp081button) {
		this.decp081button = decp081button;
	}

	public JButton getDecp092button() {
		return decp092button;
	}

	public void setDecp092button(JButton decp092button) {
		this.decp092button = decp092button;
	}

	public JButton getDecp082button() {
		return decp082button;
	}

	public void setDecp082button(JButton decp082button) {
		this.decp082button = decp082button;
	}

	public JButton getDecp091button() {
		return decp091button;
	}

	public void setDecp091button(JButton decp091button) {
		this.decp091button = decp091button;
	}

	public JButton getDecp06button() {
		return decp06button;
	}

	public void setDecp06button(JButton decp06button) {
		this.decp06button = decp06button;
	}

	public JButton getDecp07button() {
		return decp07button;
	}

	public void setDecp07button(JButton decp07button) {
		this.decp07button = decp07button;
	}

	public JButton getDecp03button() {
		return decp03button;
	}

	public void setDecp03button(JButton decp03button) {
		this.decp03button = decp03button;
	}

	public JButton getDecp05button() {
		return decp05button;
	}

	public void setDecp05button(JButton decp05button) {
		this.decp05button = decp05button;
	}

	public JButton getDecp04button() {
		return decp04button;
	}

	public void setDecp04button(JButton decp04button) {
		this.decp04button = decp04button;
	}

	public JButton getDecp02button() {
		return decp02button;
	}

	public void setDecp02button(JButton decp02button) {
		this.decp02button = decp02button;
	}

	public JButton getDecp11button() {
		return decp11button;
	}

	public void setDecp11button(JButton decp11button) {
		this.decp11button = decp11button;
	}

	public JComboBox getLpComboBox() {
		return lpComboBox;
	}

	public void setLpComboBox(JComboBox lpComboBox) {
		this.lpComboBox = lpComboBox;
	}

	public JButton getDecp12button() {
		return decp12button;
	}

	public void setDecp12button(JButton decp12button) {
		this.decp12button = decp12button;
	}

	public JButton getDlae01button() {
		return dlae01button;
	}

	public void setDlae01button(JButton dlae01button) {
		this.dlae01button = dlae01button;
	}

	public JButton getDlae03button() {
		return dlae03button;
	}

	public void setDlae03button(JButton dlae03button) {
		this.dlae03button = dlae03button;
	}

	public JButton getDlae05button() {
		return dlae05button;
	}

	public void setDlae05button(JButton dlae05button) {
		this.dlae05button = dlae05button;
	}

	public JButton getDlae04button() {
		return dlae04button;
	}

	public void setDlae04button(JButton dlae04button) {
		this.dlae04button = dlae04button;
	}

	public JButton getDlae06button() {
		return dlae06button;
	}

	public void setDlae06button(JButton dlae06button) {
		this.dlae06button = dlae06button;
	}

	public JButton getDecp14button() {
		return decp14button;
	}

	public void setDecp14button(JButton decp14button) {
		this.decp14button = decp14button;
	}

	public JButton getDlae08button() {
		return dlae08button;
	}

	public void setDlae08button(JButton dlae08button) {
		this.dlae08button = dlae08button;
	}

	public JButton getDecp13button() {
		return decp13button;
	}

	public void setDecp13button(JButton decp13button) {
		this.decp13button = decp13button;
	}

	public JTextField getAutortextField() {
		return autortextField;
	}

	public void setAutortextField(JTextField autortextField) {
		this.autortextField = autortextField;
	}

	public JTextField getCreaciontextField() {
		return creaciontextField;
	}

	public void setCreaciontextField(JTextField creaciontextField) {
		this.creaciontextField = creaciontextField;
	}

	public JTextField getModificaciontextField() {
		return modificaciontextField;
	}

	public void setModificaciontextField(JTextField modificaciontextField) {
		this.modificaciontextField = modificaciontextField;
	}

	public JButton getBtnAreas() {
		return btnAreas;
	}

	public void setBtnAreas(JButton btnAreas) {
		this.btnAreas = btnAreas;
	}

	public JScrollPane getEcpScrollPane() {
		return ecpScrollPane;
	}

	public void setEcpScrollPane(JScrollPane ecpScrollPane) {
		this.ecpScrollPane = ecpScrollPane;
	}



}
