package vista;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.JToolBar;
import javax.swing.JLabel;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import javax.swing.JScrollPane;
import javax.swing.JTable;

import utils.tablemodels.ExampleModel;
import javax.swing.JTextField;
import javax.swing.JComboBox;
import java.awt.FlowLayout;
import javax.swing.JButton;
import javax.swing.ImageIcon;
import javax.swing.JTextArea;
import javax.swing.ListSelectionModel;

import controlador.EditorGruposController;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;
import javax.swing.border.BevelBorder;

public class EditorGrupos extends JFrame {

	private JPanel contentPane;
	private JPanel panelSouth;
	private JPanel panelNorth;
	private JPanel panelCenter;
	private JToolBar toolBar;
	private JLabel lblUsuario;
	private JLabel lblGrupo;
	private JPanel panelLeft;
	private JPanel panelRight;
	private JTable table;
	private JScrollPane scrollPane;
	private JLabel lblNombre;
	private JLabel lblDescripcion;
	private JTextField textFieldNombre;
	private JButton dgu1button;
	private JButton dgu2button;
	private JButton dgu3button;
	private JButton dgu4button;
	private JTextArea textArea;
	private JScrollPane scrollPane_1;
	
	private JFrame previousWindow;
	private EditorGruposController controller;
	private JButton editarUsuariosButton;
	private JLabel lblUsuarios;

	/**
	 * Create the frame.
	 * @param perviousWindow 
	 */
	public EditorGrupos(JFrame previousWindow) {
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent arg0) {
				controller.cerrarVentana();
			}
		});
		setTitle("Gesti\u00F3n de grupos de usuarios");
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		setBounds(100, 100, 650, 300);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(0, 0));
		setContentPane(contentPane);
		
		panelSouth = new JPanel();
		panelSouth.setBorder(new BevelBorder(BevelBorder.LOWERED, null, null, null, null));
		FlowLayout flowLayout = (FlowLayout) panelSouth.getLayout();
		flowLayout.setAlignment(FlowLayout.LEFT);
		flowLayout.setVgap(0);
		contentPane.add(panelSouth, BorderLayout.SOUTH);
		
		lblUsuario = new JLabel("Usuario: Adam");
		panelSouth.add(lblUsuario);
		
		lblGrupo = new JLabel("Grupo: Becario");
		panelSouth.add(lblGrupo);
		
		panelNorth = new JPanel();
		FlowLayout flowLayout_1 = (FlowLayout) panelNorth.getLayout();
		flowLayout_1.setVgap(0);
		flowLayout_1.setHgap(0);
		flowLayout_1.setAlignment(FlowLayout.LEFT);
		contentPane.add(panelNorth, BorderLayout.NORTH);
		
		toolBar = new JToolBar();
		toolBar.setFloatable(false);
		panelNorth.add(toolBar);
		
		dgu1button = new JButton("");
		dgu1button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.agregarGrupo();
			}
		});
		dgu1button.setIcon(new ImageIcon(EditorGrupos.class.getResource("/resources/icons/list-add.png")));
		dgu1button.setToolTipText("Agregar usuario");
		toolBar.add(dgu1button);
		
		dgu2button = new JButton("");
		dgu2button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.eliminarGrupo();
			}
		});
		dgu2button.setIcon(new ImageIcon(EditorGrupos.class.getResource("/resources/icons/list-remove.png")));
		dgu2button.setToolTipText("Eliminar usuario");
		toolBar.add(dgu2button);
		
		dgu3button = new JButton("");
		dgu3button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.cerrarVentana();
			}
		});
		dgu3button.setIcon(new ImageIcon(EditorGrupos.class.getResource("/resources/icons/ok_button.png")));
		dgu3button.setToolTipText("Salir");
		toolBar.add(dgu3button);
		
		dgu4button = new JButton("");
		dgu4button.setIcon(new ImageIcon(EditorGrupos.class.getResource("/resources/icons/help-browser.png")));
		dgu4button.setToolTipText("Ayuda");
		toolBar.add(dgu4button);
		
		panelCenter = new JPanel();
		contentPane.add(panelCenter, BorderLayout.CENTER);
		GridBagLayout gbl_panelCenter = new GridBagLayout();
		gbl_panelCenter.columnWidths = new int[]{388, 260};
		gbl_panelCenter.rowHeights = new int[]{0, 0};
		gbl_panelCenter.columnWeights = new double[]{1.0, 4.9E-324};
		gbl_panelCenter.rowWeights = new double[]{1.0, Double.MIN_VALUE};
		panelCenter.setLayout(gbl_panelCenter);
		
		panelLeft = new JPanel();
		GridBagConstraints gbc_panelLeft = new GridBagConstraints();
		gbc_panelLeft.insets = new Insets(0, 0, 0, 5);
		gbc_panelLeft.fill = GridBagConstraints.BOTH;
		gbc_panelLeft.gridx = 0;
		gbc_panelLeft.gridy = 0;
		panelCenter.add(panelLeft, gbc_panelLeft);
		panelLeft.setLayout(new BorderLayout(0, 0));
		
		scrollPane = new JScrollPane();
		panelLeft.add(scrollPane);
		
		table = new JTable(new ExampleModel());
		table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		ListSelectionModel selectionModel = table.getSelectionModel();
		selectionModel.addListSelectionListener(new ListSelectionListener(){

			@Override
			public void valueChanged(ListSelectionEvent arg0) {
				controller.habilitarCampos();
				controller.actualizarCampos();
				

			}

		});
		scrollPane.setViewportView(table);
		
		panelRight = new JPanel();
		GridBagConstraints gbc_panelRight = new GridBagConstraints();
		gbc_panelRight.fill = GridBagConstraints.BOTH;
		gbc_panelRight.gridx = 1;
		gbc_panelRight.gridy = 0;
		panelCenter.add(panelRight, gbc_panelRight);
		GridBagLayout gbl_panelRight = new GridBagLayout();
		gbl_panelRight.columnWidths = new int[]{0, 0, 0};
		gbl_panelRight.rowHeights = new int[]{0, 0, 0, 0};
		gbl_panelRight.columnWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
		gbl_panelRight.rowWeights = new double[]{0.0, 0.0, 0.0, 2.0};
		panelRight.setLayout(gbl_panelRight);
		
		lblNombre = new JLabel("Nombre:");
		GridBagConstraints gbc_lblNombre = new GridBagConstraints();
		gbc_lblNombre.anchor = GridBagConstraints.EAST;
		gbc_lblNombre.insets = new Insets(5, 5, 5, 5);
		gbc_lblNombre.gridx = 0;
		gbc_lblNombre.gridy = 0;
		panelRight.add(lblNombre, gbc_lblNombre);
		
		textFieldNombre = new JTextField();
		textFieldNombre.addFocusListener(new FocusAdapter() {
			@Override
			public void focusLost(FocusEvent arg0) {
				controller.cambiarNombre();
			}
			@Override
			public void focusGained(FocusEvent arg0) {
				controller.actualizarFilaSeleccionada();
			}
		});
		lblNombre.setLabelFor(textFieldNombre);
		GridBagConstraints gbc_textFieldNombre = new GridBagConstraints();
		gbc_textFieldNombre.insets = new Insets(5, 0, 5, 0);
		gbc_textFieldNombre.fill = GridBagConstraints.HORIZONTAL;
		gbc_textFieldNombre.gridx = 1;
		gbc_textFieldNombre.gridy = 0;
		panelRight.add(textFieldNombre, gbc_textFieldNombre);
		textFieldNombre.setColumns(10);
		
		lblDescripcion = new JLabel("Descripci\u00F3n:");
		GridBagConstraints gbc_lblDescripcion = new GridBagConstraints();
		gbc_lblDescripcion.anchor = GridBagConstraints.EAST;
		gbc_lblDescripcion.insets = new Insets(5, 5, 5, 5);
		gbc_lblDescripcion.gridx = 0;
		gbc_lblDescripcion.gridy = 2;
		panelRight.add(lblDescripcion, gbc_lblDescripcion);
		
		lblUsuarios = new JLabel("Usuarios:");
		GridBagConstraints gbc_lblUsuarios = new GridBagConstraints();
		gbc_lblUsuarios.anchor = GridBagConstraints.EAST;
		gbc_lblUsuarios.insets = new Insets(5, 5, 5, 5);
		gbc_lblUsuarios.gridx = 0;
		gbc_lblUsuarios.gridy = 1;
		panelRight.add(lblUsuarios, gbc_lblUsuarios);
		
		editarUsuariosButton = new JButton("Editar usuarios");
		lblUsuarios.setLabelFor(editarUsuariosButton);
		editarUsuariosButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.abrirGestionUsuariosGrupo();
			}
		});
		GridBagConstraints gbc_editarUsuariosButton = new GridBagConstraints();
		gbc_editarUsuariosButton.insets = new Insets(5, 5, 5, 5);
		gbc_editarUsuariosButton.gridx = 1;
		gbc_editarUsuariosButton.gridy = 1;
		panelRight.add(editarUsuariosButton, gbc_editarUsuariosButton);
		
		scrollPane_1 = new JScrollPane();
		GridBagConstraints gbc_scrollPane_1 = new GridBagConstraints();
		gbc_scrollPane_1.insets = new Insets(0, 0, 5, 0);
		gbc_scrollPane_1.fill = GridBagConstraints.BOTH;
		gbc_scrollPane_1.gridwidth = 2;
		gbc_scrollPane_1.gridx = 0;
		gbc_scrollPane_1.gridy = 3;
		panelRight.add(scrollPane_1, gbc_scrollPane_1);
		
		textArea = new JTextArea();
		textArea.setLineWrap( true );
		textArea.setWrapStyleWord( true );
		textArea.setSize( textArea.getPreferredSize() );
		textArea.getDocument().addDocumentListener(new DocumentListener() {
			public void changedUpdate(DocumentEvent e) {
				controller.cambiarDescripcion();
			}
			public void removeUpdate(DocumentEvent e) {
				controller.cambiarDescripcion();
			}
			public void insertUpdate(DocumentEvent e) {
				controller.cambiarDescripcion();
			}
		});
		scrollPane_1.setViewportView(textArea);
		
		this.previousWindow = previousWindow;
		controller = EditorGruposController.getInstance();
		controller.inicializar(this);
		
	}

	public JLabel getLblUsuario() {
		return lblUsuario;
	}

	public void setLblUsuario(JLabel lblUsuario) {
		this.lblUsuario = lblUsuario;
	}

	public JLabel getLblGrupo() {
		return lblGrupo;
	}

	public void setLblGrupo(JLabel lblGrupo) {
		this.lblGrupo = lblGrupo;
	}

	public JTable getTable() {
		return table;
	}

	public void setTable(JTable table) {
		this.table = table;
	}

	public JLabel getLblNombre() {
		return lblNombre;
	}

	public void setLblNombre(JLabel lblNombre) {
		this.lblNombre = lblNombre;
	}

	public JLabel getLblDescripcion() {
		return lblDescripcion;
	}

	public void setLblDescripcion(JLabel lblDescripcion) {
		this.lblDescripcion = lblDescripcion;
	}

	public JTextField getTextFieldNombre() {
		return textFieldNombre;
	}

	public void setTextFieldNombre(JTextField textFieldNombre) {
		this.textFieldNombre = textFieldNombre;
	}

	public JButton getDgu1button() {
		return dgu1button;
	}

	public void setDgu1button(JButton dgu1button) {
		this.dgu1button = dgu1button;
	}

	public JButton getDgu2button() {
		return dgu2button;
	}

	public void setDgu2button(JButton dgu2button) {
		this.dgu2button = dgu2button;
	}

	public JButton getDgu3button() {
		return dgu3button;
	}

	public void setDgu3button(JButton dgu3button) {
		this.dgu3button = dgu3button;
	}

	public JButton getDgu4button() {
		return dgu4button;
	}

	public void setDgu4button(JButton dgu4button) {
		this.dgu4button = dgu4button;
	}

	public JTextArea getTextArea() {
		return textArea;
	}

	public void setTextArea(JTextArea textArea) {
		this.textArea = textArea;
	}

	public JFrame getPreviousWindow() {
		return previousWindow;
	}

	public void setPreviousWindow(JFrame previousWindow) {
		this.previousWindow = previousWindow;
	}

	public EditorGruposController getController() {
		return controller;
	}

	public void setController(EditorGruposController controller) {
		this.controller = controller;
	}

	public JScrollPane getScrollPane_1() {
		return scrollPane_1;
	}

	public void setScrollPane_1(JScrollPane scrollPane_1) {
		this.scrollPane_1 = scrollPane_1;
	}

	public JButton getEditarUsuariosButton() {
		return editarUsuariosButton;
	}

	public void setEditarUsuariosButton(JButton editarUsuariosButton) {
		this.editarUsuariosButton = editarUsuariosButton;
	}
	
	

}
