package vista;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JToolBar;
import javax.swing.JLabel;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JColorChooser;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JTabbedPane;
import javax.swing.ListSelectionModel;
import javax.swing.border.BevelBorder;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.ImageIcon;
import javax.swing.JTable;
import javax.swing.JScrollPane;

import utils.tablemodels.ExampleModel;
import javax.swing.JComboBox;

import controlador.EditorPresentacionesController;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.border.LineBorder;

import modelo.Presentacion;

import java.awt.Color;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

public class EditorPresentaciones extends JFrame {

	private JFrame previousWindow;
	private EditorPresentacionesController controller;
	private JPanel contentPane;
	private JPanel panelNorth;
	private JPanel panelSouth;
	private JPanel panelCenter;
	private JToolBar toolBar;
	private JLabel lblUsuario;
	private JLabel lblGrupo;
	private JPanel panelCenterIzquierda;
	private JPanel panelCenterDerecha;
	private JLabel lblNombre;
	private JLabel lblCreacin;
	private JLabel lblAutor;
	private JLabel lblUltModificacin;
	private JLabel lblAutorModificacion;
	private JTextField textNombre;
	private JTextField textCreacion;
	private JTextField textAutor;
	private JTextField textUltimaModificacion;
	private JTextField textAutorModificacion;
	private JButton dp1;
	private JButton dp2;
	private JTabbedPane tabbedPane;
	private JPanel panelPropiedades;
	private JPanel panelAspecto;
	private JPanel panelAcabado;
	private JTable tablePropiedades;
	private JScrollPane scrollPane;
	private JLabel lblAcabado1;
	private JLabel lblAcabado2;
	private JTextField textFieldAcabado1;
	private JTextField textFieldAcabado2;
	private JTable tableAspecto;
	private JScrollPane scrollPane_1;
	private JPanel panelAspectoDerecha;
	private JLabel lblColor;
	private JLabel lblFuente;
	private JLabel lblTamanyo;
	private JTextField textFieldColor;
	private JComboBox comboBoxFuente;
	private JComboBox comboBoxTamanyo;

	//	/**
	//	 * Launch the application.
	//	 */
	//	public static void main(String[] args) {
	//		EventQueue.invokeLater(new Runnable() {
	//			public void run() {
	//				try {
	//					EditorPresentaciones frame = new EditorPresentaciones();
	//					frame.setVisible(true);
	//				} catch (Exception e) {
	//					e.printStackTrace();
	//				}
	//			}
	//		});
	//	}

	/**
	 * Create the frame.
	 */

	public EditorPresentaciones(JFrame previous, Presentacion presentacion, int tipo) {
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent arg0) {
				controller.cerrarVentana();
			}
		});
		setTitle("Editor de Presentaciones");
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		setBounds(100, 100, 800, 600);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(0, 0));
		setContentPane(contentPane);

		panelNorth = new JPanel();
		FlowLayout flowLayout = (FlowLayout) panelNorth.getLayout();
		flowLayout.setVgap(0);
		flowLayout.setAlignment(FlowLayout.LEFT);
		contentPane.add(panelNorth, BorderLayout.NORTH);

		toolBar = new JToolBar();
		toolBar.setFloatable(false);
		panelNorth.add(toolBar);

		dp1 = new JButton("");
		dp1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.cerrarVentana();
			}
		});
		dp1.setIcon(new ImageIcon(EditorPresentaciones.class.getResource("/resources/icons/ok_button.png")));
		toolBar.add(dp1);

		dp2 = new JButton("");
		dp2.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.abrirManual();
			}
		});
		dp2.setIcon(new ImageIcon(EditorPresentaciones.class.getResource("/resources/icons/help-browser.png")));
		toolBar.add(dp2);

		panelSouth = new JPanel();
		panelSouth.setBorder(new BevelBorder(BevelBorder.LOWERED, null, null, null, null));
		FlowLayout flowLayout_1 = (FlowLayout) panelSouth.getLayout();
		flowLayout_1.setVgap(0);
		flowLayout_1.setAlignment(FlowLayout.LEFT);
		contentPane.add(panelSouth, BorderLayout.SOUTH);

		lblUsuario = new JLabel("Usuario: Adam");
		panelSouth.add(lblUsuario);

		lblGrupo = new JLabel("Grupo: Becario");
		panelSouth.add(lblGrupo);

		panelCenter = new JPanel();
		contentPane.add(panelCenter, BorderLayout.CENTER);
		GridBagLayout gbl_panelCenter = new GridBagLayout();
		gbl_panelCenter.columnWidths = new int[]{225, 0, 0};
		gbl_panelCenter.rowHeights = new int[]{0, 0};
		gbl_panelCenter.columnWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
		gbl_panelCenter.rowWeights = new double[]{1.0, Double.MIN_VALUE};
		panelCenter.setLayout(gbl_panelCenter);

		panelCenterIzquierda = new JPanel();
		panelCenterIzquierda.setBorder(new LineBorder(Color.LIGHT_GRAY));
		GridBagConstraints gbc_panelCenterIzquierda = new GridBagConstraints();
		gbc_panelCenterIzquierda.fill = GridBagConstraints.VERTICAL;
		gbc_panelCenterIzquierda.anchor = GridBagConstraints.WEST;
		gbc_panelCenterIzquierda.insets = new Insets(0, 0, 0, 5);
		gbc_panelCenterIzquierda.gridx = 0;
		gbc_panelCenterIzquierda.gridy = 0;
		panelCenter.add(panelCenterIzquierda, gbc_panelCenterIzquierda);
		GridBagLayout gbl_panelCenterIzquierda = new GridBagLayout();
		gbl_panelCenterIzquierda.columnWidths = new int[]{0, 120, 0};
		gbl_panelCenterIzquierda.rowHeights = new int[]{0, 0, 0, 0, 0, 0};
		gbl_panelCenterIzquierda.columnWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
		gbl_panelCenterIzquierda.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		panelCenterIzquierda.setLayout(gbl_panelCenterIzquierda);

		lblNombre = new JLabel("Nombre: ");
		GridBagConstraints gbc_lblNombre = new GridBagConstraints();
		gbc_lblNombre.ipady = 5;
		gbc_lblNombre.anchor = GridBagConstraints.EAST;
		gbc_lblNombre.insets = new Insets(5, 0, 5, 5);
		gbc_lblNombre.gridx = 0;
		gbc_lblNombre.gridy = 0;
		panelCenterIzquierda.add(lblNombre, gbc_lblNombre);

		textNombre = new JTextField();
		textNombre.setText("Presentacion Ejemplo");
		textNombre.getDocument().addDocumentListener(new DocumentListener() {
			public void changedUpdate(DocumentEvent e) {
				if(textNombre.getText().trim().equals("")){
					warn();
				}
				else {
					EditorPresentaciones.this.controller.getPresentacion().setNombre(textNombre.getText());
				}
			}
			public void removeUpdate(DocumentEvent e) {
			}
			public void insertUpdate(DocumentEvent e) {
				System.out.println(textNombre.getText());
				if(textNombre.getText().trim().equals("")){
					warn();
				}
				else {
					EditorPresentaciones.this.controller.getPresentacion().setNombre(textNombre.getText());
				}
			}

			public void warn() {
				JOptionPane.showMessageDialog(null,
						"Introduzca un nombre vlido.", "Error",
						JOptionPane.ERROR_MESSAGE);

			}
		});
		GridBagConstraints gbc_textNombre = new GridBagConstraints();
		gbc_textNombre.insets = new Insets(0, 0, 5, 0);
		gbc_textNombre.fill = GridBagConstraints.HORIZONTAL;
		gbc_textNombre.gridx = 1;
		gbc_textNombre.gridy = 0;
		panelCenterIzquierda.add(textNombre, gbc_textNombre);
		textNombre.setColumns(10);

		lblCreacin = new JLabel("Creaci\u00F3n: ");
		GridBagConstraints gbc_lblCreacin = new GridBagConstraints();
		gbc_lblCreacin.ipady = 5;
		gbc_lblCreacin.anchor = GridBagConstraints.EAST;
		gbc_lblCreacin.insets = new Insets(5, 0, 5, 5);
		gbc_lblCreacin.gridx = 0;
		gbc_lblCreacin.gridy = 1;
		panelCenterIzquierda.add(lblCreacin, gbc_lblCreacin);

		textCreacion = new JTextField();
		textCreacion.setEnabled(false);
		textCreacion.setText("12-Feb-2012");
		GridBagConstraints gbc_textCreacion = new GridBagConstraints();
		gbc_textCreacion.insets = new Insets(0, 0, 5, 0);
		gbc_textCreacion.fill = GridBagConstraints.HORIZONTAL;
		gbc_textCreacion.gridx = 1;
		gbc_textCreacion.gridy = 1;
		panelCenterIzquierda.add(textCreacion, gbc_textCreacion);
		textCreacion.setColumns(10);

		lblAutor = new JLabel("Autor: ");
		GridBagConstraints gbc_lblAutor = new GridBagConstraints();
		gbc_lblAutor.ipady = 5;
		gbc_lblAutor.anchor = GridBagConstraints.EAST;
		gbc_lblAutor.insets = new Insets(5, 0, 5, 5);
		gbc_lblAutor.gridx = 0;
		gbc_lblAutor.gridy = 2;
		panelCenterIzquierda.add(lblAutor, gbc_lblAutor);

		textAutor = new JTextField();
		textAutor.setText("Adam");
		textAutor.setEnabled(false);
		GridBagConstraints gbc_textAutor = new GridBagConstraints();
		gbc_textAutor.insets = new Insets(0, 0, 5, 0);
		gbc_textAutor.fill = GridBagConstraints.HORIZONTAL;
		gbc_textAutor.gridx = 1;
		gbc_textAutor.gridy = 2;
		panelCenterIzquierda.add(textAutor, gbc_textAutor);
		textAutor.setColumns(10);

		lblUltModificacin = new JLabel("Ult. Modificaci\u00F3n: ");
		GridBagConstraints gbc_lblUltModificacin = new GridBagConstraints();
		gbc_lblUltModificacin.ipady = 5;
		gbc_lblUltModificacin.anchor = GridBagConstraints.EAST;
		gbc_lblUltModificacin.insets = new Insets(5, 0, 5, 5);
		gbc_lblUltModificacin.gridx = 0;
		gbc_lblUltModificacin.gridy = 3;
		panelCenterIzquierda.add(lblUltModificacin, gbc_lblUltModificacin);

		textUltimaModificacion = new JTextField();
		textUltimaModificacion.setText("24-May-2012");
		textUltimaModificacion.setEnabled(false);
		GridBagConstraints gbc_textUltimaModificacion = new GridBagConstraints();
		gbc_textUltimaModificacion.fill = GridBagConstraints.HORIZONTAL;
		gbc_textUltimaModificacion.insets = new Insets(0, 0, 5, 0);
		gbc_textUltimaModificacion.gridx = 1;
		gbc_textUltimaModificacion.gridy = 3;
		panelCenterIzquierda.add(textUltimaModificacion, gbc_textUltimaModificacion);
		textUltimaModificacion.setColumns(10);

		lblAutorModificacion = new JLabel("Autor Modificacion: ");
		GridBagConstraints gbc_lblAutorModificacion = new GridBagConstraints();
		gbc_lblAutorModificacion.ipady = 5;
		gbc_lblAutorModificacion.anchor = GridBagConstraints.EAST;
		gbc_lblAutorModificacion.insets = new Insets(5, 0, 0, 5);
		gbc_lblAutorModificacion.gridx = 0;
		gbc_lblAutorModificacion.gridy = 4;
		panelCenterIzquierda.add(lblAutorModificacion, gbc_lblAutorModificacion);

		textAutorModificacion = new JTextField();
		textAutorModificacion.setText("Adam");
		textAutorModificacion.setEnabled(false);
		GridBagConstraints gbc_textAutorModificacion = new GridBagConstraints();
		gbc_textAutorModificacion.fill = GridBagConstraints.HORIZONTAL;
		gbc_textAutorModificacion.gridx = 1;
		gbc_textAutorModificacion.gridy = 4;
		panelCenterIzquierda.add(textAutorModificacion, gbc_textAutorModificacion);
		textAutorModificacion.setColumns(10);

		panelCenterDerecha = new JPanel();
		GridBagConstraints gbc_panelCenterDerecha = new GridBagConstraints();
		gbc_panelCenterDerecha.fill = GridBagConstraints.BOTH;
		gbc_panelCenterDerecha.gridx = 1;
		gbc_panelCenterDerecha.gridy = 0;
		panelCenter.add(panelCenterDerecha, gbc_panelCenterDerecha);
		GridBagLayout gbl_panelCenterDerecha = new GridBagLayout();
		gbl_panelCenterDerecha.columnWidths = new int[]{75, 0};
		gbl_panelCenterDerecha.rowHeights = new int[]{70, 0};
		gbl_panelCenterDerecha.columnWeights = new double[]{1.0, Double.MIN_VALUE};
		gbl_panelCenterDerecha.rowWeights = new double[]{1.0, Double.MIN_VALUE};
		panelCenterDerecha.setLayout(gbl_panelCenterDerecha);

		tabbedPane = new JTabbedPane(JTabbedPane.TOP);
		GridBagConstraints gbc_tabbedPane = new GridBagConstraints();
		gbc_tabbedPane.fill = GridBagConstraints.BOTH;
		gbc_tabbedPane.gridx = 0;
		gbc_tabbedPane.gridy = 0;
		panelCenterDerecha.add(tabbedPane, gbc_tabbedPane);

		panelPropiedades = new JPanel();
		tabbedPane.addTab("Propiedades", null, panelPropiedades, null);
		GridBagLayout gbl_panelPropiedades = new GridBagLayout();
		gbl_panelPropiedades.columnWidths = new int[]{452, 0};
		gbl_panelPropiedades.rowHeights = new int[]{402, 0};
		gbl_panelPropiedades.columnWeights = new double[]{1.0, Double.MIN_VALUE};
		gbl_panelPropiedades.rowWeights = new double[]{1.0, Double.MIN_VALUE};
		panelPropiedades.setLayout(gbl_panelPropiedades);

		scrollPane = new JScrollPane();
		GridBagConstraints gbc_scrollPane = new GridBagConstraints();
		gbc_scrollPane.fill = GridBagConstraints.BOTH;
		gbc_scrollPane.gridx = 0;
		gbc_scrollPane.gridy = 0;
		panelPropiedades.add(scrollPane, gbc_scrollPane);

		tablePropiedades = new JTable(new ExampleModel());
		scrollPane.setViewportView(tablePropiedades);

		panelAspecto = new JPanel();
		tabbedPane.addTab("Aspecto", null, panelAspecto, null);
		GridBagLayout gbl_panelAspecto = new GridBagLayout();
		gbl_panelAspecto.columnWidths = new int[]{0, 0, 0};
		gbl_panelAspecto.rowHeights = new int[]{0, 0};
		gbl_panelAspecto.columnWeights = new double[]{1.0, 0.0, Double.MIN_VALUE};
		gbl_panelAspecto.rowWeights = new double[]{1.0, Double.MIN_VALUE};
		panelAspecto.setLayout(gbl_panelAspecto);

		scrollPane_1 = new JScrollPane();
		GridBagConstraints gbc_scrollPane_1 = new GridBagConstraints();
		gbc_scrollPane_1.insets = new Insets(0, 0, 0, 5);
		gbc_scrollPane_1.fill = GridBagConstraints.BOTH;
		gbc_scrollPane_1.gridx = 0;
		gbc_scrollPane_1.gridy = 0;
		panelAspecto.add(scrollPane_1, gbc_scrollPane_1);

		tableAspecto = new JTable(new ExampleModel());
		tableAspecto.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		ListSelectionModel selectionModel = tableAspecto.getSelectionModel();
		selectionModel.addListSelectionListener(new ListSelectionListener(){

			@Override
			public void valueChanged(ListSelectionEvent arg0) {
				controller.aspectoHabilitarCampos();
				controller.aspectoActualizarCampos();

			}

		});
		scrollPane_1.setViewportView(tableAspecto);

		panelAspectoDerecha = new JPanel();
		GridBagConstraints gbc_panelAspectoDerecha = new GridBagConstraints();
		gbc_panelAspectoDerecha.fill = GridBagConstraints.BOTH;
		gbc_panelAspectoDerecha.gridx = 1;
		gbc_panelAspectoDerecha.gridy = 0;
		panelAspecto.add(panelAspectoDerecha, gbc_panelAspectoDerecha);
		GridBagLayout gbl_panelAspectoDerecha = new GridBagLayout();
		gbl_panelAspectoDerecha.columnWidths = new int[]{0, 100, 0};
		gbl_panelAspectoDerecha.rowHeights = new int[]{0, 0, 0, 0};
		gbl_panelAspectoDerecha.columnWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
		gbl_panelAspectoDerecha.rowWeights = new double[]{0.0, 0.0, 0.0, Double.MIN_VALUE};
		panelAspectoDerecha.setLayout(gbl_panelAspectoDerecha);

		lblColor = new JLabel("Color: ");
		GridBagConstraints gbc_lblColor = new GridBagConstraints();
		gbc_lblColor.ipady = 5;
		gbc_lblColor.anchor = GridBagConstraints.EAST;
		gbc_lblColor.insets = new Insets(5, 5, 5, 5);
		gbc_lblColor.gridx = 0;
		gbc_lblColor.gridy = 0;
		panelAspectoDerecha.add(lblColor, gbc_lblColor);

		textFieldColor = new JTextField();
		textFieldColor.setEditable(false);
		textFieldColor.setEnabled(false);
		textFieldColor.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent arg0) {
				if(textFieldColor.isEnabled())
					controller.aspectoCambiarColor();
			}
		});
		GridBagConstraints gbc_textFieldColor = new GridBagConstraints();
		gbc_textFieldColor.insets = new Insets(5, 0, 5, 0);
		gbc_textFieldColor.fill = GridBagConstraints.HORIZONTAL;
		gbc_textFieldColor.gridx = 1;
		gbc_textFieldColor.gridy = 0;
		panelAspectoDerecha.add(textFieldColor, gbc_textFieldColor);
		textFieldColor.setColumns(10);

		lblFuente = new JLabel("Fuente: ");
		GridBagConstraints gbc_lblFuente = new GridBagConstraints();
		gbc_lblFuente.ipady = 5;
		gbc_lblFuente.anchor = GridBagConstraints.EAST;
		gbc_lblFuente.insets = new Insets(5, 5, 5, 5);
		gbc_lblFuente.gridx = 0;
		gbc_lblFuente.gridy = 1;
		panelAspectoDerecha.add(lblFuente, gbc_lblFuente);

		comboBoxFuente = new JComboBox();
		String nombresFuentes []= {"Arial", "Arial Black", "Comic Sans MS", "Courier New", "Impact", "Times New Roman", "Verdana"};
		DefaultComboBoxModel cbm1 = new DefaultComboBoxModel(nombresFuentes);
		cbm1.setSelectedItem("Arial");
		comboBoxFuente.setModel(cbm1);
		comboBoxFuente.setEnabled(false);
		comboBoxFuente.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent arg0) {
				controller.aspectoCambiarFuente();
			}
		});
		GridBagConstraints gbc_comboBoxFuente = new GridBagConstraints();
		gbc_comboBoxFuente.insets = new Insets(5, 0, 5, 0);
		gbc_comboBoxFuente.fill = GridBagConstraints.HORIZONTAL;
		gbc_comboBoxFuente.gridx = 1;
		gbc_comboBoxFuente.gridy = 1;
		panelAspectoDerecha.add(comboBoxFuente, gbc_comboBoxFuente);

		lblTamanyo = new JLabel("Tama\u00F1o: ");
		GridBagConstraints gbc_lblTamanyo = new GridBagConstraints();
		gbc_lblTamanyo.anchor = GridBagConstraints.EAST;
		gbc_lblTamanyo.insets = new Insets(5, 5, 0, 5);
		gbc_lblTamanyo.gridx = 0;
		gbc_lblTamanyo.gridy = 2;
		panelAspectoDerecha.add(lblTamanyo, gbc_lblTamanyo);

		comboBoxTamanyo = new JComboBox();
		String nombres []= {"8","9","10","11","12","13","14", "16", "18", "20"};
		DefaultComboBoxModel cbm2 = new DefaultComboBoxModel(nombres);
		comboBoxTamanyo.setModel(cbm2);
		comboBoxTamanyo.setEnabled(false);
		comboBoxTamanyo.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent arg0) {
				controller.aspectoCambiarTamanyo();
			}
		});
		GridBagConstraints gbc_comboBoxTamanyo = new GridBagConstraints();
		gbc_comboBoxTamanyo.fill = GridBagConstraints.HORIZONTAL;
		gbc_comboBoxTamanyo.gridx = 1;
		gbc_comboBoxTamanyo.gridy = 2;
		panelAspectoDerecha.add(comboBoxTamanyo, gbc_comboBoxTamanyo);

		panelAcabado = new JPanel();
		tabbedPane.addTab("Acabado", null, panelAcabado, null);
		GridBagLayout gbl_panelAcabado = new GridBagLayout();
		gbl_panelAcabado.columnWidths = new int[]{0, 0, 0};
		gbl_panelAcabado.rowHeights = new int[]{0, 0, 0};
		gbl_panelAcabado.columnWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
		gbl_panelAcabado.rowWeights = new double[]{0.0, 0.0, Double.MIN_VALUE};
		panelAcabado.setLayout(gbl_panelAcabado);

		lblAcabado1 = new JLabel("Numero de l\u00EDneas para a\u00F1adir l\u00EDnea de cierre en agregados: ");
		GridBagConstraints gbc_lblAcabado1 = new GridBagConstraints();
		gbc_lblAcabado1.anchor = GridBagConstraints.EAST;
		gbc_lblAcabado1.insets = new Insets(5, 5, 5, 5);
		gbc_lblAcabado1.gridx = 0;
		gbc_lblAcabado1.gridy = 0;
		panelAcabado.add(lblAcabado1, gbc_lblAcabado1);

		textFieldAcabado1 = new JTextField();
		textFieldAcabado1.getDocument().addDocumentListener(new DocumentListener() {
			public void changedUpdate(DocumentEvent e) {
				EditorPresentaciones.this.controller.getValoresAcabado().set(0, textFieldAcabado1.getText());
			}
			public void removeUpdate(DocumentEvent e) {
			}
			public void insertUpdate(DocumentEvent e) {
				EditorPresentaciones.this.controller.getValoresAcabado().set(0, textFieldAcabado1.getText());
			}
		});
		GridBagConstraints gbc_textFieldAcabado1 = new GridBagConstraints();
		gbc_textFieldAcabado1.anchor = GridBagConstraints.WEST;
		gbc_textFieldAcabado1.insets = new Insets(5, 5, 5, 5);
		gbc_textFieldAcabado1.gridx = 1;
		gbc_textFieldAcabado1.gridy = 0;
		panelAcabado.add(textFieldAcabado1, gbc_textFieldAcabado1);
		textFieldAcabado1.setColumns(10);

		lblAcabado2 = new JLabel("N\u00FAmero de l\u00EDneas para a\u00F1adir l\u00EDnea de ciere en especializados: ");
		GridBagConstraints gbc_lblAcabado2 = new GridBagConstraints();
		gbc_lblAcabado2.anchor = GridBagConstraints.EAST;
		gbc_lblAcabado2.insets = new Insets(5, 5, 5, 5);
		gbc_lblAcabado2.gridx = 0;
		gbc_lblAcabado2.gridy = 1;
		panelAcabado.add(lblAcabado2, gbc_lblAcabado2);

		textFieldAcabado2 = new JTextField();
		textFieldAcabado2.getDocument().addDocumentListener(new DocumentListener() {
			public void changedUpdate(DocumentEvent e) {
				EditorPresentaciones.this.controller.getValoresAcabado().set(1, textFieldAcabado2.getText());
			}
			public void removeUpdate(DocumentEvent e) {
			}
			public void insertUpdate(DocumentEvent e) {
				EditorPresentaciones.this.controller.getValoresAcabado().set(1, textFieldAcabado2.getText());
			}
		});
		GridBagConstraints gbc_textFieldAcabado2 = new GridBagConstraints();
		gbc_textFieldAcabado2.anchor = GridBagConstraints.WEST;
		gbc_textFieldAcabado2.insets = new Insets(5, 5, 5, 5);
		gbc_textFieldAcabado2.gridx = 1;
		gbc_textFieldAcabado2.gridy = 1;
		panelAcabado.add(textFieldAcabado2, gbc_textFieldAcabado2);
		textFieldAcabado2.setColumns(10);

		controller = EditorPresentacionesController.getInstance();
		controller.setView(this);
		this.previousWindow = previous;
		controller.inicializar(presentacion, tipo);
	}

	public JFrame getPreviousWindow() {
		return previousWindow;
	}

	public void setPreviousWindow(JFrame previousWindow) {
		this.previousWindow = previousWindow;
	}

	public JTable getTablePropiedades() {
		return tablePropiedades;
	}

	public void setTablePropiedades(JTable tablePropiedades) {
		this.tablePropiedades = tablePropiedades;
	}

	public JTable getTableAspecto() {
		return tableAspecto;
	}

	public void setTableAspecto(JTable tableAspecto) {
		this.tableAspecto = tableAspecto;
	}

	public JTextField getTextNombre() {
		return textNombre;
	}

	public void setTextNombre(JTextField textNombre) {
		this.textNombre = textNombre;
	}

	public JTextField getTextCreacion() {
		return textCreacion;
	}

	public void setTextCreacion(JTextField textCreacion) {
		this.textCreacion = textCreacion;
	}

	public JTextField getTextAutor() {
		return textAutor;
	}

	public void setTextAutor(JTextField textAutor) {
		this.textAutor = textAutor;
	}

	public JTextField getTextUltimaModificacion() {
		return textUltimaModificacion;
	}

	public void setTextUltimaModificacion(JTextField textUltimaModificacion) {
		this.textUltimaModificacion = textUltimaModificacion;
	}

	public JTextField getTextAutorModificacion() {
		return textAutorModificacion;
	}

	public void setTextAutorModificacion(JTextField textAutorModificacion) {
		this.textAutorModificacion = textAutorModificacion;
	}

	public JTextField getTextFieldAcabado1() {
		return textFieldAcabado1;
	}

	public void setTextFieldAcabado1(JTextField textFieldAcabado1) {
		this.textFieldAcabado1 = textFieldAcabado1;
	}

	public JTextField getTextFieldAcabado2() {
		return textFieldAcabado2;
	}

	public void setTextFieldAcabado2(JTextField textFieldAcabado2) {
		this.textFieldAcabado2 = textFieldAcabado2;
	}

	public JTextField getTextFieldColor() {
		return textFieldColor;
	}

	public void setTextFieldColor(JTextField textFieldColor) {
		this.textFieldColor = textFieldColor;
	}



	public JComboBox getComboBoxTamanyo() {
		return comboBoxTamanyo;
	}

	public void setComboBoxTamanyo(JComboBox comboBoxTamanyo) {
		this.comboBoxTamanyo = comboBoxTamanyo;
	}

	public JComboBox getComboBoxFuente() {
		return comboBoxFuente;
	}

	public void setComboBoxFuente(JComboBox comboBoxFuente) {
		this.comboBoxFuente = comboBoxFuente;
	}





}
