package vista;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JToolBar;
import java.awt.FlowLayout;
import javax.swing.JButton;

import controlador.EditorSelectorController;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.border.LineBorder;
import java.awt.Color;
import javax.swing.JLabel;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.util.ArrayList;

import javax.swing.JList;
import javax.swing.JTable;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;

import utils.tablemodels.ModeloEditorEstructuraDerivada;
import utils.tablemodels.ModeloEditorSelectorComponentesInsertadas;
import javax.swing.ImageIcon;
import javax.swing.border.BevelBorder;

public class EditorSelector extends JFrame {

	private JPanel contentPane;
	private JFrame previousWindow;
	private JPanel toolBarPane;
	private JPanel contentPane2;
	private JPanel statusBarPane;
	private JToolBar toolBar;
	private JButton des01button;
	
	private EditorSelectorController controller;
	private JLabel usuarioLabel;
	private JLabel grupoLabel;
	private JLabel estructuraLabel;
	private JPanel panelSuperiorIzquierdo;
	private JPanel panelInferiorIzquierdo;
	private JPanel panelDerecho;
	private JButton anyadirSuperiorButton;
	private JTable superiorTable;
	private JTable inferiorTable;
	private JButton anyadirInferiorButton;
	private JScrollPane superiorScrollPanel;
	private JScrollPane inferiorScrollPanel;
	private JTable derechaTable;
	private JButton quitarButton;
	private JScrollPane derechaScrollPanel;
	private JButton des02button;
	/**
	 * Launch the application.
	 */
//	public static void main(String[] args) {
//		EventQueue.invokeLater(new Runnable() {
//			public void run() {
//				try {
//					EditorSelector frame = new EditorSelector();
//					frame.setVisible(true);
//				} catch (Exception e) {
//					e.printStackTrace();
//				}
//			}
//		});
//	}

	/**
	 * Create the frame.
	 */
	public EditorSelector(JFrame previousWindows) {
		setTitle("Crear Selector");
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent arg0) {
				controller.cerrarVentana();
			}
		});
		this.previousWindow = previousWindows;
		
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		setBounds(300, 300, 800, 400);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(0, 0));
		setContentPane(contentPane);
		
		toolBarPane = new JPanel();
		FlowLayout flowLayout = (FlowLayout) toolBarPane.getLayout();
		flowLayout.setHgap(0);
		flowLayout.setAlignment(FlowLayout.LEFT);
		flowLayout.setVgap(0);
		contentPane.add(toolBarPane, BorderLayout.NORTH);
		
		toolBar = new JToolBar();
		toolBar.setFloatable(false);
		toolBarPane.add(toolBar);
		
		des01button = new JButton("");
		des01button.setToolTipText("Descartar los cambios realizados");
		des01button.setIcon(new ImageIcon(EditorSelector.class.getResource("/resources/icons/cancel_button.png")));
		des01button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.cerrarVentana();
			}
		});
		
		des02button = new JButton("");
		des02button.setEnabled(false);
		des02button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.guardarModificaciones();
				controller.cerrarVentana();
			}
		});
		des02button.setToolTipText("Aplicar los cambios realizados");
		des02button.setIcon(new ImageIcon(EditorSelector.class.getResource("/resources/icons/ok_button.png")));
		toolBar.add(des02button);
		toolBar.add(des01button);
		
		contentPane2 = new JPanel();
		contentPane2.setBorder(new LineBorder(Color.LIGHT_GRAY));
		contentPane.add(contentPane2, BorderLayout.CENTER);
		GridBagLayout gbl_contentPane2 = new GridBagLayout();
		gbl_contentPane2.columnWidths = new int[]{0, 0, 0};
		gbl_contentPane2.rowHeights = new int[]{0, 0, 0};
		gbl_contentPane2.columnWeights = new double[]{1.0, 1.0, Double.MIN_VALUE};
		gbl_contentPane2.rowWeights = new double[]{1.0, 1.0, Double.MIN_VALUE};
		contentPane2.setLayout(gbl_contentPane2);
		
		panelSuperiorIzquierdo = new JPanel();
		GridBagConstraints gbc_panelSuperiorIzquierdo = new GridBagConstraints();
		gbc_panelSuperiorIzquierdo.insets = new Insets(0, 0, 5, 5);
		gbc_panelSuperiorIzquierdo.fill = GridBagConstraints.BOTH;
		gbc_panelSuperiorIzquierdo.gridx = 0;
		gbc_panelSuperiorIzquierdo.gridy = 0;
		contentPane2.add(panelSuperiorIzquierdo, gbc_panelSuperiorIzquierdo);
		
		String[] data = {"one", "two", "three", "four"};
		GridBagLayout gbl_panelSuperiorIzquierdo = new GridBagLayout();
		gbl_panelSuperiorIzquierdo.columnWidths = new int[]{28, 0, 0};
		gbl_panelSuperiorIzquierdo.rowHeights = new int[]{0, 0, 0};
		gbl_panelSuperiorIzquierdo.columnWeights = new double[]{1.0, 0.0, Double.MIN_VALUE};
		gbl_panelSuperiorIzquierdo.rowWeights = new double[]{1.0, 0.0, Double.MIN_VALUE};
		panelSuperiorIzquierdo.setLayout(gbl_panelSuperiorIzquierdo);
		
		superiorScrollPanel = new JScrollPane();
		GridBagConstraints gbc_superiorScrollPanel = new GridBagConstraints();
		gbc_superiorScrollPanel.fill = GridBagConstraints.BOTH;
		gbc_superiorScrollPanel.gridwidth = 2;
		gbc_superiorScrollPanel.insets = new Insets(0, 0, 5, 0);
		gbc_superiorScrollPanel.gridx = 0;
		gbc_superiorScrollPanel.gridy = 0;
		panelSuperiorIzquierdo.add(superiorScrollPanel, gbc_superiorScrollPanel);
		
		
		superiorTable = new JTable();
		superiorTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		superiorScrollPanel.setViewportView(superiorTable);
		
		anyadirSuperiorButton = new JButton("A\u00F1adir");
		anyadirSuperiorButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.agregarDeTablaSuperior();
			}
		});
		GridBagConstraints gbc_anyadirSuperiorButton = new GridBagConstraints();
		gbc_anyadirSuperiorButton.gridx = 1;
		gbc_anyadirSuperiorButton.gridy = 1;
		panelSuperiorIzquierdo.add(anyadirSuperiorButton, gbc_anyadirSuperiorButton);
		
		panelInferiorIzquierdo = new JPanel();
		GridBagConstraints gbc_panelInferiorIzquierdo = new GridBagConstraints();
		gbc_panelInferiorIzquierdo.insets = new Insets(0, 0, 0, 5);
		gbc_panelInferiorIzquierdo.fill = GridBagConstraints.BOTH;
		gbc_panelInferiorIzquierdo.gridx = 0;
		gbc_panelInferiorIzquierdo.gridy = 1;
		contentPane2.add(panelInferiorIzquierdo, gbc_panelInferiorIzquierdo);
		GridBagLayout gbl_panelInferiorIzquierdo = new GridBagLayout();
		gbl_panelInferiorIzquierdo.columnWidths = new int[]{0, 0, 0};
		gbl_panelInferiorIzquierdo.rowHeights = new int[]{0, 0, 0};
		gbl_panelInferiorIzquierdo.columnWeights = new double[]{1.0, 1.0, Double.MIN_VALUE};
		gbl_panelInferiorIzquierdo.rowWeights = new double[]{1.0, 0.0, Double.MIN_VALUE};
		panelInferiorIzquierdo.setLayout(gbl_panelInferiorIzquierdo);
		
		inferiorScrollPanel = new JScrollPane();
		GridBagConstraints gbc_inferiorScrollPanel = new GridBagConstraints();
		gbc_inferiorScrollPanel.fill = GridBagConstraints.BOTH;
		gbc_inferiorScrollPanel.gridwidth = 2;
		gbc_inferiorScrollPanel.insets = new Insets(0, 0, 5, 0);
		gbc_inferiorScrollPanel.gridx = 0;
		gbc_inferiorScrollPanel.gridy = 0;
		panelInferiorIzquierdo.add(inferiorScrollPanel, gbc_inferiorScrollPanel);
		
		
		inferiorTable = new JTable();
		inferiorTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		inferiorScrollPanel.setViewportView(inferiorTable);
		
		anyadirInferiorButton = new JButton("A\u00F1adir");
		anyadirInferiorButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.agregarDeTablaInferior();
			}
		});
		GridBagConstraints gbc_anyadirInferiorButton = new GridBagConstraints();
		gbc_anyadirInferiorButton.anchor = GridBagConstraints.EAST;
		gbc_anyadirInferiorButton.gridx = 1;
		gbc_anyadirInferiorButton.gridy = 1;
		panelInferiorIzquierdo.add(anyadirInferiorButton, gbc_anyadirInferiorButton);
		
		panelDerecho = new JPanel();
		panelDerecho.setBorder(new LineBorder(Color.LIGHT_GRAY));
		GridBagConstraints gbc_panelDerecho = new GridBagConstraints();
		gbc_panelDerecho.gridheight = 2;
		gbc_panelDerecho.fill = GridBagConstraints.BOTH;
		gbc_panelDerecho.gridx = 1;
		gbc_panelDerecho.gridy = 0;
		contentPane2.add(panelDerecho, gbc_panelDerecho);
		GridBagLayout gbl_panelDerecho = new GridBagLayout();
		gbl_panelDerecho.columnWidths = new int[]{84, 0};
		gbl_panelDerecho.rowHeights = new int[]{1, 0, 0};
		gbl_panelDerecho.columnWeights = new double[]{1.0, Double.MIN_VALUE};
		gbl_panelDerecho.rowWeights = new double[]{1.0, 0.0, Double.MIN_VALUE};
		panelDerecho.setLayout(gbl_panelDerecho);
		
		derechaScrollPanel = new JScrollPane();
		GridBagConstraints gbc_derechaScrollPanel = new GridBagConstraints();
		gbc_derechaScrollPanel.fill = GridBagConstraints.BOTH;
		gbc_derechaScrollPanel.insets = new Insets(0, 0, 5, 0);
		gbc_derechaScrollPanel.gridx = 0;
		gbc_derechaScrollPanel.gridy = 0;
		panelDerecho.add(derechaScrollPanel, gbc_derechaScrollPanel);
		
		derechaTable = new JTable();
		derechaTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		derechaScrollPanel.setViewportView(derechaTable);
		
		quitarButton = new JButton("Quitar");
		quitarButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.borrarDeTablaDerecha();
			}
		});
		GridBagConstraints gbc_quitarButton = new GridBagConstraints();
		gbc_quitarButton.anchor = GridBagConstraints.EAST;
		gbc_quitarButton.gridx = 0;
		gbc_quitarButton.gridy = 1;
		panelDerecho.add(quitarButton, gbc_quitarButton);
		
		statusBarPane = new JPanel();
		statusBarPane.setBorder(new BevelBorder(BevelBorder.LOWERED, null, null, null, null));
		FlowLayout flowLayout_1 = (FlowLayout) statusBarPane.getLayout();
		flowLayout_1.setAlignment(FlowLayout.LEFT);
		flowLayout_1.setVgap(0);
		contentPane.add(statusBarPane, BorderLayout.SOUTH);
		
		usuarioLabel = new JLabel("Usuario: Adam");
		statusBarPane.add(usuarioLabel);
		
		grupoLabel = new JLabel("Grupo: Becario");
		statusBarPane.add(grupoLabel);
		
		estructuraLabel = new JLabel("Estructura: Cliente");
		statusBarPane.add(estructuraLabel);
		
		controller = EditorSelectorController.getInstance();
		controller.inicializar(this);
		
	}
	public JFrame getPreviousWindow() {
		return previousWindow;
	}
	public void setPreviousWindow(JFrame previousWindow) {
		this.previousWindow = previousWindow;
	}
	public EditorSelectorController getController() {
		return controller;
	}
	public void setController(EditorSelectorController controller) {
		this.controller = controller;
	}
	public JLabel getUsuarioLabel() {
		return usuarioLabel;
	}
	public void setUsuarioLabel(JLabel usuarioLabel) {
		this.usuarioLabel = usuarioLabel;
	}
	public JLabel getGrupoLabel() {
		return grupoLabel;
	}
	public void setGrupoLabel(JLabel grupoLabel) {
		this.grupoLabel = grupoLabel;
	}
	public JLabel getEstructuraLabel() {
		return estructuraLabel;
	}
	public void setEstructuraLabel(JLabel estructuraLabel) {
		this.estructuraLabel = estructuraLabel;
	}
	public JButton getAnyadirSuperiorButton() {
		return anyadirSuperiorButton;
	}
	public void setAnyadirSuperiorButton(JButton anyadirSuperiorButton) {
		this.anyadirSuperiorButton = anyadirSuperiorButton;
	}
	public JTable getInferiorTable() {
		return inferiorTable;
	}
	public void setInferiorTable(JTable inferiorTable) {
		this.inferiorTable = inferiorTable;
	}
	public JButton getAnyadirInferiorButton() {
		return anyadirInferiorButton;
	}
	public void setAnyadirInferiorButton(JButton anyadirInferiorButton) {
		this.anyadirInferiorButton = anyadirInferiorButton;
	}
	public JButton getQuitarButton() {
		return quitarButton;
	}
	public void setQuitarButton(JButton quitarButton) {
		this.quitarButton = quitarButton;
	}
	public JTable getSuperiorTable() {
		return superiorTable;
	}
	public void setSuperiorTable(JTable superiorTable) {
		this.superiorTable = superiorTable;
	}
	public JTable getDerechaTable() {
		return derechaTable;
	}
	public void setDerechaTable(JTable derechaTable) {
		this.derechaTable = derechaTable;
	}
	public JButton getDes01button() {
		return des01button;
	}
	public void setDes01button(JButton des01button) {
		this.des01button = des01button;
	}
	public JButton getDes02button() {
		return des02button;
	}
	public void setDes02button(JButton des02button) {
		this.des02button = des02button;
	}

	
	
	
}
