package vista;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import java.awt.FlowLayout;
import javax.swing.JToolBar;
import javax.swing.border.BevelBorder;
import javax.swing.JButton;
import javax.swing.ImageIcon;
import java.awt.GridBagLayout;
import javax.swing.border.LineBorder;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import java.awt.Color;
import javax.swing.JRadioButton;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import javax.swing.JCheckBox;
import javax.swing.ButtonGroup;
import javax.swing.JTextField;

import modelo.Propiedad;

import controlador.EditorTipoDatosController;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.SystemColor;

public class EditorTipoDatos extends JFrame {

	private JFrame previousWindow;
	private EditorTipoDatosController controller;
	private JPanel contentPane;
	private JPanel panelNorth;
	private JPanel panelSouth;
	private JPanel panelCenter;
	private JLabel lblPresentacion;
	private JLabel lblPropiedad;
	private JToolBar toolBar;
	private JButton detd1;
	private JButton detd2;
	private JRadioButton rdbtnAlfanumrico;
	private JLabel lblLongMin;
	private JLabel lblLongMax;
	private JRadioButton rdbtnNumrico;
	private JCheckBox chckbxNoNegativo;
	private JRadioButton rdbtnRango;
	private JRadioButton rdbtnBinariosino;
	private JCheckBox chckbxNoNulo;
	private final ButtonGroup buttonGroup = new ButtonGroup();
	private JTextField textFieldLongMin;
	private JTextField textFieldLongMax;

	/**
	 * Launch the application.
	 */
//	public static void main(String[] args) {
//		EventQueue.invokeLater(new Runnable() {
//			public void run() {
//				try {
//					EditorTipoDatos frame = new EditorTipoDatos();
//					frame.setVisible(true);
//				} catch (Exception e) {
//					e.printStackTrace();
//				}
//			}
//		});
//	}

	/**
	 * Create the frame.
	 * @param propiedadSeleccionada 
	 */
	public EditorTipoDatos(JFrame previous, Propiedad propiedadSeleccionada) {
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				controller.cerrarVentana();
			}
		});
		setResizable(false);
		setTitle("Editor de Tipo de Datos");
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		setBounds(200, 200, 279, 339);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(0, 0));
		setContentPane(contentPane);
		
		panelNorth = new JPanel();
		FlowLayout flowLayout_1 = (FlowLayout) panelNorth.getLayout();
		flowLayout_1.setVgap(0);
		flowLayout_1.setAlignment(FlowLayout.LEFT);
		contentPane.add(panelNorth, BorderLayout.NORTH);
		
		toolBar = new JToolBar();
		toolBar.setFloatable(false);
		panelNorth.add(toolBar);
		
		detd1 = new JButton("");
		detd1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.cerrarVentana();
			}
		});
		detd1.setIcon(new ImageIcon(EditorTipoDatos.class.getResource("/resources/icons/ok_button.png")));
		toolBar.add(detd1);
		
		detd2 = new JButton("");
		detd2.setIcon(new ImageIcon(EditorTipoDatos.class.getResource("/resources/icons/help-browser.png")));
		toolBar.add(detd2);
		
		panelSouth = new JPanel();
		panelSouth.setBorder(new BevelBorder(BevelBorder.LOWERED, null, null, null, null));
		FlowLayout flowLayout = (FlowLayout) panelSouth.getLayout();
		flowLayout.setAlignment(FlowLayout.LEFT);
		flowLayout.setVgap(0);
		contentPane.add(panelSouth, BorderLayout.SOUTH);
		
		lblPresentacion = new JLabel("Presentaci\u00F3n: Presentaci\u00F3n");
		panelSouth.add(lblPresentacion);
		
		lblPropiedad = new JLabel("Propiedad: Propiedad");
		panelSouth.add(lblPropiedad);
		
		panelCenter = new JPanel();
		panelCenter.setBorder(new LineBorder(SystemColor.windowBorder));
		contentPane.add(panelCenter, BorderLayout.CENTER);
		GridBagLayout gbl_panelCenter = new GridBagLayout();
		gbl_panelCenter.columnWidths = new int[]{0, 0, 120, 0};
		gbl_panelCenter.rowHeights = new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0};
		gbl_panelCenter.columnWeights = new double[]{0.0, 0.0, 0.0, Double.MIN_VALUE};
		gbl_panelCenter.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		panelCenter.setLayout(gbl_panelCenter);
		
		rdbtnAlfanumrico = new JRadioButton("Alfanum\u00E9rico");
		rdbtnAlfanumrico.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.getPropiedad().getTipoDatos().reset();
				controller.getPropiedad().getTipoDatos().setAlfanumerico(true);
				controller.actualizarCampos();
			}
		});
		buttonGroup.add(rdbtnAlfanumrico);
		GridBagConstraints gbc_rdbtnAlfanumrico = new GridBagConstraints();
		gbc_rdbtnAlfanumrico.anchor = GridBagConstraints.WEST;
		gbc_rdbtnAlfanumrico.insets = new Insets(0, 0, 5, 5);
		gbc_rdbtnAlfanumrico.gridx = 0;
		gbc_rdbtnAlfanumrico.gridy = 0;
		panelCenter.add(rdbtnAlfanumrico, gbc_rdbtnAlfanumrico);
		
		lblLongMin = new JLabel("Long. Min");
		GridBagConstraints gbc_lblLongMin = new GridBagConstraints();
		gbc_lblLongMin.gridwidth = 2;
		gbc_lblLongMin.anchor = GridBagConstraints.EAST;
		gbc_lblLongMin.insets = new Insets(0, 0, 5, 5);
		gbc_lblLongMin.gridx = 0;
		gbc_lblLongMin.gridy = 1;
		panelCenter.add(lblLongMin, gbc_lblLongMin);
		
		textFieldLongMin = new JTextField();
		textFieldLongMin.getDocument().addDocumentListener(new DocumentListener() {
			public void changedUpdate(DocumentEvent e) {
				EditorTipoDatos.this.getController().setValorLongitudMinima(textFieldLongMin.getText());
			}
			public void removeUpdate(DocumentEvent e) {
			}
			public void insertUpdate(DocumentEvent e) {
				EditorTipoDatos.this.getController().setValorLongitudMinima(textFieldLongMin.getText());
			}
		});
		GridBagConstraints gbc_textFieldLongMin = new GridBagConstraints();
		gbc_textFieldLongMin.insets = new Insets(0, 0, 5, 0);
		gbc_textFieldLongMin.fill = GridBagConstraints.HORIZONTAL;
		gbc_textFieldLongMin.gridx = 2;
		gbc_textFieldLongMin.gridy = 1;
		panelCenter.add(textFieldLongMin, gbc_textFieldLongMin);
		textFieldLongMin.setColumns(10);
		
		lblLongMax = new JLabel("Long. Max");
		GridBagConstraints gbc_lblLongMax = new GridBagConstraints();
		gbc_lblLongMax.gridwidth = 2;
		gbc_lblLongMax.anchor = GridBagConstraints.EAST;
		gbc_lblLongMax.insets = new Insets(0, 0, 5, 5);
		gbc_lblLongMax.gridx = 0;
		gbc_lblLongMax.gridy = 2;
		panelCenter.add(lblLongMax, gbc_lblLongMax);
		
		textFieldLongMax = new JTextField();
		textFieldLongMax.getDocument().addDocumentListener(new DocumentListener() {
			public void changedUpdate(DocumentEvent e) {
				EditorTipoDatos.this.getController().setValorLongitudMaxima(textFieldLongMax.getText());
			}
			public void removeUpdate(DocumentEvent e) {
			}
			public void insertUpdate(DocumentEvent e) {
				EditorTipoDatos.this.getController().setValorLongitudMaxima(textFieldLongMax.getText());
			}
		});
		GridBagConstraints gbc_textFieldLongMax = new GridBagConstraints();
		gbc_textFieldLongMax.insets = new Insets(0, 0, 5, 0);
		gbc_textFieldLongMax.fill = GridBagConstraints.HORIZONTAL;
		gbc_textFieldLongMax.gridx = 2;
		gbc_textFieldLongMax.gridy = 2;
		panelCenter.add(textFieldLongMax, gbc_textFieldLongMax);
		textFieldLongMax.setColumns(10);
		
		rdbtnNumrico = new JRadioButton("Num\u00E9rico");
		rdbtnNumrico.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.getPropiedad().getTipoDatos().reset();
				controller.getPropiedad().getTipoDatos().setNumerico(true);
				controller.actualizarCampos();
			}
		});
		buttonGroup.add(rdbtnNumrico);
		GridBagConstraints gbc_rdbtnNumrico = new GridBagConstraints();
		gbc_rdbtnNumrico.anchor = GridBagConstraints.WEST;
		gbc_rdbtnNumrico.insets = new Insets(0, 0, 5, 5);
		gbc_rdbtnNumrico.gridx = 0;
		gbc_rdbtnNumrico.gridy = 3;
		panelCenter.add(rdbtnNumrico, gbc_rdbtnNumrico);
		
		chckbxNoNegativo = new JCheckBox("No negativo");
		chckbxNoNegativo.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.getPropiedad().getTipoDatos().setNoNegativo(chckbxNoNegativo.isSelected());
			}
		});
		GridBagConstraints gbc_chckbxNoNegativo = new GridBagConstraints();
		gbc_chckbxNoNegativo.gridwidth = 2;
		gbc_chckbxNoNegativo.anchor = GridBagConstraints.EAST;
		gbc_chckbxNoNegativo.insets = new Insets(0, 0, 5, 5);
		gbc_chckbxNoNegativo.gridx = 0;
		gbc_chckbxNoNegativo.gridy = 4;
		panelCenter.add(chckbxNoNegativo, gbc_chckbxNoNegativo);
		
		rdbtnRango = new JRadioButton("Rango");
		rdbtnRango.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.getPropiedad().getTipoDatos().reset();
				controller.getPropiedad().getTipoDatos().setRango(true);
				controller.actualizarCampos();
			}
		});
		buttonGroup.add(rdbtnRango);
		GridBagConstraints gbc_rdbtnRango = new GridBagConstraints();
		gbc_rdbtnRango.anchor = GridBagConstraints.WEST;
		gbc_rdbtnRango.insets = new Insets(0, 0, 5, 5);
		gbc_rdbtnRango.gridx = 0;
		gbc_rdbtnRango.gridy = 5;
		panelCenter.add(rdbtnRango, gbc_rdbtnRango);
		
		rdbtnBinariosino = new JRadioButton("Binario (si/no)");
		rdbtnBinariosino.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.getPropiedad().getTipoDatos().reset();
				controller.getPropiedad().getTipoDatos().setBinario(true);
				controller.actualizarCampos();
			}
		});
		buttonGroup.add(rdbtnBinariosino);
		GridBagConstraints gbc_rdbtnBinariosino = new GridBagConstraints();
		gbc_rdbtnBinariosino.anchor = GridBagConstraints.WEST;
		gbc_rdbtnBinariosino.insets = new Insets(0, 0, 5, 5);
		gbc_rdbtnBinariosino.gridx = 0;
		gbc_rdbtnBinariosino.gridy = 6;
		panelCenter.add(rdbtnBinariosino, gbc_rdbtnBinariosino);
		
		chckbxNoNulo = new JCheckBox("No nulo");
		chckbxNoNulo.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.getPropiedad().getTipoDatos().setNulo(!chckbxNoNulo.isSelected());
			}
		});
		GridBagConstraints gbc_chckbxNoNulo = new GridBagConstraints();
		gbc_chckbxNoNulo.anchor = GridBagConstraints.WEST;
		gbc_chckbxNoNulo.insets = new Insets(0, 0, 0, 5);
		gbc_chckbxNoNulo.gridx = 0;
		gbc_chckbxNoNulo.gridy = 7;
		panelCenter.add(chckbxNoNulo, gbc_chckbxNoNulo);
		
		controller = EditorTipoDatosController.getInstance();
		
		this.previousWindow = previous;
		controller.inicializar(this, propiedadSeleccionada);
		
	}

	public JFrame getPreviousWindow() {
		return previousWindow;
	}

	public void setPreviousWindow(JFrame previousWindow) {
		this.previousWindow = previousWindow;
	}

	public EditorTipoDatosController getController() {
		return controller;
	}

	public void setController(EditorTipoDatosController controller) {
		this.controller = controller;
	}

	public JLabel getLblPresentacion() {
		return lblPresentacion;
	}

	public void setLblPresentacion(JLabel lblPresentacion) {
		this.lblPresentacion = lblPresentacion;
	}

	public JLabel getLblPropiedad() {
		return lblPropiedad;
	}

	public void setLblPropiedad(JLabel lblPropiedad) {
		this.lblPropiedad = lblPropiedad;
	}

	public JToolBar getToolBar() {
		return toolBar;
	}

	public void setToolBar(JToolBar toolBar) {
		this.toolBar = toolBar;
	}

	public JButton getDetd1() {
		return detd1;
	}

	public void setDetd1(JButton detd1) {
		this.detd1 = detd1;
	}

	public JButton getDetd2() {
		return detd2;
	}

	public void setDetd2(JButton detd2) {
		this.detd2 = detd2;
	}

	public JRadioButton getRdbtnAlfanumrico() {
		return rdbtnAlfanumrico;
	}

	public void setRdbtnAlfanumrico(JRadioButton rdbtnAlfanumrico) {
		this.rdbtnAlfanumrico = rdbtnAlfanumrico;
	}

	public JLabel getLblLongMin() {
		return lblLongMin;
	}

	public void setLblLongMin(JLabel lblLongMin) {
		this.lblLongMin = lblLongMin;
	}

	public JLabel getLblLongMax() {
		return lblLongMax;
	}

	public void setLblLongMax(JLabel lblLongMax) {
		this.lblLongMax = lblLongMax;
	}

	public JRadioButton getRdbtnNumrico() {
		return rdbtnNumrico;
	}

	public void setRdbtnNumrico(JRadioButton rdbtnNumrico) {
		this.rdbtnNumrico = rdbtnNumrico;
	}

	public JCheckBox getChckbxNoNegativo() {
		return chckbxNoNegativo;
	}

	public void setChckbxNoNegativo(JCheckBox chckbxNoNegativo) {
		this.chckbxNoNegativo = chckbxNoNegativo;
	}

	public JRadioButton getRdbtnRango() {
		return rdbtnRango;
	}

	public void setRdbtnRango(JRadioButton rdbtnRango) {
		this.rdbtnRango = rdbtnRango;
	}

	public JRadioButton getRdbtnBinariosino() {
		return rdbtnBinariosino;
	}

	public void setRdbtnBinariosino(JRadioButton rdbtnBinariosino) {
		this.rdbtnBinariosino = rdbtnBinariosino;
	}

	public JCheckBox getChckbxNoNulo() {
		return chckbxNoNulo;
	}

	public void setChckbxNoNulo(JCheckBox chckbxNoNulo) {
		this.chckbxNoNulo = chckbxNoNulo;
	}

	public JTextField getTextFieldLongMin() {
		return textFieldLongMin;
	}

	public void setTextFieldLongMin(JTextField textFieldLongMin) {
		this.textFieldLongMin = textFieldLongMin;
	}

	public JTextField getTextFieldLongMax() {
		return textFieldLongMax;
	}

	public void setTextFieldLongMax(JTextField textFieldLongMax) {
		this.textFieldLongMax = textFieldLongMax;
	}

	public ButtonGroup getButtonGroup() {
		return buttonGroup;
	}

	
}
