package vista;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JToolBar;
import java.awt.FlowLayout;
import javax.swing.JButton;
import java.awt.GridLayout;
import javax.swing.BoxLayout;
import javax.swing.JTable;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;

import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import javax.swing.JLabel;

import controlador.EditorTipoPresentacionController;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.ImageIcon;

import utils.tablemodels.ExampleModel;
import utils.tablemodels.ModeloEditorTipoPresentaciones;

import javax.swing.border.BevelBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import modelo.Presentacion;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

public class EditorTipoPresentacion extends JFrame {

	private JFrame previousWindow;
	private JPanel contentPane;
	private JPanel panelNorth;
	private JPanel panelSouth;
	private JPanel panelCenter;
	private JPanel panelCenterNorth;
	private JPanel panelCenterSouth;
	private JPanel panelCenterCenter;
	private JToolBar toolBarNorth;
	private JButton dept1;
	private JButton detp2;
	private JButton detp3;
	private JTable publicasTable;
	private JScrollPane publicasScrollPane;
	private JTable privadasTable;
	private JScrollPane privadasScrollPane;
	private JPanel panelCenterNorthRight;
	private JPanel panelCenterSouthRight;
	private JButton dlppb1;
	private JButton dlppb2;
	private JButton dlppb3;
	private JButton dlppb4;
	private JButton dlppv1;
	private JButton dlppv2;
	private JButton dlppv3;
	private JLabel lblUsuario;
	private JLabel lblGrupo;
	private EditorTipoPresentacionController controller;
	private JPanel panelCenterSouthLeft;
	private JPanel panelCenterNorthLeft;
	private JButton dept2;
	private JLabel lblPublicas;
	private JLabel lblNewLabel;

	/**
	 * Launch the application.
	 */
//	public static void main(String[] args) {
//		EventQueue.invokeLater(new Runnable() {
//			public void run() {
//				try {
//					EditorTipoPresentacion frame = new EditorTipoPresentacion();
//					frame.setVisible(true);
//				} catch (Exception e) {
//					e.printStackTrace();
//				}
//			}
//		});
//	}

	/**
	 * Create the frame.
	 */
	public EditorTipoPresentacion(JFrame previous) {
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				controller.cerrarVentana();
			}
		});
		setPreviousWindow(previous);
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		setBounds(200, 200, 800, 600);
		contentPane = new JPanel();
		contentPane.setLayout(new BorderLayout(0, 0));
		setContentPane(contentPane);
		
		panelNorth = new JPanel();
		FlowLayout flowLayout = (FlowLayout) panelNorth.getLayout();
		flowLayout.setVgap(0);
		flowLayout.setAlignment(FlowLayout.LEFT);
		contentPane.add(panelNorth, BorderLayout.NORTH);
		
		toolBarNorth = new JToolBar();
		toolBarNorth.setFloatable(false);
		panelNorth.add(toolBarNorth);
		
		dept1 = new JButton("");
		dept1.setIcon(new ImageIcon(EditorTipoPresentacion.class.getResource("/resources/icons/ok_button.png")));
		dept1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.cerrarVentana();
			}
		});
		toolBarNorth.add(dept1);
		
		dept2 = new JButton("");
		dept2.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.abrirManual();
			}
		});
		dept2.setIcon(new ImageIcon(EditorTipoPresentacion.class.getResource("/resources/icons/help-browser.png")));
		toolBarNorth.add(dept2);
		
		panelSouth = new JPanel();
		panelSouth.setBorder(new BevelBorder(BevelBorder.LOWERED, null, null, null, null));
		FlowLayout flowLayout_2 = (FlowLayout) panelSouth.getLayout();
		flowLayout_2.setVgap(0);
		flowLayout_2.setAlignment(FlowLayout.LEFT);
		contentPane.add(panelSouth, BorderLayout.SOUTH);
		
		lblUsuario = new JLabel("Usuario: Adam");
		panelSouth.add(lblUsuario);
		
		lblGrupo = new JLabel("Grupo: Becario");
		panelSouth.add(lblGrupo);
		
		panelCenter = new JPanel();
		contentPane.add(panelCenter, BorderLayout.CENTER);
		GridBagLayout gbl_panelCenter = new GridBagLayout();
		gbl_panelCenter.columnWidths = new int[]{424, 0};
		gbl_panelCenter.rowHeights = new int[]{69, 69, 69, 0};
		gbl_panelCenter.columnWeights = new double[]{1.0, Double.MIN_VALUE};
		gbl_panelCenter.rowWeights = new double[]{1.0, 0.0, 1.0, Double.MIN_VALUE};
		panelCenter.setLayout(gbl_panelCenter);
		
		panelCenterNorth = new JPanel();
		GridBagConstraints gbc_panelCenterNorth = new GridBagConstraints();
		gbc_panelCenterNorth.fill = GridBagConstraints.BOTH;
		gbc_panelCenterNorth.insets = new Insets(0, 0, 5, 5);
		gbc_panelCenterNorth.gridx = 0;
		gbc_panelCenterNorth.gridy = 0;
		panelCenter.add(panelCenterNorth, gbc_panelCenterNorth);
		GridBagLayout gbl_panelCenterNorth = new GridBagLayout();
		gbl_panelCenterNorth.columnWidths = new int[]{699, 75, 0};
		gbl_panelCenterNorth.rowHeights = new int[]{152, 0};
		gbl_panelCenterNorth.columnWeights = new double[]{1.0, 0.0, Double.MIN_VALUE};
		gbl_panelCenterNorth.rowWeights = new double[]{1.0, Double.MIN_VALUE};
		panelCenterNorth.setLayout(gbl_panelCenterNorth);
		
		panelCenterNorthLeft = new JPanel();
		GridBagConstraints gbc_panelCenterNorthLeft = new GridBagConstraints();
		gbc_panelCenterNorthLeft.fill = GridBagConstraints.BOTH;
		gbc_panelCenterNorthLeft.insets = new Insets(0, 5, 0, 5);
		gbc_panelCenterNorthLeft.gridx = 0;
		gbc_panelCenterNorthLeft.gridy = 0;
		panelCenterNorth.add(panelCenterNorthLeft, gbc_panelCenterNorthLeft);
		GridBagLayout gbl_panelCenterNorthLeft = new GridBagLayout();
		gbl_panelCenterNorthLeft.columnWidths = new int[]{730, 0};
		gbl_panelCenterNorthLeft.rowHeights = new int[]{24, 0, 0};
		gbl_panelCenterNorthLeft.columnWeights = new double[]{1.0, Double.MIN_VALUE};
		gbl_panelCenterNorthLeft.rowWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
		panelCenterNorthLeft.setLayout(gbl_panelCenterNorthLeft);
		
		publicasScrollPane = new JScrollPane();
		GridBagConstraints gbc_publicasScrollPane = new GridBagConstraints();
		gbc_publicasScrollPane.insets = new Insets(0, 0, 5, 0);
		gbc_publicasScrollPane.fill = GridBagConstraints.BOTH;
		gbc_publicasScrollPane.gridx = 0;
		gbc_publicasScrollPane.gridy = 1;
		panelCenterNorthLeft.add(publicasScrollPane, gbc_publicasScrollPane);
		
		publicasTable = new JTable();
		publicasTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

		// Listener de cambio de seleccin de fila
		
		ListSelectionModel selectionModel = publicasTable.getSelectionModel();
		selectionModel.addListSelectionListener(new ListSelectionListener(){

			@Override
			public void valueChanged(ListSelectionEvent arg0) {
				controller.actualizarHabilitacionDisparos();
				
			}
			
		});
		publicasScrollPane.setViewportView(publicasTable);
		
		lblPublicas = new JLabel("Presentaciones P\u00FAblicas:");
		GridBagConstraints gbc_lblPublicas = new GridBagConstraints();
		gbc_lblPublicas.anchor = GridBagConstraints.WEST;
		gbc_lblPublicas.insets = new Insets(0, 15, 0, 0);
		gbc_lblPublicas.gridx = 0;
		gbc_lblPublicas.gridy = 0;
		panelCenterNorthLeft.add(lblPublicas, gbc_lblPublicas);
		
		panelCenterNorthRight = new JPanel();
		GridBagConstraints gbc_panelCenterNorthRight = new GridBagConstraints();
		gbc_panelCenterNorthRight.gridx = 1;
		gbc_panelCenterNorthRight.gridy = 0;
		panelCenterNorth.add(panelCenterNorthRight, gbc_panelCenterNorthRight);
		GridBagLayout gbl_panelCenterNorthRight = new GridBagLayout();
		gbl_panelCenterNorthRight.columnWidths = new int[]{75, 0};
		gbl_panelCenterNorthRight.rowHeights = new int[]{23, 23, 23, 23, 0};
		gbl_panelCenterNorthRight.columnWeights = new double[]{0.0, Double.MIN_VALUE};
		gbl_panelCenterNorthRight.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		panelCenterNorthRight.setLayout(gbl_panelCenterNorthRight);
		
		dlppb1 = new JButton("Nueva");
		dlppb1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.abrirNuevaPresentacion(Presentacion.PUBLICA);
			}
		});
		GridBagConstraints gbc_dlppb1 = new GridBagConstraints();
		gbc_dlppb1.fill = GridBagConstraints.HORIZONTAL;
		gbc_dlppb1.insets = new Insets(0, 0, 5, 0);
		gbc_dlppb1.gridx = 0;
		gbc_dlppb1.gridy = 0;
		panelCenterNorthRight.add(dlppb1, gbc_dlppb1);
		
		dlppb2 = new JButton("Eliminar");
		dlppb2.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.eliminarPresentacionPublica();
			}
		});
		GridBagConstraints gbc_dlppb2 = new GridBagConstraints();
		gbc_dlppb2.fill = GridBagConstraints.HORIZONTAL;
		gbc_dlppb2.insets = new Insets(0, 0, 5, 0);
		gbc_dlppb2.gridx = 0;
		gbc_dlppb2.gridy = 1;
		panelCenterNorthRight.add(dlppb2, gbc_dlppb2);
		
		dlppb3 = new JButton("Modificar");
		dlppb3.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.abrirModificarPresentacion(Presentacion.PUBLICA);
			}
		});
		GridBagConstraints gbc_dlppb3 = new GridBagConstraints();
		gbc_dlppb3.fill = GridBagConstraints.HORIZONTAL;
		gbc_dlppb3.insets = new Insets(0, 0, 5, 0);
		gbc_dlppb3.gridx = 0;
		gbc_dlppb3.gridy = 2;
		panelCenterNorthRight.add(dlppb3, gbc_dlppb3);
		
		dlppb4 = new JButton("Default");
		dlppb4.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.marcarPresentacionDefault();
			}
		});
		GridBagConstraints gbc_dlppb4 = new GridBagConstraints();
		gbc_dlppb4.fill = GridBagConstraints.HORIZONTAL;
		gbc_dlppb4.gridx = 0;
		gbc_dlppb4.gridy = 3;
		panelCenterNorthRight.add(dlppb4, gbc_dlppb4);
		
		panelCenterCenter = new JPanel();
		FlowLayout flowLayout_1 = (FlowLayout) panelCenterCenter.getLayout();
		GridBagConstraints gbc_panelCenterCenter = new GridBagConstraints();
		gbc_panelCenterCenter.fill = GridBagConstraints.HORIZONTAL;
		gbc_panelCenterCenter.insets = new Insets(0, 0, 5, 0);
		gbc_panelCenterCenter.gridx = 0;
		gbc_panelCenterCenter.gridy = 1;
		panelCenter.add(panelCenterCenter, gbc_panelCenterCenter);
		
		detp2 = new JButton("");
		detp2.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.moverArriba();
			}
		});
		detp2.setIcon(new ImageIcon(EditorTipoPresentacion.class.getResource("/resources/icons/go-up.png")));
		panelCenterCenter.add(detp2);
		
		detp3 = new JButton("");
		detp3.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.moverAbajo();
			}
		});
		detp3.setIcon(new ImageIcon(EditorTipoPresentacion.class.getResource("/resources/icons/go-down.png")));
		panelCenterCenter.add(detp3);
		
		panelCenterSouth = new JPanel();
		GridBagConstraints gbc_panelCenterSouth = new GridBagConstraints();
		gbc_panelCenterSouth.fill = GridBagConstraints.BOTH;
		gbc_panelCenterSouth.gridx = 0;
		gbc_panelCenterSouth.gridy = 2;
		gbc_panelCenterSouth.insets = new Insets(0,0,0,5);
		panelCenter.add(panelCenterSouth, gbc_panelCenterSouth);
		GridBagLayout gbl_panelCenterSouth = new GridBagLayout();
		gbl_panelCenterSouth.columnWidths = new int[]{452, 0, 0};
		gbl_panelCenterSouth.rowHeights = new int[]{200, 0};
		gbl_panelCenterSouth.columnWeights = new double[]{1.0, 0.0, Double.MIN_VALUE};
		gbl_panelCenterSouth.rowWeights = new double[]{1.0, Double.MIN_VALUE};
		panelCenterSouth.setLayout(gbl_panelCenterSouth);
		
		panelCenterSouthLeft = new JPanel();
		GridBagConstraints gbc_panelCenterSouthLeft = new GridBagConstraints();
		gbc_panelCenterSouthLeft.fill = GridBagConstraints.BOTH;
		gbc_panelCenterSouthLeft.insets = new Insets(0, 5, 0, 5);
		gbc_panelCenterSouthLeft.gridx = 0;
		gbc_panelCenterSouthLeft.gridy = 0;
		panelCenterSouth.add(panelCenterSouthLeft, gbc_panelCenterSouthLeft);
		GridBagLayout gbl_panelCenterSouthLeft = new GridBagLayout();
		gbl_panelCenterSouthLeft.columnWidths = new int[]{452, 0};
		gbl_panelCenterSouthLeft.rowHeights = new int[]{26, 0, 0};
		gbl_panelCenterSouthLeft.columnWeights = new double[]{1.0, Double.MIN_VALUE};
		gbl_panelCenterSouthLeft.rowWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
		panelCenterSouthLeft.setLayout(gbl_panelCenterSouthLeft);
		
		privadasScrollPane = new JScrollPane();
		GridBagConstraints gbc_privadasScrollPane = new GridBagConstraints();
		gbc_privadasScrollPane.insets = new Insets(0, 0, 5, 0);
		gbc_privadasScrollPane.fill = GridBagConstraints.BOTH;
		gbc_privadasScrollPane.gridx = 0;
		gbc_privadasScrollPane.gridy = 1;
		panelCenterSouthLeft.add(privadasScrollPane, gbc_privadasScrollPane);
		
		privadasTable = new JTable();
		privadasTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

		// Listener de cambio de seleccin de fila
		
		selectionModel = privadasTable.getSelectionModel();
		selectionModel.addListSelectionListener(new ListSelectionListener(){

			@Override
			public void valueChanged(ListSelectionEvent arg0) {
				controller.actualizarHabilitacionDisparos();
				
			}
			
		});
		privadasScrollPane.setViewportView(privadasTable);
		
		lblNewLabel = new JLabel("Presentaciones Privadas:");
		GridBagConstraints gbc_lblNewLabel = new GridBagConstraints();
		gbc_lblNewLabel.anchor = GridBagConstraints.WEST;
		gbc_lblNewLabel.gridx = 0;
		gbc_lblNewLabel.gridy = 0;
		gbc_lblNewLabel.insets = new Insets(0, 15, 0, 0);
		panelCenterSouthLeft.add(lblNewLabel, gbc_lblNewLabel);
		
		panelCenterSouthRight = new JPanel();
		GridBagConstraints gbc_panelCenterSouthRight = new GridBagConstraints();
		gbc_panelCenterSouthRight.gridx = 1;
		gbc_panelCenterSouthRight.gridy = 0;
		panelCenterSouth.add(panelCenterSouthRight, gbc_panelCenterSouthRight);
		GridBagLayout gbl_panelCenterSouthRight = new GridBagLayout();
		gbl_panelCenterSouthRight.columnWidths = new int[]{75, 0};
		gbl_panelCenterSouthRight.rowHeights = new int[]{23, 23, 23, 0};
		gbl_panelCenterSouthRight.columnWeights = new double[]{0.0, Double.MIN_VALUE};
		gbl_panelCenterSouthRight.rowWeights = new double[]{0.0, 0.0, 0.0, Double.MIN_VALUE};
		panelCenterSouthRight.setLayout(gbl_panelCenterSouthRight);
		
		dlppv1 = new JButton("Nueva");
		dlppv1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.abrirNuevaPresentacion(Presentacion.PRIVADA);
			}
		});
		GridBagConstraints gbc_dlppv1 = new GridBagConstraints();
		gbc_dlppv1.fill = GridBagConstraints.HORIZONTAL;
		gbc_dlppv1.insets = new Insets(0, 0, 5, 0);
		gbc_dlppv1.gridx = 0;
		gbc_dlppv1.gridy = 0;
		panelCenterSouthRight.add(dlppv1, gbc_dlppv1);
		
		dlppv2 = new JButton("Eliminar");
		dlppv2.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.eliminarPresentacionPrivada();
			}
		});
		GridBagConstraints gbc_dlppv2 = new GridBagConstraints();
		gbc_dlppv2.fill = GridBagConstraints.HORIZONTAL;
		gbc_dlppv2.insets = new Insets(0, 0, 5, 0);
		gbc_dlppv2.gridx = 0;
		gbc_dlppv2.gridy = 1;
		panelCenterSouthRight.add(dlppv2, gbc_dlppv2);
		
		dlppv3 = new JButton("Modificar");
		dlppv3.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.abrirModificarPresentacion(Presentacion.PRIVADA);
			}
		});
		GridBagConstraints gbc_dlppv3 = new GridBagConstraints();
		gbc_dlppv3.fill = GridBagConstraints.HORIZONTAL;
		gbc_dlppv3.gridx = 0;
		gbc_dlppv3.gridy = 2;
		panelCenterSouthRight.add(dlppv3, gbc_dlppv3);
		

		controller = EditorTipoPresentacionController.getInstance();
		controller.setView(this);
		
		this.setTitle("Editor de tipo de presentacin");
		controller.inicializar();
	}

	public JFrame getPreviousWindow() {
		return previousWindow;
	}

	public void setPreviousWindow(JFrame previousWindow) {
		this.previousWindow = previousWindow;
	}

	public JTable getPublicasTable() {
		return publicasTable;
	}

	public void setPublicasTable(JTable publicasTable) {
		this.publicasTable = publicasTable;
	}

	public JTable getPrivadasTable() {
		return privadasTable;
	}

	public void setPrivadasTable(JTable privadasTable) {
		this.privadasTable = privadasTable;
	}

	public JButton getDept1() {
		return dept1;
	}

	public void setDept1(JButton dept1) {
		this.dept1 = dept1;
	}

	public JButton getDetp2() {
		return detp2;
	}

	public void setDetp2(JButton detp2) {
		this.detp2 = detp2;
	}

	public JButton getDetp3() {
		return detp3;
	}

	public void setDetp3(JButton detp3) {
		this.detp3 = detp3;
	}

	public JButton getDlppb1() {
		return dlppb1;
	}

	public void setDlppb1(JButton dlppb1) {
		this.dlppb1 = dlppb1;
	}

	public JButton getDlppb2() {
		return dlppb2;
	}

	public void setDlppb2(JButton dlppb2) {
		this.dlppb2 = dlppb2;
	}

	public JButton getDlppb3() {
		return dlppb3;
	}

	public void setDlppb3(JButton dlppb3) {
		this.dlppb3 = dlppb3;
	}

	public JButton getDlppb4() {
		return dlppb4;
	}

	public void setDlppb4(JButton dlppb4) {
		this.dlppb4 = dlppb4;
	}

	public JButton getDlppv1() {
		return dlppv1;
	}

	public void setDlppv1(JButton dlppv1) {
		this.dlppv1 = dlppv1;
	}

	public JButton getDlppv2() {
		return dlppv2;
	}

	public void setDlppv2(JButton dlppv2) {
		this.dlppv2 = dlppv2;
	}

	public JButton getDlppv3() {
		return dlppv3;
	}

	public void setDlppv3(JButton dlppv3) {
		this.dlppv3 = dlppv3;
	}

	public EditorTipoPresentacionController getController() {
		return controller;
	}

	public void setController(EditorTipoPresentacionController controller) {
		this.controller = controller;
	}
	
	

}
