package vista;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JToolBar;
import javax.swing.JLabel;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import javax.swing.JScrollPane;
import javax.swing.JTable;

import utils.tablemodels.ExampleModel;
import javax.swing.JTextField;
import javax.swing.JComboBox;
import java.awt.FlowLayout;
import javax.swing.JButton;
import javax.swing.ImageIcon;

import controlador.GestionUsuariosController;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.border.BevelBorder;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.ListSelectionModel;
import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;

public class GestionUsuarios extends JFrame {

	private JPanel contentPane;
	private JPanel panelSouth;
	private JPanel panelNorth;
	private JPanel panelCenter;
	private JToolBar toolBar;
	private JLabel lblUsuario;
	private JLabel lblGrupo;
	private JPanel panelLeft;
	private JPanel panelRight;
	private JTable table;
	private JScrollPane scrollPane;
	private JLabel lblNombreReal;
	private JLabel lblNombreDeUsuario;
	private JLabel lblMail;
	private JLabel lblTipoUsuario;
	private JTextField textFieldNombreReal;
	private JTextField textFieldNombreUsuario;
	private JTextField textFieldMail;
	private JComboBox comboBoxTipoUsuario;
	private JButton dgu1button;
	private JButton dgu2button;
	private JButton dgu3button;
	private JButton dgu4button;

	private JFrame previousWindow;
	private GestionUsuariosController controller;

	/**
	 * Launch the application.
	 */
	//	public static void main(String[] args) {
	//		EventQueue.invokeLater(new Runnable() {
	//			public void run() {
	//				try {
	//					GestionUsuarios frame = new GestionUsuarios();
	//					frame.setVisible(true);
	//				} catch (Exception e) {
	//					e.printStackTrace();
	//				}
	//			}
	//		});
	//	}

	/**
	 * Create the frame.
	 */
	public GestionUsuarios(JFrame previousWindow) {
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent arg0) {
				controller.cerrarVentana();
			}
		});
		setTitle("Gesti\u00F3n de usuarios");
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		setBounds(100, 100, 650, 300);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(0, 0));
		setContentPane(contentPane);

		panelSouth = new JPanel();
		panelSouth.setBorder(new BevelBorder(BevelBorder.LOWERED, null, null, null, null));
		FlowLayout flowLayout = (FlowLayout) panelSouth.getLayout();
		flowLayout.setAlignment(FlowLayout.LEFT);
		flowLayout.setVgap(0);
		contentPane.add(panelSouth, BorderLayout.SOUTH);

		lblUsuario = new JLabel("Usuario: Adam");
		panelSouth.add(lblUsuario);

		lblGrupo = new JLabel("Grupo: Becario");
		panelSouth.add(lblGrupo);

		panelNorth = new JPanel();
		FlowLayout flowLayout_1 = (FlowLayout) panelNorth.getLayout();
		flowLayout_1.setVgap(0);
		flowLayout_1.setHgap(0);
		flowLayout_1.setAlignment(FlowLayout.LEFT);
		contentPane.add(panelNorth, BorderLayout.NORTH);

		toolBar = new JToolBar();
		toolBar.setFloatable(false);
		panelNorth.add(toolBar);

		dgu1button = new JButton("");
		dgu1button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.agregarUsuario();
			}
		});
		dgu1button.setIcon(new ImageIcon(GestionUsuarios.class.getResource("/resources/icons/list-add.png")));
		dgu1button.setToolTipText("Agregar usuario");
		toolBar.add(dgu1button);

		dgu2button = new JButton("");
		dgu2button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.eliminarUsuario();
			}
		});
		dgu2button.setIcon(new ImageIcon(GestionUsuarios.class.getResource("/resources/icons/list-remove.png")));
		dgu2button.setToolTipText("Eliminar usuario");
		toolBar.add(dgu2button);

		dgu3button = new JButton("");
		dgu3button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.cerrarVentana();
			}
		});
		dgu3button.setIcon(new ImageIcon(GestionUsuarios.class.getResource("/resources/icons/ok_button.png")));
		dgu3button.setToolTipText("Salir");
		toolBar.add(dgu3button);

		dgu4button = new JButton("");
		dgu4button.setIcon(new ImageIcon(GestionUsuarios.class.getResource("/resources/icons/help-browser.png")));
		dgu4button.setToolTipText("Ayuda");
		toolBar.add(dgu4button);

		panelCenter = new JPanel();
		contentPane.add(panelCenter, BorderLayout.CENTER);
		GridBagLayout gbl_panelCenter = new GridBagLayout();
		gbl_panelCenter.columnWidths = new int[]{388, 260};
		gbl_panelCenter.rowHeights = new int[]{0, 0};
		gbl_panelCenter.columnWeights = new double[]{1.0, 4.9E-324};
		gbl_panelCenter.rowWeights = new double[]{1.0, Double.MIN_VALUE};
		panelCenter.setLayout(gbl_panelCenter);

		panelLeft = new JPanel();
		GridBagConstraints gbc_panelLeft = new GridBagConstraints();
		gbc_panelLeft.insets = new Insets(0, 0, 0, 5);
		gbc_panelLeft.fill = GridBagConstraints.BOTH;
		gbc_panelLeft.gridx = 0;
		gbc_panelLeft.gridy = 0;
		panelCenter.add(panelLeft, gbc_panelLeft);
		panelLeft.setLayout(new BorderLayout(0, 0));

		scrollPane = new JScrollPane();
		panelLeft.add(scrollPane);

		table = new JTable(new ExampleModel());
		table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		ListSelectionModel selectionModel = table.getSelectionModel();
		selectionModel.addListSelectionListener(new ListSelectionListener(){

			@Override
			public void valueChanged(ListSelectionEvent arg0) {
				controller.habilitarCampos();
				controller.actualizarCampos();

			}

		});
		scrollPane.setViewportView(table);

		panelRight = new JPanel();
		GridBagConstraints gbc_panelRight = new GridBagConstraints();
		gbc_panelRight.fill = GridBagConstraints.BOTH;
		gbc_panelRight.gridx = 1;
		gbc_panelRight.gridy = 0;
		panelCenter.add(panelRight, gbc_panelRight);
		GridBagLayout gbl_panelRight = new GridBagLayout();
		gbl_panelRight.columnWidths = new int[]{0, 0, 0};
		gbl_panelRight.rowHeights = new int[]{0, 0, 0, 0, 0};
		gbl_panelRight.columnWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
		gbl_panelRight.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		panelRight.setLayout(gbl_panelRight);

		lblNombreReal = new JLabel("Nombre real:");
		GridBagConstraints gbc_lblNombreReal = new GridBagConstraints();
		gbc_lblNombreReal.anchor = GridBagConstraints.EAST;
		gbc_lblNombreReal.insets = new Insets(5, 5, 5, 5);
		gbc_lblNombreReal.gridx = 0;
		gbc_lblNombreReal.gridy = 0;
		panelRight.add(lblNombreReal, gbc_lblNombreReal);

		textFieldNombreReal = new JTextField();
		textFieldNombreReal.getDocument().addDocumentListener(new DocumentListener() {
			public void changedUpdate(DocumentEvent e) {
				controller.cambiarNombre();
			}
			public void removeUpdate(DocumentEvent e) {
				controller.cambiarNombre();
			}
			public void insertUpdate(DocumentEvent e) {
				controller.cambiarNombre();
			}
		});
		lblNombreReal.setLabelFor(textFieldNombreReal);
		GridBagConstraints gbc_textFieldNombreReal = new GridBagConstraints();
		gbc_textFieldNombreReal.insets = new Insets(5, 0, 5, 5);
		gbc_textFieldNombreReal.fill = GridBagConstraints.HORIZONTAL;
		gbc_textFieldNombreReal.gridx = 1;
		gbc_textFieldNombreReal.gridy = 0;
		panelRight.add(textFieldNombreReal, gbc_textFieldNombreReal);
		textFieldNombreReal.setColumns(10);

		lblNombreDeUsuario = new JLabel("Nombre de usuario:");
		GridBagConstraints gbc_lblNombreDeUsuario = new GridBagConstraints();
		gbc_lblNombreDeUsuario.anchor = GridBagConstraints.EAST;
		gbc_lblNombreDeUsuario.insets = new Insets(5, 5, 5, 5);
		gbc_lblNombreDeUsuario.gridx = 0;
		gbc_lblNombreDeUsuario.gridy = 1;
		panelRight.add(lblNombreDeUsuario, gbc_lblNombreDeUsuario);

		textFieldNombreUsuario = new JTextField();

		textFieldNombreUsuario.setEnabled(false);
		GridBagConstraints gbc_textFieldNombreUsuario = new GridBagConstraints();
		gbc_textFieldNombreUsuario.insets = new Insets(5, 0, 5, 5);
		gbc_textFieldNombreUsuario.fill = GridBagConstraints.HORIZONTAL;
		gbc_textFieldNombreUsuario.gridx = 1;
		gbc_textFieldNombreUsuario.gridy = 1;
		panelRight.add(textFieldNombreUsuario, gbc_textFieldNombreUsuario);
		textFieldNombreUsuario.setColumns(10);

		lblMail = new JLabel("Correo electr\u00F3nico:");
		GridBagConstraints gbc_lblMail = new GridBagConstraints();
		gbc_lblMail.anchor = GridBagConstraints.EAST;
		gbc_lblMail.insets = new Insets(5, 5, 5, 5);
		gbc_lblMail.gridx = 0;
		gbc_lblMail.gridy = 2;
		panelRight.add(lblMail, gbc_lblMail);

		textFieldMail = new JTextField();
		textFieldMail.getDocument().addDocumentListener(new DocumentListener() {
			public void changedUpdate(DocumentEvent e) {
				controller.cambiarMail();
			}
			public void removeUpdate(DocumentEvent e) {
				controller.cambiarMail();
			}
			public void insertUpdate(DocumentEvent e) {
				controller.cambiarMail();
			}
		});
		GridBagConstraints gbc_textFieldMail = new GridBagConstraints();
		gbc_textFieldMail.insets = new Insets(5, 0, 5, 5);
		gbc_textFieldMail.fill = GridBagConstraints.HORIZONTAL;
		gbc_textFieldMail.gridx = 1;
		gbc_textFieldMail.gridy = 2;
		panelRight.add(textFieldMail, gbc_textFieldMail);
		textFieldMail.setColumns(10);

		lblTipoUsuario = new JLabel("Tipo de usuario: ");
		GridBagConstraints gbc_lblTipoUsuario = new GridBagConstraints();
		gbc_lblTipoUsuario.insets = new Insets(5, 5, 0, 5);
		gbc_lblTipoUsuario.anchor = GridBagConstraints.EAST;
		gbc_lblTipoUsuario.gridx = 0;
		gbc_lblTipoUsuario.gridy = 3;
		panelRight.add(lblTipoUsuario, gbc_lblTipoUsuario);

		String []tipos = {"Normal", "Administrador"};
		comboBoxTipoUsuario = new JComboBox(tipos);
		comboBoxTipoUsuario.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent arg0) {
				controller.cambiarTipo();
			}
		});
		GridBagConstraints gbc_comboBoxTipoUsuario = new GridBagConstraints();
		gbc_comboBoxTipoUsuario.insets = new Insets(5, 0, 5, 5);
		gbc_comboBoxTipoUsuario.fill = GridBagConstraints.HORIZONTAL;
		gbc_comboBoxTipoUsuario.gridx = 1;
		gbc_comboBoxTipoUsuario.gridy = 3;
		panelRight.add(comboBoxTipoUsuario, gbc_comboBoxTipoUsuario);

		controller = GestionUsuariosController.getInstance();
		controller.inicializar(this);

		this.previousWindow = previousWindow;
	}

	public JLabel getLblUsuario() {
		return lblUsuario;
	}

	public void setLblUsuario(JLabel lblUsuario) {
		this.lblUsuario = lblUsuario;
	}

	public JLabel getLblGrupo() {
		return lblGrupo;
	}

	public void setLblGrupo(JLabel lblGrupo) {
		this.lblGrupo = lblGrupo;
	}

	public JTable getTable() {
		return table;
	}

	public void setTable(JTable table) {
		this.table = table;
	}

	public JLabel getLblNombreReal() {
		return lblNombreReal;
	}

	public void setLblNombreReal(JLabel lblNombreReal) {
		this.lblNombreReal = lblNombreReal;
	}

	public JLabel getLblNombreDeUsuario() {
		return lblNombreDeUsuario;
	}

	public void setLblNombreDeUsuario(JLabel lblNombreDeUsuario) {
		this.lblNombreDeUsuario = lblNombreDeUsuario;
	}

	public JLabel getLblMail() {
		return lblMail;
	}

	public void setLblMail(JLabel lblMail) {
		this.lblMail = lblMail;
	}

	public JLabel getLblTipoUsuario() {
		return lblTipoUsuario;
	}

	public void setLblTipoUsuario(JLabel lblTipoUsuario) {
		this.lblTipoUsuario = lblTipoUsuario;
	}

	public JButton getDgu1button() {
		return dgu1button;
	}

	public void setDgu1button(JButton dgu1button) {
		this.dgu1button = dgu1button;
	}

	public JButton getDgu2button() {
		return dgu2button;
	}

	public void setDgu2button(JButton dgu2button) {
		this.dgu2button = dgu2button;
	}

	public JButton getDgu3button() {
		return dgu3button;
	}

	public void setDgu3button(JButton dgu3button) {
		this.dgu3button = dgu3button;
	}

	public JButton getDgu4button() {
		return dgu4button;
	}

	public void setDgu4button(JButton dgu4button) {
		this.dgu4button = dgu4button;
	}

	public GestionUsuariosController getController() {
		return controller;
	}

	public void setController(GestionUsuariosController controller) {
		this.controller = controller;
	}

	public JFrame getPreviousWindow() {
		return previousWindow;
	}

	public void setPreviousWindow(JFrame previousWindow) {
		this.previousWindow = previousWindow;
	}

	public JTextField getTextFieldNombreReal() {
		return textFieldNombreReal;
	}

	public void setTextFieldNombreReal(JTextField textFieldNombreReal) {
		this.textFieldNombreReal = textFieldNombreReal;
	}

	public JTextField getTextFieldNombreUsuario() {
		return textFieldNombreUsuario;
	}

	public void setTextFieldNombreUsuario(JTextField textFieldNombreUsuario) {
		this.textFieldNombreUsuario = textFieldNombreUsuario;
	}

	public JTextField getTextFieldMail() {
		return textFieldMail;
	}

	public void setTextFieldMail(JTextField textFieldMail) {
		this.textFieldMail = textFieldMail;
	}

	public JComboBox getComboBoxTipoUsuario() {
		return comboBoxTipoUsuario;
	}

	public void setComboBoxTipoUsuario(JComboBox comboBoxTipoUsuario) {
		this.comboBoxTipoUsuario = comboBoxTipoUsuario;
	}



}
