package vista;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import javax.swing.JToolBar;
import java.awt.FlowLayout;
import javax.swing.JButton;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.JScrollPane;

import modelo.Grupo;

import controlador.GestionUsuariosGrupoController;

import utils.tablemodels.ExampleModel;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.border.BevelBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.ListSelectionModel;

public class GestionUsuariosGrupo extends JFrame {

	private JPanel contentPane;
	private JPanel panelSouth;
	private JPanel panelNorth;
	private JPanel panelCenter;
	private JPanel panelCenterLeft;
	private JPanel panelCenterCenter;
	private JPanel panelCenterRight;
	private JToolBar toolBar;
	private JButton dgg1button;
	private JButton dgg2button;
	private JButton dgg3button;
	private JButton dgg4button;
	private JLabel lblUsuarios;
	private JLabel lblUsuariosDelGrupo;
	private JTable tableLUNG;
	private JTable tableLUG;
	private JScrollPane scrollPane;
	private JScrollPane scrollPane_1;
	private JLabel lblUsuario;
	private JLabel lblGrupo;

	private JFrame previousWindow;
	private GestionUsuariosGrupoController controller;


	/**
	 * Create the frame.
	 */
	public GestionUsuariosGrupo(JFrame previousWindow, Grupo grupo) {
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent arg0) {
				controller.cerrarVentana();
			}
		});
		setTitle("Gesti\u00F3n de los usuarios del grupo " + grupo.getNombre());
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		setBounds(100, 100, 611, 300);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(0, 0));
		setContentPane(contentPane);

		panelSouth = new JPanel();
		panelSouth.setBorder(new BevelBorder(BevelBorder.LOWERED, null, null, null, null));
		FlowLayout flowLayout_1 = (FlowLayout) panelSouth.getLayout();
		flowLayout_1.setAlignment(FlowLayout.LEFT);
		flowLayout_1.setVgap(0);
		contentPane.add(panelSouth, BorderLayout.SOUTH);

		lblUsuario = new JLabel("Usuario: Adam");
		panelSouth.add(lblUsuario);

		lblGrupo = new JLabel("Grupo: Becario");
		panelSouth.add(lblGrupo);

		panelNorth = new JPanel();
		FlowLayout flowLayout = (FlowLayout) panelNorth.getLayout();
		flowLayout.setAlignment(FlowLayout.LEFT);
		flowLayout.setVgap(0);
		flowLayout.setHgap(0);
		contentPane.add(panelNorth, BorderLayout.NORTH);

		toolBar = new JToolBar();
		toolBar.setFloatable(false);
		panelNorth.add(toolBar);

		dgg1button = new JButton("");
		dgg1button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.cerrarVentana();
			}
		});
		dgg1button.setIcon(new ImageIcon(GestionUsuariosGrupo.class.getResource("/resources/icons/ok_button.png")));
		toolBar.add(dgg1button);

		dgg2button = new JButton("");
		dgg2button.setIcon(new ImageIcon(GestionUsuariosGrupo.class.getResource("/resources/icons/help-browser.png")));
		toolBar.add(dgg2button);

		panelCenter = new JPanel();
		contentPane.add(panelCenter, BorderLayout.CENTER);
		GridBagLayout gbl_panelCenter = new GridBagLayout();
		gbl_panelCenter.columnWidths = new int[]{300, 0, 300, 0};
		gbl_panelCenter.rowHeights = new int[]{0, 0};
		gbl_panelCenter.columnWeights = new double[]{1.0, 0.0, 1.0, Double.MIN_VALUE};
		gbl_panelCenter.rowWeights = new double[]{1.0, Double.MIN_VALUE};
		panelCenter.setLayout(gbl_panelCenter);

		panelCenterLeft = new JPanel();
		GridBagConstraints gbc_panelCenterLeft = new GridBagConstraints();
		gbc_panelCenterLeft.insets = new Insets(0, 0, 0, 5);
		gbc_panelCenterLeft.fill = GridBagConstraints.BOTH;
		gbc_panelCenterLeft.gridx = 0;
		gbc_panelCenterLeft.gridy = 0;
		panelCenter.add(panelCenterLeft, gbc_panelCenterLeft);
		GridBagLayout gbl_panelCenterLeft = new GridBagLayout();
		gbl_panelCenterLeft.columnWidths = new int[]{0, 0};
		gbl_panelCenterLeft.rowHeights = new int[]{0, 0, 0};
		gbl_panelCenterLeft.columnWeights = new double[]{1.0, Double.MIN_VALUE};
		gbl_panelCenterLeft.rowWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
		panelCenterLeft.setLayout(gbl_panelCenterLeft);

		lblUsuarios = new JLabel("Usuarios:");
		GridBagConstraints gbc_lblUsuarios = new GridBagConstraints();
		gbc_lblUsuarios.anchor = GridBagConstraints.WEST;
		gbc_lblUsuarios.insets = new Insets(5, 5, 5, 5);
		gbc_lblUsuarios.gridx = 0;
		gbc_lblUsuarios.gridy = 0;
		panelCenterLeft.add(lblUsuarios, gbc_lblUsuarios);

		scrollPane = new JScrollPane();
		GridBagConstraints gbc_scrollPane = new GridBagConstraints();
		gbc_scrollPane.fill = GridBagConstraints.BOTH;
		gbc_scrollPane.insets = new Insets(5, 5, 5, 5);
		gbc_scrollPane.gridx = 0;
		gbc_scrollPane.gridy = 1;
		panelCenterLeft.add(scrollPane, gbc_scrollPane);

		tableLUNG = new JTable(new ExampleModel());
		tableLUNG.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

		scrollPane.setViewportView(tableLUNG);

		panelCenterCenter = new JPanel();
		GridBagConstraints gbc_panelCenterCenter = new GridBagConstraints();
		gbc_panelCenterCenter.insets = new Insets(0, 0, 0, 5);
		gbc_panelCenterCenter.gridx = 1;
		gbc_panelCenterCenter.gridy = 0;
		panelCenter.add(panelCenterCenter, gbc_panelCenterCenter);
		GridBagLayout gbl_panelCenterCenter = new GridBagLayout();
		gbl_panelCenterCenter.columnWidths = new int[]{33, 0};
		gbl_panelCenterCenter.rowHeights = new int[]{23, 23, 0};
		gbl_panelCenterCenter.columnWeights = new double[]{0.0, Double.MIN_VALUE};
		gbl_panelCenterCenter.rowWeights = new double[]{0.0, 0.0, Double.MIN_VALUE};
		panelCenterCenter.setLayout(gbl_panelCenterCenter);

		dgg3button = new JButton("");
		dgg3button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.moverDerecha();
				controller.habilitarDisparos();
			}
		});
		dgg3button.setIcon(new ImageIcon(GestionUsuariosGrupo.class.getResource("/resources/icons/go-next.png")));
		GridBagConstraints gbc_dgg3button = new GridBagConstraints();
		gbc_dgg3button.fill = GridBagConstraints.HORIZONTAL;
		gbc_dgg3button.insets = new Insets(0, 0, 5, 0);
		gbc_dgg3button.gridx = 0;
		gbc_dgg3button.gridy = 0;
		panelCenterCenter.add(dgg3button, gbc_dgg3button);

		dgg4button = new JButton("");
		dgg4button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.moverIzquierda();
				controller.habilitarDisparos();
			}
		});
		dgg4button.setIcon(new ImageIcon(GestionUsuariosGrupo.class.getResource("/resources/icons/go-previous.png")));
		GridBagConstraints gbc_dgg4button = new GridBagConstraints();
		gbc_dgg4button.fill = GridBagConstraints.HORIZONTAL;
		gbc_dgg4button.gridx = 0;
		gbc_dgg4button.gridy = 1;
		panelCenterCenter.add(dgg4button, gbc_dgg4button);

		panelCenterRight = new JPanel();
		GridBagConstraints gbc_panelCenterRight = new GridBagConstraints();
		gbc_panelCenterRight.fill = GridBagConstraints.BOTH;
		gbc_panelCenterRight.gridx = 2;
		gbc_panelCenterRight.gridy = 0;
		panelCenter.add(panelCenterRight, gbc_panelCenterRight);
		GridBagLayout gbl_panelCenterRight = new GridBagLayout();
		gbl_panelCenterRight.columnWidths = new int[]{0, 0};
		gbl_panelCenterRight.rowHeights = new int[]{0, 0, 0};
		gbl_panelCenterRight.columnWeights = new double[]{1.0, Double.MIN_VALUE};
		gbl_panelCenterRight.rowWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
		panelCenterRight.setLayout(gbl_panelCenterRight);

		lblUsuariosDelGrupo = new JLabel("Usuarios del grupo " + grupo.getNombre() + ":");
		GridBagConstraints gbc_lblUsuariosDelGrupo = new GridBagConstraints();
		gbc_lblUsuariosDelGrupo.anchor = GridBagConstraints.WEST;
		gbc_lblUsuariosDelGrupo.insets = new Insets(5, 5, 5, 5);
		gbc_lblUsuariosDelGrupo.gridx = 0;
		gbc_lblUsuariosDelGrupo.gridy = 0;
		panelCenterRight.add(lblUsuariosDelGrupo, gbc_lblUsuariosDelGrupo);

		scrollPane_1 = new JScrollPane();
		GridBagConstraints gbc_scrollPane_1 = new GridBagConstraints();
		gbc_scrollPane_1.insets = new Insets(5, 5, 5, 5);
		gbc_scrollPane_1.fill = GridBagConstraints.BOTH;
		gbc_scrollPane_1.gridx = 0;
		gbc_scrollPane_1.gridy = 1;
		panelCenterRight.add(scrollPane_1, gbc_scrollPane_1);

		tableLUG = new JTable(new ExampleModel());
		tableLUG.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		ListSelectionModel selectionModel2 = tableLUG.getSelectionModel();
		scrollPane_1.setViewportView(tableLUG);

		this.previousWindow = previousWindow;
		controller = GestionUsuariosGrupoController.getInstance();
		controller.inicializar(this, grupo);
	}


	public JButton getDgg1button() {
		return dgg1button;
	}


	public void setDgg1button(JButton dgg1button) {
		this.dgg1button = dgg1button;
	}


	public JButton getDgg2button() {
		return dgg2button;
	}


	public void setDgg2button(JButton dgg2button) {
		this.dgg2button = dgg2button;
	}


	public JButton getDgg3button() {
		return dgg3button;
	}


	public void setDgg3button(JButton dgg3button) {
		this.dgg3button = dgg3button;
	}


	public JButton getDgg4button() {
		return dgg4button;
	}


	public void setDgg4button(JButton dgg4button) {
		this.dgg4button = dgg4button;
	}


	public JLabel getLblUsuarios() {
		return lblUsuarios;
	}


	public void setLblUsuarios(JLabel lblUsuarios) {
		this.lblUsuarios = lblUsuarios;
	}


	public JLabel getLblUsuariosDelGrupo() {
		return lblUsuariosDelGrupo;
	}


	public void setLblUsuariosDelGrupo(JLabel lblUsuariosDelGrupo) {
		this.lblUsuariosDelGrupo = lblUsuariosDelGrupo;
	}


	public JTable getTableLUNG() {
		return tableLUNG;
	}


	public void setTableLUNG(JTable tableLUNG) {
		this.tableLUNG = tableLUNG;
	}


	public JTable getTableLUG() {
		return tableLUG;
	}


	public void setTableLUG(JTable tableLUG) {
		this.tableLUG = tableLUG;
	}


	public JLabel getLblUsuario() {
		return lblUsuario;
	}


	public void setLblUsuario(JLabel lblUsuario) {
		this.lblUsuario = lblUsuario;
	}


	public JLabel getLblGrupo() {
		return lblGrupo;
	}


	public void setLblGrupo(JLabel lblGrupo) {
		this.lblGrupo = lblGrupo;
	}


	public JFrame getPreviousWindow() {
		return previousWindow;
	}


	public void setPreviousWindow(JFrame previousWindow) {
		this.previousWindow = previousWindow;
	}



}
