package vista;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.JScrollPane;

import utils.tablemodels.ExampleModel;
import javax.swing.JToolBar;
import java.awt.FlowLayout;
import javax.swing.JButton;
import javax.swing.ImageIcon;
import javax.swing.ListSelectionModel;

import controlador.LocalizadorAreasEsquemasController;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class LocalizadorAreasEsquemas extends JFrame {

	private JPanel contentPane;
	private JPanel panelNorth;
	private JPanel panelSouth;
	private JPanel panelCenter;
	private JPanel panelCenterTL;
	private JPanel panelCenterTR;
	private JPanel panelCenterBL;
	private JPanel panelCenterBR;
	private JLabel lblAreas;
	private JLabel lblEsquemas;
	private JTable tableAreas;
	private JScrollPane scrollPane;
	private JTable tableEsquemas;
	private JScrollPane scrollPane_1;
	private JToolBar toolBar;
	private JButton dlae1button;
	private JButton dlae2button;
	private JButton dla1button;
	private JButton dla2button;
	private JButton dla3button;
	private JButton dle1button;
	private JButton dle2button;
	private JButton dle3button;
	private JLabel lblUsuario;
	private JLabel lblGrupos;
	private LocalizadorAreasEsquemasController controller;
	private JFrame previousWindow;

	/**
	 * Create the frame.
	 */
	public LocalizadorAreasEsquemas(JFrame previousWindow) {
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent arg0) {
				controller.cerrarVentana();
			}
		});
		setTitle("\u00C1reas y esquemas");
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		setBounds(100, 100, 450, 550);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(0, 0));
		setContentPane(contentPane);
		
		panelNorth = new JPanel();
		FlowLayout flowLayout = (FlowLayout) panelNorth.getLayout();
		flowLayout.setVgap(0);
		flowLayout.setAlignment(FlowLayout.LEFT);
		flowLayout.setHgap(0);
		contentPane.add(panelNorth, BorderLayout.NORTH);
		
		toolBar = new JToolBar();
		toolBar.setFloatable(false);
		panelNorth.add(toolBar);
		
		dlae1button = new JButton("");
		dlae1button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.cerrarVentana();
			}
		});
		dlae1button.setIcon(new ImageIcon(LocalizadorAreasEsquemas.class.getResource("/resources/icons/ok_button.png")));
		toolBar.add(dlae1button);
		
		dlae2button = new JButton("");
		dlae2button.setIcon(new ImageIcon(LocalizadorAreasEsquemas.class.getResource("/resources/icons/help-browser.png")));
		toolBar.add(dlae2button);
		
		panelSouth = new JPanel();
		FlowLayout flowLayout_1 = (FlowLayout) panelSouth.getLayout();
		flowLayout_1.setVgap(0);
		flowLayout_1.setAlignment(FlowLayout.LEFT);
		contentPane.add(panelSouth, BorderLayout.SOUTH);
		
		lblUsuario = new JLabel("Usuario: Adam");
		panelSouth.add(lblUsuario);
		
		lblGrupos = new JLabel("Grupos: Becario");
		panelSouth.add(lblGrupos);
		
		panelCenter = new JPanel();
		contentPane.add(panelCenter, BorderLayout.CENTER);
		GridBagLayout gbl_panelCenter = new GridBagLayout();
		gbl_panelCenter.columnWidths = new int[]{0, 0, 0};
		gbl_panelCenter.rowHeights = new int[]{0, 0, 0};
		gbl_panelCenter.columnWeights = new double[]{1.0, 0.0, Double.MIN_VALUE};
		gbl_panelCenter.rowWeights = new double[]{1.0, 1.0, Double.MIN_VALUE};
		panelCenter.setLayout(gbl_panelCenter);
		
		panelCenterTL = new JPanel();
		GridBagConstraints gbc_panelCenterTL = new GridBagConstraints();
		gbc_panelCenterTL.insets = new Insets(0, 0, 0, 0);
		gbc_panelCenterTL.fill = GridBagConstraints.BOTH;
		gbc_panelCenterTL.gridx = 0;
		gbc_panelCenterTL.gridy = 0;
		panelCenter.add(panelCenterTL, gbc_panelCenterTL);
		GridBagLayout gbl_panelCenterTL = new GridBagLayout();
		gbl_panelCenterTL.columnWidths = new int[]{0, 0};
		gbl_panelCenterTL.rowHeights = new int[]{0, 0, 0};
		gbl_panelCenterTL.columnWeights = new double[]{1.0, Double.MIN_VALUE};
		gbl_panelCenterTL.rowWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
		panelCenterTL.setLayout(gbl_panelCenterTL);
		
		lblAreas = new JLabel("\u00C1reas:");
		GridBagConstraints gbc_lblAreas = new GridBagConstraints();
		gbc_lblAreas.anchor = GridBagConstraints.WEST;
		gbc_lblAreas.insets = new Insets(5, 5, 5, 5);
		gbc_lblAreas.gridx = 0;
		gbc_lblAreas.gridy = 0;
		panelCenterTL.add(lblAreas, gbc_lblAreas);
		
		scrollPane = new JScrollPane();
		GridBagConstraints gbc_scrollPane = new GridBagConstraints();
		gbc_scrollPane.fill = GridBagConstraints.BOTH;
		gbc_scrollPane.gridx = 0;
		gbc_scrollPane.gridy = 1;
		panelCenterTL.add(scrollPane, gbc_scrollPane);
		
		tableAreas = new JTable(new ExampleModel());
		tableAreas.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		ListSelectionModel selectionModel = tableAreas.getSelectionModel();
		selectionModel.addListSelectionListener(new ListSelectionListener(){

			@Override
			public void valueChanged(ListSelectionEvent arg0) {
				controller.habilitarDisparos();
				controller.actualizarTablaEsquemas();

			}

		});
		scrollPane.setViewportView(tableAreas);
		
		panelCenterTR = new JPanel();
		GridBagConstraints gbc_panelCenterTR = new GridBagConstraints();
		gbc_panelCenterTR.insets = new Insets(5, 5, 5, 5);
		gbc_panelCenterTR.gridx = 1;
		gbc_panelCenterTR.gridy = 0;
		panelCenter.add(panelCenterTR, gbc_panelCenterTR);
		GridBagLayout gbl_panelCenterTR = new GridBagLayout();
		gbl_panelCenterTR.columnWidths = new int[]{63, 0};
		gbl_panelCenterTR.rowHeights = new int[]{23, 0, 0, 0};
		gbl_panelCenterTR.columnWeights = new double[]{0.0, Double.MIN_VALUE};
		gbl_panelCenterTR.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0};
		panelCenterTR.setLayout(gbl_panelCenterTR);
		
		dla1button = new JButton("Nuevo");
		dla1button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.nuevaArea();
			}
		});
		GridBagConstraints gbc_dla1button = new GridBagConstraints();
		gbc_dla1button.fill = GridBagConstraints.HORIZONTAL;
		gbc_dla1button.insets = new Insets(0, 0, 5, 0);
		gbc_dla1button.gridx = 0;
		gbc_dla1button.gridy = 0;
		panelCenterTR.add(dla1button, gbc_dla1button);
		
		dla2button = new JButton("Modificar");
		dla2button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.modificarArea();
			}
		});
		GridBagConstraints gbc_dla2button = new GridBagConstraints();
		gbc_dla2button.fill = GridBagConstraints.HORIZONTAL;
		gbc_dla2button.insets = new Insets(0, 0, 5, 0);
		gbc_dla2button.gridx = 0;
		gbc_dla2button.gridy = 1;
		panelCenterTR.add(dla2button, gbc_dla2button);
		
		dla3button = new JButton("Eliminar");
		dla3button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.eliminarArea();
			}
		});
		GridBagConstraints gbc_dla3button = new GridBagConstraints();
		gbc_dla3button.insets = new Insets(0, 0, 5, 0);
		gbc_dla3button.fill = GridBagConstraints.HORIZONTAL;
		gbc_dla3button.gridx = 0;
		gbc_dla3button.gridy = 2;
		panelCenterTR.add(dla3button, gbc_dla3button);
		
		panelCenterBL = new JPanel();
		GridBagConstraints gbc_panelCenterBL = new GridBagConstraints();
		gbc_panelCenterBL.insets = new Insets(0, 0, 0, 0);
		gbc_panelCenterBL.fill = GridBagConstraints.BOTH;
		gbc_panelCenterBL.gridx = 0;
		gbc_panelCenterBL.gridy = 1;
		panelCenter.add(panelCenterBL, gbc_panelCenterBL);
		GridBagLayout gbl_panelCenterBL = new GridBagLayout();
		gbl_panelCenterBL.columnWidths = new int[]{0, 0};
		gbl_panelCenterBL.rowHeights = new int[]{0, 0, 0};
		gbl_panelCenterBL.columnWeights = new double[]{1.0, Double.MIN_VALUE};
		gbl_panelCenterBL.rowWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
		panelCenterBL.setLayout(gbl_panelCenterBL);
		
		lblEsquemas = new JLabel("Esquemas:");
		GridBagConstraints gbc_lblEsquemas = new GridBagConstraints();
		gbc_lblEsquemas.anchor = GridBagConstraints.WEST;
		gbc_lblEsquemas.insets = new Insets(5, 5, 5, 5);
		gbc_lblEsquemas.gridx = 0;
		gbc_lblEsquemas.gridy = 0;
		panelCenterBL.add(lblEsquemas, gbc_lblEsquemas);
		
		scrollPane_1 = new JScrollPane();
		GridBagConstraints gbc_scrollPane_1 = new GridBagConstraints();
		gbc_scrollPane_1.fill = GridBagConstraints.BOTH;
		gbc_scrollPane_1.gridx = 0;
		gbc_scrollPane_1.gridy = 1;
		panelCenterBL.add(scrollPane_1, gbc_scrollPane_1);
		
		tableEsquemas = new JTable(new ExampleModel());
		tableEsquemas.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		ListSelectionModel selectionModel2 = tableEsquemas.getSelectionModel();
		selectionModel2.addListSelectionListener(new ListSelectionListener(){

			@Override
			public void valueChanged(ListSelectionEvent arg0) {
				controller.habilitarDisparos();

			}

		});
		scrollPane_1.setViewportView(tableEsquemas);
		
		panelCenterBR = new JPanel();
		GridBagConstraints gbc_panelCenterBR = new GridBagConstraints();
		gbc_panelCenterBR.insets = new Insets(5, 5, 5, 5);
		gbc_panelCenterBR.gridx = 1;
		gbc_panelCenterBR.gridy = 1;
		panelCenter.add(panelCenterBR, gbc_panelCenterBR);
		GridBagLayout gbl_panelCenterBR = new GridBagLayout();
		gbl_panelCenterBR.columnWidths = new int[]{0, 0};
		gbl_panelCenterBR.rowHeights = new int[]{0, 0, 0, 0};
		gbl_panelCenterBR.columnWeights = new double[]{0.0, Double.MIN_VALUE};
		gbl_panelCenterBR.rowWeights = new double[]{0.0, 0.0, 0.0, Double.MIN_VALUE};
		panelCenterBR.setLayout(gbl_panelCenterBR);
		
		dle1button = new JButton("Nuevo");
		dle1button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				controller.nuevoEsquema();
			}
		});
		GridBagConstraints gbc_dle1button = new GridBagConstraints();
		gbc_dle1button.fill = GridBagConstraints.HORIZONTAL;
		gbc_dle1button.insets = new Insets(0, 0, 5, 0);
		gbc_dle1button.gridx = 0;
		gbc_dle1button.gridy = 0;
		panelCenterBR.add(dle1button, gbc_dle1button);
		
		dle2button = new JButton("Modificar");
		dle2button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.modificarEsquema();
			}
		});
		GridBagConstraints gbc_dle2button = new GridBagConstraints();
		gbc_dle2button.fill = GridBagConstraints.HORIZONTAL;
		gbc_dle2button.insets = new Insets(0, 0, 5, 0);
		gbc_dle2button.gridx = 0;
		gbc_dle2button.gridy = 1;
		panelCenterBR.add(dle2button, gbc_dle2button);
		
		dle3button = new JButton("Eliminar");
		dle3button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.eliminarEsquema();
			}
		});
		GridBagConstraints gbc_dle3button = new GridBagConstraints();
		gbc_dle3button.fill = GridBagConstraints.HORIZONTAL;
		gbc_dle3button.gridx = 0;
		gbc_dle3button.gridy = 2;
		panelCenterBR.add(dle3button, gbc_dle3button);
		
		controller = LocalizadorAreasEsquemasController.getInstance();
		this.previousWindow = previousWindow;
		controller.inicializar(this);
		
	}

	public JTable getTableAreas() {
		return tableAreas;
	}

	public void setTableAreas(JTable tableAreas) {
		this.tableAreas = tableAreas;
	}

	public JTable getTableEsquemas() {
		return tableEsquemas;
	}

	public void setTableEsquemas(JTable tableEsquemas) {
		this.tableEsquemas = tableEsquemas;
	}

	public JButton getDlae1button() {
		return dlae1button;
	}

	public void setDlae1button(JButton dlae1button) {
		this.dlae1button = dlae1button;
	}

	public JButton getDlae2button() {
		return dlae2button;
	}

	public void setDlae2button(JButton dlae2button) {
		this.dlae2button = dlae2button;
	}

	public JButton getDla1button() {
		return dla1button;
	}

	public void setDla1button(JButton dla1button) {
		this.dla1button = dla1button;
	}

	public JButton getDla2button() {
		return dla2button;
	}

	public void setDla2button(JButton dla2button) {
		this.dla2button = dla2button;
	}

	public JButton getDla3button() {
		return dla3button;
	}

	public void setDla3button(JButton dla3button) {
		this.dla3button = dla3button;
	}

	public JButton getDle1button() {
		return dle1button;
	}

	public void setDle1button(JButton dle1button) {
		this.dle1button = dle1button;
	}

	public JButton getDle2button() {
		return dle2button;
	}

	public void setDle2button(JButton dle2button) {
		this.dle2button = dle2button;
	}

	public JButton getDle3button() {
		return dle3button;
	}

	public void setDle3button(JButton dle3button) {
		this.dle3button = dle3button;
	}

	public JFrame getPreviousWindow() {
		return previousWindow;
	}

	public void setPreviousWindow(JFrame previousWindow) {
		this.previousWindow = previousWindow;
	}

	public LocalizadorAreasEsquemasController getController() {
		return controller;
	}

	public void setController(LocalizadorAreasEsquemasController controller) {
		this.controller = controller;
	}


	
	

}
