package vista;

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import java.awt.GridBagLayout;
import javax.swing.JLabel;
import java.awt.GridBagConstraints;
import java.awt.Insets;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JTextPane;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import modelo.Grupo;

import utils.ManagerGrupos;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class NuevoGrupo extends JDialog {

	private final JPanel contentPanel = new JPanel();
	private JTextField textFieldNombre;
	private JLabel lblDescripcin;
	private EditorGrupos view;
	private JTextArea textAreaDescripcion;


	/**
	 * Create the dialog.
	 */
	public NuevoGrupo() {
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent arg0) {
				cerrarVentana();
			}


		});
		setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
		setTitle("Nuevo grupo");
		setBounds(100, 100, 450, 300);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		GridBagLayout gbl_contentPanel = new GridBagLayout();
		gbl_contentPanel.columnWidths = new int[]{0, 0, 0};
		gbl_contentPanel.rowHeights = new int[]{0, 0, 0, 0};
		gbl_contentPanel.columnWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
		gbl_contentPanel.rowWeights = new double[]{0.0, 0.0, 1.0, Double.MIN_VALUE};
		contentPanel.setLayout(gbl_contentPanel);
		{
			JLabel lblNombre = new JLabel("Nombre:");
			GridBagConstraints gbc_lblNombre = new GridBagConstraints();
			gbc_lblNombre.anchor = GridBagConstraints.EAST;
			gbc_lblNombre.insets = new Insets(5, 5, 5, 5);
			gbc_lblNombre.gridx = 0;
			gbc_lblNombre.gridy = 0;
			contentPanel.add(lblNombre, gbc_lblNombre);
		}
		{
			textFieldNombre = new JTextField();
			GridBagConstraints gbc_textFieldNombre = new GridBagConstraints();
			gbc_textFieldNombre.insets = new Insets(5, 5, 5, 0);
			gbc_textFieldNombre.fill = GridBagConstraints.HORIZONTAL;
			gbc_textFieldNombre.gridx = 1;
			gbc_textFieldNombre.gridy = 0;
			contentPanel.add(textFieldNombre, gbc_textFieldNombre);
			textFieldNombre.setColumns(10);
		}
		{
			lblDescripcin = new JLabel("Descripci\u00F3n:");
			GridBagConstraints gbc_lblDescripcin = new GridBagConstraints();
			gbc_lblDescripcin.insets = new Insets(5, 5, 5, 5);
			gbc_lblDescripcin.gridx = 0;
			gbc_lblDescripcin.gridy = 1;
			contentPanel.add(lblDescripcin, gbc_lblDescripcin);
		}
		{
			JScrollPane scrollPane = new JScrollPane();
			GridBagConstraints gbc_scrollPane = new GridBagConstraints();
			gbc_scrollPane.fill = GridBagConstraints.BOTH;
			gbc_scrollPane.gridwidth = 2;
			gbc_scrollPane.insets = new Insets(5, 5, 5, 5);
			gbc_scrollPane.gridx = 0;
			gbc_scrollPane.gridy = 2;
			contentPanel.add(scrollPane, gbc_scrollPane);
			{
				textAreaDescripcion = new JTextArea();
				textAreaDescripcion.setLineWrap( true );
				textAreaDescripcion.setWrapStyleWord( true );
				textAreaDescripcion.setSize( textAreaDescripcion.getPreferredSize() );
				scrollPane.setViewportView(textAreaDescripcion);
				lblDescripcin.setLabelFor(textAreaDescripcion);
			}
		}
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						cerrarVentana();
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent arg0) {
						// Cerrar ventana
						view.setEnabled(true);
						dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}

	public void cerrarVentana() {
		if(comprobarCampos()){
			
			// Nuevo grupo
			Grupo nuevoGrupo = new Grupo();
			
			// Campos
			
			String nombre = this.textFieldNombre.getText();
			String descripcion = this.textAreaDescripcion.getText();
			
			// Asignar valores
			
			nuevoGrupo.setDescripcion(descripcion);
			nuevoGrupo.setNombre(nombre);
			
			// Insertar usuario
			
			ManagerGrupos manager = ManagerGrupos.getInstance();
			manager.insertarGrupo(nuevoGrupo);
			
			// Cerrar la ventana
			view.setEnabled(true);
			dispose();
			view.getController().actualizarTabla();
		}

	}


	public void setView(EditorGrupos view) {
		this.view = view;
	}

	public boolean comprobarCampos(){
		ManagerGrupos manager = ManagerGrupos.getInstance();
		String nombreNuevo = this.textFieldNombre.getText();

		if(nombreNuevo.trim().equals("")){
			JOptionPane.showMessageDialog(view,
					"El campo de nombre de grupo no puede estar vaco.",
					"Error",
					JOptionPane.ERROR_MESSAGE);
			return false;
		}
		else if(manager.existeNombreGrupo(nombreNuevo)){
			JOptionPane.showMessageDialog(view,
					"Ya existe un grupo con el mismo nombre.",
					"Error",
					JOptionPane.ERROR_MESSAGE);
			return false;
		}
		else
			return true;
	}



}
