package vista;

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import java.awt.GridBagLayout;
import javax.swing.JLabel;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import javax.swing.JTextField;
import javax.swing.JComboBox;

import modelo.Usuario;

import utils.ManagerUsuarios;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

public class NuevoUsuario extends JDialog {

	private final JPanel contentPanel = new JPanel();
	private JTextField textFieldNombreReal;
	private JTextField textFieldNombreUsuario;
	private JTextField textFieldMail;
	private GestionUsuarios view;
	private JComboBox comboBoxTipo;

	/**
	 * Launch the application.
	 */
	//	public static void main(String[] args) {
	//		try {
	//			NuevoUsuario dialog = new NuevoUsuario();
	//			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
	//			dialog.setVisible(true);
	//		} catch (Exception e) {
	//			e.printStackTrace();
	//		}
	//	}

	/**
	 * Create the dialog.
	 */
	public NuevoUsuario() {
		setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent arg0) {
				cerrarVentana();
			}
		});
		setTitle("Nuevo usuario");
		setBounds(100, 100, 450, 238);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		GridBagLayout gbl_contentPanel = new GridBagLayout();
		gbl_contentPanel.columnWidths = new int[]{0, 0, 0};
		gbl_contentPanel.rowHeights = new int[]{0, 0, 0, 0, 0, 0};
		gbl_contentPanel.columnWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
		gbl_contentPanel.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		contentPanel.setLayout(gbl_contentPanel);
		{
			JLabel lblNombreReal = new JLabel("Nombre real: ");
			GridBagConstraints gbc_lblNombreReal = new GridBagConstraints();
			gbc_lblNombreReal.anchor = GridBagConstraints.EAST;
			gbc_lblNombreReal.insets = new Insets(5, 5, 5, 5);
			gbc_lblNombreReal.gridx = 0;
			gbc_lblNombreReal.gridy = 0;
			contentPanel.add(lblNombreReal, gbc_lblNombreReal);
		}
		{
			textFieldNombreReal = new JTextField();
			GridBagConstraints gbc_textFieldNombreReal = new GridBagConstraints();
			gbc_textFieldNombreReal.insets = new Insets(5, 5, 5, 5);
			gbc_textFieldNombreReal.fill = GridBagConstraints.HORIZONTAL;
			gbc_textFieldNombreReal.gridx = 1;
			gbc_textFieldNombreReal.gridy = 0;
			contentPanel.add(textFieldNombreReal, gbc_textFieldNombreReal);
			textFieldNombreReal.setColumns(10);
		}
		{
			JLabel lblNombeDeUsuario = new JLabel("Nombe de usuario: ");
			GridBagConstraints gbc_lblNombeDeUsuario = new GridBagConstraints();
			gbc_lblNombeDeUsuario.anchor = GridBagConstraints.EAST;
			gbc_lblNombeDeUsuario.insets = new Insets(5, 5, 5, 5);
			gbc_lblNombeDeUsuario.gridx = 0;
			gbc_lblNombeDeUsuario.gridy = 1;
			contentPanel.add(lblNombeDeUsuario, gbc_lblNombeDeUsuario);
		}
		{
			textFieldNombreUsuario = new JTextField();
			GridBagConstraints gbc_textFieldNombreUsuario = new GridBagConstraints();
			gbc_textFieldNombreUsuario.insets = new Insets(5, 5, 5, 5);
			gbc_textFieldNombreUsuario.fill = GridBagConstraints.HORIZONTAL;
			gbc_textFieldNombreUsuario.gridx = 1;
			gbc_textFieldNombreUsuario.gridy = 1;
			contentPanel.add(textFieldNombreUsuario, gbc_textFieldNombreUsuario);
			textFieldNombreUsuario.setColumns(10);
		}
		{
			JLabel lblCorreoElectrnico = new JLabel("Correo electr\u00F3nico:");
			GridBagConstraints gbc_lblCorreoElectrnico = new GridBagConstraints();
			gbc_lblCorreoElectrnico.anchor = GridBagConstraints.EAST;
			gbc_lblCorreoElectrnico.insets = new Insets(5, 5, 5, 5);
			gbc_lblCorreoElectrnico.gridx = 0;
			gbc_lblCorreoElectrnico.gridy = 2;
			contentPanel.add(lblCorreoElectrnico, gbc_lblCorreoElectrnico);
		}
		{
			textFieldMail = new JTextField();
			GridBagConstraints gbc_textFieldMail = new GridBagConstraints();
			gbc_textFieldMail.insets = new Insets(5, 5, 5, 5);
			gbc_textFieldMail.fill = GridBagConstraints.HORIZONTAL;
			gbc_textFieldMail.gridx = 1;
			gbc_textFieldMail.gridy = 2;
			contentPanel.add(textFieldMail, gbc_textFieldMail);
			textFieldMail.setColumns(10);
		}
		{
			JLabel lblTipo = new JLabel("Tipo:");
			GridBagConstraints gbc_lblTipo = new GridBagConstraints();
			gbc_lblTipo.anchor = GridBagConstraints.EAST;
			gbc_lblTipo.insets = new Insets(5, 5, 5, 5);
			gbc_lblTipo.gridx = 0;
			gbc_lblTipo.gridy = 3;
			contentPanel.add(lblTipo, gbc_lblTipo);
		}
		{
			String [] opciones = {"NORMAL", "ADMINISTRADOR"};
			comboBoxTipo = new JComboBox(opciones);
			GridBagConstraints gbc_comboBoxTipo = new GridBagConstraints();
			gbc_comboBoxTipo.insets = new Insets(5, 5, 5, 5);
			gbc_comboBoxTipo.fill = GridBagConstraints.HORIZONTAL;
			gbc_comboBoxTipo.gridx = 1;
			gbc_comboBoxTipo.gridy = 3;
			contentPanel.add(comboBoxTipo, gbc_comboBoxTipo);
		}
		{
			JLabel lblInfo = new JLabel("Importante: no ser\u00E1 posible modificar el nombre de usuario posteriormente.");
			GridBagConstraints gbc_lblInfo = new GridBagConstraints();
			gbc_lblInfo.anchor = GridBagConstraints.WEST;
			gbc_lblInfo.gridwidth = 2;
			gbc_lblInfo.insets = new Insets(5, 5, 5, 5);
			gbc_lblInfo.gridx = 0;
			gbc_lblInfo.gridy = 4;
			contentPanel.add(lblInfo, gbc_lblInfo);
		}
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent arg0) {
						cerrarVentana();
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton btnCancelar = new JButton("Cancelar");
				btnCancelar.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						// Cerrar ventana
						view.setEnabled(true);
						dispose();
					}
				});
				buttonPane.add(btnCancelar);
			}
		}
	}

	public void setPreviousWindow(GestionUsuarios view) {
		this.view = view;
	}

	public void cerrarVentana(){
		if(comprobarCampos()){
			// Nuevo usuario
			Usuario usuario = new Usuario();
			usuario.setCorreoElectronico(textFieldMail.getText());
			usuario.setNombreReal(textFieldNombreReal.getText());
			usuario.setNombreUsuario(textFieldNombreUsuario.getText());
			switch(comboBoxTipo.getSelectedIndex()){
			case 1: // Administrador
				usuario.setTipo(Usuario.TIPO_ADMINISTRADOR);
				break;
			default:
				usuario.setTipo(Usuario.TIPO_NORMAL);
			}

			// Insertar usuario
			ManagerUsuarios manager = ManagerUsuarios.getInstance();
			manager.insertarUsuario(usuario);

			// Cerrar ventana
			view.setEnabled(true);
			dispose();
			view.getController().actualizarTabla();
		}
	}

	public boolean comprobarCampos(){
		ManagerUsuarios manager = ManagerUsuarios.getInstance();
		String nombreNuevo = textFieldNombreUsuario.getText();

		if(nombreNuevo.trim().equals("")){
			JOptionPane.showMessageDialog(view,
					"El campo de nombre de usuario no puede estar vaco.",
					"Error",
					JOptionPane.ERROR_MESSAGE);
			return false;
		}
		else if(manager.existeNombreUsuario(nombreNuevo)){
			JOptionPane.showMessageDialog(view,
					"Ya existe un usuario con el mismo nombre de usuario.",
					"Error",
					JOptionPane.ERROR_MESSAGE);
			return false;
		}
		else if(nombreNuevo.contains(" ")){
			JOptionPane.showMessageDialog(view,
					"El nombre de usuario no debe tener espacios.",
					"Error",
					JOptionPane.ERROR_MESSAGE);
			return false;
		}
		else
			return true;
	}

}
